.. Copyright (C) Internet Systems Consortium, Inc. ("ISC")
..
.. SPDX-License-Identifier: MPL-2.0
..
.. This Source Code Form is subject to the terms of the Mozilla Public
.. License, v. 2.0.  If a copy of the MPL was not distributed with this
.. file, you can obtain one at https://mozilla.org/MPL/2.0/.
..
.. See the COPYRIGHT file distributed with this work for additional
.. information regarding copyright ownership.

Changes prior to 9.20.1
-----------------------

.. code-block:: none

		--- 9.20.0 released ---

	6404.	[placeholder]

	6403.	[security]	qctx-zversion was not being cleared when it should have
				been leading to an assertion failure if it needed to be
				reused. (CVE-2024-4076) [GL #4507]

	6402.	[security]	A malicious DNS client that sends many queries with a
				SIG(0)-signed message can cause the server to respond
				slowly or not respond at all to other clients. Use the
				offload threadpool for SIG(0) signature verifications,
				add the 'sig0checks-quota' configuration option to
				introduce a quota for SIG(0)-signed queries running in
				parallel and add the 'sig0checks-quota-exempt' option to
				exempt certain clients by their IP/network addresses.
				(CVE-2024-1975) [GL #4480]

	6401.	[security]	An excessively large number of rrtypes per owner can
				slow down database query processing, so a limit has been
				placed on the number of rrtypes that can be stored per
				owner (node) in a cache or zone database. This is
				configured with the new "max-rrtypes-per-name" option,
				and defaults to 100. (CVE-2024-1737)
				[GL #3403] [GL #4548]

	6400.	[security]	Excessively large rdatasets can slow down database
				query processing, so a limit has been placed on the
				number of records that can be stored per rdataset
				in a cache or zone database. This is configured
				with the new "max-records-per-type" option, and
				defaults to 100. (CVE-2024-1737)
				[GL #497] [GL #3405]

	6399.	[security]	Malicious DNS client that sends many queries over
				TCP but never reads responses can cause server to
				respond slowly or not respond at all for other
				clients. (CVE-2024-0760) [GL #4481]

	6398.	[bug]		Fix potential data races in our DoH implementation
				related to HTTP/2 session object management and
				endpoints set object management after reconfiguration.
				We would like to thank Dzintars and Ivo from nic.lv
				for bringing this to our attention. [GL #4473]

	6397.	[placeholder]

	6396.	[func]		Outgoing zone transfers are no longer enabled by
				default. To enable them, an "allow-transfer" ACL
				must be specified. [GL #4728]

	6395.	[bug]		Handle ISC_R_HOSTDOWN and ISC_R_NETDOWN in resolver.c.
				[GL #4736]

	6394.	[bug]		Named's -4 and -6 options now apply to zone primaries,
				also-notify and parental-agents.  Report when a zone
				has these options configured but does not have an IPv4
				or IPv6 address listed respectively. [GL #3472]

	6393.	[func]		Deal with uv_tcp_close_reset() error return codes
				more gracefully. [GL #4708]

	6392.	[bug]		Use a completely new memory context when flushing the
				cache. [GL #2744]

	6391.	[placeholder]

	6390.	[placeholder]

	6389.	[bug]		dnssec-verify and dnssec-signzone could fail if there
				was an obscured DNSKEY RRset at a delegatation.
				[GL #4517]

	6388.	[placeholder]

	6387.	[func]		Added a new statistics variable "recursive high-water"
				that reports the maximum number of simultaneous
				recursive clients BIND has handled while running.
				[GL #4668]

	6386.	[bug]		When shutting down catzs->view could point to freed
				memory. Obtain a reference to the view to prevent this.
				[GL #4502]

	6385.	[func]		Relax SVCB alias mode checks to allow parameters.
				[GL #4704]

	6384.	[bug]		Remove infinite loop when including a directory in a
				zone file. [GL #4357]

	6383.	[bug]		Address an infinite loop in $GENERATE when a negative
				value was converted in nibble mode. [GL #4353]

	6382.	[bug]		Fix RPZ response's SOA record TTL, which was incorrectly
				set to 1 if 'add-soa' is used. [GL #3323]

.. code-block:: none

		--- 9.19.24 released ---

	6381.	[bug]		dns_qp_lookup() could position the iterator at the
				wrong predecessor when searching for names with
				uncommon characters, which are encoded as two-octet
				sequences in QP trie keys. [GL #4702]

	6380.	[func]		Queries and responses now emit distinct dnstap entries
				for DoT and DoH. [GL #4523]

	6379.	[bug]		A QP iterator bug could result in DNSSEC validation
				failing because the wrong NSEC was returned. [GL #4659]

	6378.	[func]		The option to specify the number of UDP dispatches was
				previously removed. An attempt to use the option now
				prints a warning. [GL #1879]

	6377.	[func]		Introduce 'dnssec-ksr', a DNSSEC tool to create
				Key Signing Requests (KSRs) and Signed Key Responses
				(SKRs). [GL #1128]

	6376.	[func]		Allow 'dnssec-keygen' options '-f' and '-k' to be used
				together to create a subset of keys from the DNSSEC
				policy. [GL !8188]

	6375.	[func]		Allow multiple RNDC message to be processed from
				a single TCP read. [GL #4416]

	6374.	[func]		Don't count expired / future RRSIGs in verification
				failure quota. [GL #4586]

	6373.	[func]		Offload the isc_http response processing to worker
				thread. [GL #4680]

	6372.	[func]		Implement signature jitter for dnssec-policy. [GL #4554]

	6371.	[bug]		Access to the trust bytes in the ncache data needed to
				be made thread safe. [GL #4475]

	6370.	[bug]		Wrong source address used for IPv6 notify messages.
				[GL #4669]

.. code-block:: none

		--- 9.19.23 released ---

	6369.	[func]		The 'fixed' value for the 'rrset-order' option has
				been marked and documented as deprecated. [GL #4446]

	6368.	[func]		The 'sortlist' option has been marked and documented
				as deprecated. [GL #4593]

	6367.	[bug]		Since the dns_validator_destroy() function doesn't
				guarantee that it destroys the validator, rename it to
				dns_validator_shutdown() and require explicit
				dns_validator_detach() to follow. Implement an expected
				behavior of the function to release a name associated
				with the validator. [GL #4654]

	6366.	[bug]		An assertion could be triggered in the QPDB cache when
				encountering a delegation below a DNAME. [GL #4652]

	6365.	[placeholder]

	6364.	[protocol]	Add RESOLVER.ARPA to the built in empty zones.
				[GL #4580]

	6363.	[bug]		dig/mdig +ednsflags=<non-zero-value> did not re-enable
				EDNS if it had been disabled. [GL #4641]

	6362.	[bug]		Reduce memory consumption of QP-trie based databases
				by dynamically allocating the nodenames. [GL #4614]

	6361.	[bug]		Some invalid ISO 8601 durations were accepted
				erroneously. [GL #4624]

	6360.	[bug]		Don't return static-stub synthesised NS RRset.
				[GL #4608]

	6359.	[bug]		Fix bug in Depends (keymgr_dep) function. [GL #4552]

.. code-block:: none

		--- 9.19.22 released ---

	6358.	[bug]		Fix validate_dnskey_dsset when KSK is not signing,
				do not skip remainder of DS RRset. [GL #4625]

	6357.	[func]		The QP zone database implementation introduced in
				change #6355 has now been replaced with a version
				based on the multithreaded dns_qpmulti API, which
				is based on RCU and reduces the need for locking.
				The new implementation is called "qpzone". The
				previous "qp" implementation has been renamed
				"qpcache", and can only be used for the cache.
				[GL #4348]

	6356.	[bug]		Attach the loop also in the dns_cache_flush(), so
				the cache pruning still works after the flush.
				[GL #4621]

	6355.	[func]		The red-black tree data structure underlying the
				RBTDB has been replaced with QP-tries.  This is
				expected to improve scalability and reduce
				CPU consumption under load. It is currently known to
				have higher memory consumption than the traditional
				RBTDB; this will be addressed in future releases.

				Nodes in a QP-trie contain the full domain name,
				while nodes in a red-black tree only contain names
				relative to a parent.  Because of this difference,
				zone files dumped with masterfile-style "relative"
				will no longer have multiple different $ORIGIN
				statements throughout the file.

				This version is a minimal adaptation, keeping RBTDB
				code largely unchanged, except as needed to replace
				the underlying data structure. It uses the
				single-thread "dns_qp" interface with locks for
				synchronization. A future version will use the
				multithreaded "dns_qpmulti" interface instead,
				and will be renamed to QPDB.

				The RBT-based version of RBTDB is still in place
				for now, and can be used by specifying "database rbt"
				in a "zone" statement, or by compiling with
				"configure --with-zonedb=rbt --with-cachedb=rbt".
				[GL #4411]

	6354.	[bug]		Change 6035 introduced a regression when chasing DS
				records resulting in an assertion failure. [GL #4612]

	6353.	[bug]		Improve the TTL-based cleaning by removing the expired
				headers from the heap, so they don't block the next
				cleaning round and clean more than a single item for
				each new addition to the RBTDB. [GL #4591]

	6352.	[bug]		Revert change 6319 and decrease lock contention during
				RBTDB tree pruning by not cleaning up nodes recursively
				within a single prune_tree() call. [GL #4596]

	6351.	[protocol]	Support for the RESINFO record type has been added.
				[GL #4413]

	6350.	[bug]		Address use after free in expire_lru_headers. [GL #4495]

	6349.	[placeholder]

	6348.	[bug]		BIND could previously abort when trying to
				establish a connection to a remote server using an
				incorrect 'tls' configuration. That has been
				fixed. Thanks to Tobias Wolter for bringing
				the issue to our attention. [GL #4572]

	6347.	[func]		Disallow stale-answer-client-timeout non-zero values.
				[GL #4447]

	6346.	[bug]		Cleaned up several minor bugs in the RBTDB dbiterator
				implementation. [GL !8741]

	6345.	[bug]		Added missing dns_rdataset_disassociate calls in
				validator.c:findnsec3proofs. [GL #4571]

	6344.	[bug]		Fix case insensitive setting for isc_ht hashtable.
				[GL #4568]

	6343.	[bug]		Fix case insensitive setting for isc_ht hashtable.
				[GL #4568]

	6342.	[placeholder]

	6341.	[bug]		Address use after free in ccmsg_senddone. [GL #4549]

	6340.	[test]		Fix incorrectly reported errors when running tests
				with `make test` on platforms with older pytest.
				[GL #4560]

	6339.	[bug]		The alignas() can't be used on types larger than
				max_align_t; instead add padding into the structures
				where we want avoid false memory sharing. [GL #4187]

	6338.	[func]		Optimize slabheader placement, so the infrastructure
				records are put in the beginning of the slabheader
				linked list. [GL !8675]

	6337.	[bug]		Nsupdate could assert while shutting down. [GL #4529]

	6336.	[func]		Expose the zones with the 'first refresh' flag set in
				statistics channel's "Incoming Zone Transfers" section
				to indicate the zones that are not yet fully ready, and
				their first refresh is pending or is in-progress. Also
				expose the number of such zones in the output of the
				'rndc status' command. [GL #4241]

	6335.	[func]		The 'dnssec-validation yes' option now requires an
				explicitly configured 'trust-anchors' statement (or
				'managed-keys' or 'trusted-keys' statements, both
				deprecated). [GL #4373]

	6334.	[doc]		Improve ARM parental-agents definition. [GL #4531]

	6333.	[bug]		Fix the DNS_GETDB_STALEFIRST flag, which was defined
				incorrectly in lib/ns/query.c. [GL !8683]

	6332.	[bug]		Range-check the arguments to fetch-quota-param.
				[GL #362]

	6331.	[func]		Add HSM support for dnssec-policy. You can now
				configure keys with a key-store that allows you to
				set the directory to store key files and to set a
				PKCS #11 URI string. [GL #1129]

	6330.	[doc]		Update ZSK minimum lifetime documentation in ARM, also
				depends on signing delay. [GL #4510]

	6329.	[func]		Nsupdate can now set the UL EDNS option when sending
				UPDATE requests. [GL #4419]

	6328.	[func]		Add workaround to enforce dynamic linker to pull
				jemalloc earlier than libc to ensure all memory
				allocations are done via jemalloc. [GL #4404]

	6327.	[func]		Expose the TCP client count in statistics channel.
				[GL #4425]

	6326.	[bug]		Changes to "listen-on" statements were ignored on
				reconfiguration unless the port or interface address was
				changed, making it impossible to change a related
				listener transport type. Thanks to Thomas Amgarten.
				[GL #4518] [GL #4528]

	6325.	[func]		The 'tls' block was extended with a new
				'cipher-suites' option that allows setting
				allowed cipher suites for TLSv1.3.
				[GL #3504]

	6324.	[bug]		Fix a possible crash in 'dig +nssearch +nofail' and
				'host -C' commands when one of the name servers returns
				SERVFAIL. [GL #4508]

.. code-block:: none

		--- 9.19.21 released ---

	6323.	[placeholder]

	6322.	[security]	Specific DNS answers could cause a denial-of-service
				condition due to DNS validation taking a long time.
				(CVE-2023-50387) [GL #4424]

				The same code change also addresses another problem:
				preparing NSEC3 closest encloser proofs could exhaust
				available CPU resources. (CVE-2023-50868) [GL #4459]

	6321.	[security]	Change 6315 inadvertently introduced regressions that
				could cause named to crash. [GL #4234]

	6320.	[placeholder]

.. code-block:: none

		--- 9.19.20 released ---

	6319.	[func]		Limit isc_async_run() overhead for RBTDB tree pruning.
				[GL #4383]

	6318.	[placeholder]

	6317.	[security]	Restore DNS64 state when handling a serve-stale timeout.
				(CVE-2023-5679) [GL #4334]

	6316.	[security]	Specific queries could trigger an assertion check with
				nxdomain-redirect enabled. (CVE-2023-5517) [GL #4281]

	6315.	[security]	Speed up parsing of DNS messages with many different
				names. (CVE-2023-4408) [GL #4234]

	6314.	[bug]		Address race conditions in dns_tsigkey_find().
				[GL #4182]

	6313.	[bug]		When dnssec-policy is in effect the DNSKEY's TTLs in
				the zone where not being updated to match the policy.
				This lead to failures when DNSKEYs where updated as the
				TTLs mismatched. [GL #4466]

	6312.	[bug]		Conversion from NSEC3 signed to NSEC signed could
				temporarily put the zone into a state where it was
				treated as unsigned until the NSEC chain was built.
				Additionally conversion from one set of NSEC3 parameters
				to another could also temporarily put the zone into a
				state where it was treated as unsigned until the new
				NSEC3 chain was built. [GL #1794] [GL #4495]

	6311.	[func]		Zone content checks are now disabled by default
				when running named-compilezone. named-checkzone
				can still be used for checking zone integrity,
				or the former checks in named-compilezone can be
				re-enabled by using "named-compilezone -i full
				-k fail -n fail -r warn -m warn -M warn -S warn
				-T warn -W warn -C check-svcb:fail". [GL #4364]

	6310.	[bug]		Memory leak in zone.c:sign_zone. When named signed a
				zone it could leak dst_keys due to a misplaced
				'continue'. [GL #4488]

	6309.	[bug]		Changing a zone's primaries while a refresh was in
				progress could trigger an assertion. [GL #4310]

	6308.	[bug]		Prevent crashes caused by the zone journal getting
				destroyed before all changes from an incoming IXFR are
				written to it. [GL #4496]

	6307.	[bug]		Obtain a client->handle reference when calling
				async_restart. [GL #4439]

	6306.	[func]		Log more details about the cause of "not exact" errors.
				[GL #4500]

	6305.	[placeholder]

	6304.	[bug]		The wrong time was being used to determine what RRSIGs
				where to be generated when dnssec-policy was in use.
				[GL #4494]

	6303.	[bug]		Dig failed to correctly process a SIGINT received while
				waiting for a TCP connection to complete. [GL #4138]

	6302.	[func]		The "trust-anchor-telemetry" statement is no longer
				marked as experimental. This silences a relevant log
				message that was emitted even when the feature was
				explicitly disabled. [GL #4497]

	6301.	[bug]		Fix data races with atomic members of the xfrin
				structure in xfrin_start() and xfrin_send_request()
				functions. [GL #4493]

	6300.	[bug]		Fix statistics export to use full 64 bit signed numbers
				instead of truncating values to unsigned 32 bits.
				[GL #4467]

	6299.	[port]		NetBSD has added 'hmac' to libc which collides with our
				use of 'hmac'. [GL #4478]

	6298.	[bug]		Fix dns_qp_lookup bugs related to the iterator.
				[GL !8558]

.. code-block:: none

		--- 9.19.19 released ---

	6297.	[bug]		Improve LRU cleaning behaviour. [GL #4448]

	6296.	[func]		The "resolver-nonbackoff-tries" and
				"resolver-retry-interval" options have been removed;
				Using them is now a fatal error. [GL #4405]

	6295.	[bug]		Fix an assertion failure which could occur during
				shutdown when DNSSEC validation was running. [GL #4462]

	6294.	[bug]		BIND might sometimes crash after startup or
				re-configuration when one 'tls' entry is used multiple
				times to connect to remote servers due to initialisation
				attempts from contexts of multiple threads. That has
				been fixed. [GL #4464]

	6293.	[func]		Initial support for accepting the PROXYv2 protocol in
				all currently implemented DNS transports in BIND and
				complementary support for sending it in dig are included
				into this release. [GL #4388]

	6292.	[func]		Lower the maximum number of allowed NSEC3 iterations,
				from 150 to 50. DNSSEC responses with a higher
				iteration count are treated as insecure. For signing
				with dnssec-policy, iterations must be set to zero.
				[GL #4363]

	6291.	[bug]		SIGTERM failed to properly stop multiple outstanding
				lookup in dig. [GL #4457]

	6290.	[bug]		Dig +yaml will now report "no servers could be reached"
				also for UDP setup failure when no other servers or
				tries are left. [GL #1229]

	6289.	[test]		Remove legacy system test runner in favor of pytest.
				[GL #4251]

	6288.	[func]		Refactor the isc_mem overmem handling to always use
				isc_mem_isovermem and remove the water callback.
				[GL #4451]

	6287.	[bug]		Recognize escapes when reading the public key from file.
				[GL !8502]

	6286.	[bug]		Dig +yaml will now report "no servers could be reached"
				on TCP connection failure as well as for UDP timeouts.
				[GL #4396]

	6285.	[func]		Remove AES-based DNS cookies. [GL #4421]

	6284.	[bug]		Fix a catz db update notification callback registration
				logic error, which could cause an assertion failure when
				receiving an AXFR update for a catalog zone while the
				previous update process of the catalog zone was already
				running. [GL #4418]

	6283.	[bug]		Fix a data race in isc_hashmap by using atomics for the
				iterators number. [GL !8474]

	6282.	[func]		Deprecate AES-based DNS cookies. [GL #4421]

	6281.	[bug]		Fix a data race in dns_tsigkeyring_dump(). [GL #4328]

.. code-block:: none

		--- 9.19.18 released ---

	6280.	[bug]		Fix missing newlines in the output of "rndc nta -dump".
				[GL !8454]

	6279.	[func]		Use QNAME minimization when fetching nameserver
				addresses. [GL #4209]

	6278.	[bug]		The call to isc_mem_setwater() was incorrectly
				removed from dns_cache_setcachesize(), causing
				cache overmem conditions not to be detected. [GL #4340]

	6277.	[bug]		Take into account local authoritative zones when
				falling back to serve-stale. [GL #4355]

	6276.	[cleanup]	Remove both lock-file configuration option and the
				-X argument to named. [GL #4391]

	6275.	[bug]		Fix assertion failure when using lock-file configuration
				option together -X argument to named. [GL #4386]

	6274.	[bug]		The 'lock-file' file was being removed when it
				shouldn't have been making it ineffective if named was
				started 3 or more times. [GL #4387]

	6273.	[bug]		Don't reuse the existing TCP streams in dns_xfrin, so
				parallel TCP transfers works again. [GL #4379]

	6272.	[func]		Enable systemd units support with the 'notify-reload'
				service type by settng the MONOTONIC_USEC field when
				sending an sd_notify() message to the service manager
				to notify it about reloading the service. Note that the
				'NotifyAccess=all' option is required in the systemd
				unit file's '[Service]' section. [GL #4377]

	6271.	[bug]		Fix a shutdown race in dns__catz_update_cb(). [GL #4381]

	6270.	[bug]		Handle an assertion when the primary server returned
				NOTIMP to IXFR or FORMERR to EDNS to SOA/IXFR/AXFR
				request when transfering a zone. [GL #4372]

	6269.	[maint]		B.ROOT-SERVERS.NET addresses are now 170.247.170.2 and
				2801:1b8:10::b. [GL #4101]

	6268.	[func]		Offload the IXFR and AXFR processing to unblock
				the networking threads. [GL #4367]

	6267.	[func]		The timeouts for resending zone refresh queries over UDP
				were lowered to enable named to more quickly determine
				that a primary is down. [GL #4260]

	6266.	[func]		The zone option 'inline-signing' is ignored from now
				on iff there is no 'dnssec-policy' configured for the
				corresponding zone. [GL #4349]

	6265.	[bug]		Don't schedule resign operations on the raw version
				of an inline-signing zone. [GL #4350]

	6264.	[func]		Use atomics to handle some ADB entry members
				to reduce ADB locking contention. [GL #4326]

	6263.	[func]		Convert the RPZ summary database to use a QP trie
				instead of an RBT. [GL !8352]

	6262.	[bug]		Duplicate control sockets didn't generate a
				configuration failure leading to hard to diagnose
				rndc connection errors.  These are now caught by
				named-checkconf and named. [GL #4253]

	6261.	[bug]		Fix a possible assertion failure on an error path in
				resolver.c:fctx_query(), when using an uninitialized
				link. [GL #4331]

	6260.	[func]		Added options to the QP trie that will be needed
				when it is used as a zone or cache database: backward
				iteration, and retrieval of DNSSEC predecessor
				nodes and node chains. [GL !8338]

	6259.	[placeholder]

	6258.	[func]		Use explictly created external memory pools for
				dns_message in the ns_client and dns_resolver.
				[GL #4325]

	6257.	[func]		Expose the "Refresh SOA" query state (before the XFR)
				in the incoming zone transfers section of the
				statistics channel and show the local and remote
				addresses for that query. Also Improve the
				"Duration (s)" field to show the duration of the
				"Pending" and "Refresh SOA" states too, before the
				actual transfer starts. [GL !8305]

	6256.	[func]		Expose the SOA query transport type (used before/during
				XFR) in the incoming zone transfers section of the
				statistics channel. [GL !8240]

	6255.	[func]		Expose data about incoming zone transfers in progress
				using statistics channel. [GL #3883]

	6254.	[cleanup]	Add semantic patch to do an explicit cast from char
				to unsigned char in ctype.h class of functions.
				[GL #4327]

	6253.	[cleanup]	Remove the support for control channel over Unix
				Domain Sockets. [GL #4311]

	6252.	[test]		Python system tests have to be executed by invoking
				pytest directly. Executing them with the legacy test
				runner is no longer supported. [GL #4250]

	6251.	[bug]		Interating a hashmap could return the same element
				twice. [GL #3422]

	6250.	[bug]		The wrong covered value was being set by
				dns_ncache_current for RRSIG records in the returned
				rdataset structure. This resulted in TYPE0 being
				reported as the covered value of the RRSIG when dumping
				the cache contents. [GL #4314]

	6249.	[cleanup]	Reduce the number of reserved UDP dispatches
				to the number of loops, replace the round-robin
				mechanism in dns_dispatchset_t with dispatches
				pinned to loops, and use lock-free hash tables
				for looking up query IDs and active TCP
				connections. [GL !8304]

	6248.	[func]		Add an option "resolver-use-dns64", which enables
				application of DNS64 rules to server addresses
				when sending recursive queries. This allows
				resolution to be performed via NAT64. [GL #608]

	6247.	[func]		Implement incremental hashing in both isc_siphash
				and isc_hash units. [GL #4306]

.. code-block:: none

		--- 9.19.17 released ---

	6246.	[placeholder]

	6245.	[security]	Limit the amount of recursion that can be performed
				by isccc_cc_fromwire. (CVE-2023-3341) [GL #4152]

	6244.	[bug]		Adjust log levels on malformed messages to NOTICE when
				transferring in a zone. [GL #4290]

	6243.	[bug]		Restore the call order of dns_validator_destroy and
				fetchctx_detach to prevent use after free. [GL #4214]

	6242.	[func]		Ignore jemalloc versions before 4.0.0 as we now
				need explicit memory arenas and tcache support.
				[GL #4296]

	6241.	[placeholder]

	6240.	[bug]		Use dedicated per-worker thread jemalloc memory
				arenas for send buffers allocation to reduce memory
				consumption and avoid lock contention. [GL #4038]

	6239.	[func]		Deprecate the 'dnssec-must-be-secure' option.
				[GL #3700]

	6238.	[cleanup]	Refactor several objects relying on dns_rbt trees
				to instead of dns_nametree, a wrapper around dns_qp.
				[GL !8213]

	6237.	[bug]		Address memory leaks due to not clearing OpenSSL error
				stack. [GL #4159]

	6236.	[func]		Add isc_mem_cget() and isc_mem_cput() calloc-like
				functions that take nmemb and size, do checked
				multiplication and zero the memory before returning
				it to the user.  Replace isc_mem_getx(..., ISC_MEM_ZERO)
				with isc_mem_cget(...) usage. [GL !8237]

	6235.	[doc]		Clarify BIND 9 time formats. [GL #4266]

	6234.	[bug]		Restore stale-refresh-time value after flushing the
				cache. [GL #4278]

	6233.	[func]		Extend client side support for the EDNS EXPIRE option
				to IXFR and AXFR query types. [GL #4170]

	6232.	[bug]		Following the introduction of krb5-subdomain-self-rhs
				and ms-subdomain-self-rhs update rules, removal of
				nonexistent PTR and SRV records via UPDATE could fail.
				[GL #4280]

	6231.	[func]		Make nsupdate honor -v for SOA requests only if the
				server is specified. [GL #1181]

	6230.	[bug]		Prevent an unnecessary query restart if a synthesized
				CNAME target points to the CNAME owner. [GL #3835]

	6229.	[func]		Add basic USDT framework for adding static
				tracing points. [GL #4041]

	6228.	[func]		Limit the number of inactive network manager handles
				and uvreq objects that we keep around for reusing
				later. [GL #4265]

	6227.	[bug]		Check the statistics-channel HTTP Content-length
				to prevent negative or overflowing values from
				causing a crash. [GL #4125]

	6226.	[bug]		Attach dispatchmgr in the dns_view object to prevent
				use-after-free when shutting down. [GL #4228]

	6225.	[func]		Convert dns_nta, dns_forward and dns_keytable units
				to use QP trie instead of an RBT. [GL !7811]

	6224.	[bug]		Check the If-Modified-Since value length to prevent
				out-of-bounds write. [GL #4124]

	6223.	[func]		Make -E engine option for OpenSSL Engine API use only.
				OpenSSL Provider API will now require engine to not be
				set. [GL #8153]

	6222.	[func]		Fixes to provider/engine based ECDSA key handling.
				[GL !8152]

.. code-block:: none

		--- 9.19.16 released ---

	6221.	[cleanup]	Refactor dns_rdataset internals, move rdatasetheader
				declarations out of rbtdb.c so they can be used by other
				databases in the future, and split the zone and cache
				functions from rbtdb.c into separate modules. [GL !7873]

	6220.	[func]		Deprecate the 'dialup' and 'heartbeat-interval'
				options. [GL #3700]

	6219.	[bug]		Ignore 'max-zone-ttl' on 'dnssec-policy insecure'.
				[GL #4032]

	6218.	[func]		Add inline-signing to dnssec-policy. [GL #3677]

	6217.	[func]		The dns_badcache unit was refactored to use cds_lfht
				instead of hand-crafted locked hashtable. [GL #4223]

	6216.	[bug]		Pin dns_request events to the originating loop
				to serialize access to the data. [GL #4086]

	6215.	[protocol]	Return REFUSED to GSS-API TKEY requests if GSS-API
				support is not configured. [GL #4225]

	6214.	[bug]		Fix the memory leak in for struct stub_glue_request
				allocated in stub_request_nameserver_address() but not
				freed in stub_glue_response(). [GL #4227]

	6213.	[bug]		Mark a primary server as temporarily unreachable if the
				TCP connection attempt times out. [GL #4215]

	6212.	[placeholder]

	6211.	[func]		Remove 'auto-dnssec'. This obsoletes the configuration
				options 'dnskey-sig-validity', 'dnssec-dnskey-kskonly',
				'dnssec-update-mode', 'sig-validity-interval', and
				'update-check-ksk'. [GL #3672]

	6210.	[func]		Don't add signing records for DNSKEY added with dynamic
				update. The dynamic update DNSSEC management feature was
				removed with GL #3686. [GL !8070]

	6209.	[func]		Reduce query-response latency by making recursive
				queries (CNAME, DNAME, NSEC) asynchronous instead
				of directly calling the respective functions. [GL #4185]

	6208.	[func]		Return BADCOOKIE for out-of-date or otherwise bad, well
				formed DNS SERVER COOKIES. [GL #4194]

.. code-block:: none

		--- 9.19.15 released ---

	6207.	[cleanup]	The code implementing TSIG/TKEY support has been cleaned
				up and refactored for improved robustness, readability,
				and consistency with other code modules. [GL !7828]

	6206.	[bug]		Add shutdown checks in dns_catz_dbupdate_callback() to
				avoid a race with dns_catz_shutdown_catzs(). [GL #4171]

	6205.	[bug]		Restore support to read legacy HMAC-MD5 K file pairs.
				[GL #4154]

	6204.	[bug]		Use NS records for relaxed QNAME-minimization mode.
				This reduces the number of queries named makes when
				resolving, as it allows the non-existence of NS RRsets
				at non-referral nodes to be cached in addition to the
				referrals that are normally cached. [GL #3325]

	6203.	[cleanup]	Ensure that the size calculation does not overflow
				when allocating memory for an array.
				[GL #4120] [GL #4121] [GL #4122]

	6202.	[func]		Use per-loop memory contexts for dns_resolver
				objects. [GL !8015]

	6201.	[bug]		The free_all_cpu_call_rcu_data() call at the end
				of isc_loopmgr_run() was causing ~200 ms extra
				latency. [GL #4163]

	6200.	[placeholder]

	6199.	[bug]		Improve HTTP Connection: header protocol conformance
				in the statistics channel. [GL #4126]

	6198.	[func]		Remove the holes in the isc_result_t enum to compact
				the isc_result tables. [GL #4149]

	6197.	[bug]		Fix a data race between the dns_zone and dns_catz
				modules when registering/unregistering a database
				update notification callback for a catalog zone.
				[GL #4132]

	6196.	[cleanup]	Report "permission denied" instead of "unexpected error"
				when trying to update a zone file on a read-only file
				system. Thanks to Midnight Veil. [GL #4134]

	6195.	[bug]		Use rcu to reference view->adb. [GL #4021]

	6194.	[func]		Change function 'find_zone_keys()' to look for signing
				keys by looking for key files instead of a DNSKEY
				RRset lookup. [GL #4141]

	6193.	[bug]		Fix a catz db update notification callback registration
				logic error, which could crash named when receiving an
				AXFR update for a catalog zone while the previous update
				process of the catalog zone was already running.
				[GL #4136]

.. code-block:: none

		--- 9.19.14 released ---

	6192.	[placeholder]

	6191.	[placeholder]

	6190.	[security]	Improve the overmem cleaning process to prevent the
				cache going over the configured limit. (CVE-2023-2828)
				[GL #4055]

	6189.	[bug]		Fix an extra dns_validator deatch when encountering
				deadling which would lead to assertion failure.
				[GL #4115]

	6188.	[performance]	Reduce memory consumption by allocating properly
				sized send buffers for stream-based transports.
				[GL #4038]

	6187.	[bug]		Address view shutdown INSIST when accessing the
				zonetable. [GL #4093]

	6186.	[bug]		Fix a 'clients-per-query' miscalculation bug. When the
				'stale-answer-enable' options was enabled and the
				'stale-answer-client-timeout' option was enabled and
				larger than 0, named was taking two places from the
				'clients-per-query' limit for each client and was
				failing to gradually auto-tune its value, as configured.
				[GL #4074]

	6185.	[func]		Add "ClientQuota" statistics channel counter, which
				indicates the number of the resolver's spilled queries
				due to reaching the clients per query quota. [GL !7978]

	6184.	[func]		Special-case code that was added to allow GSS-TSIG
				to work around bugs in the Windows 2000 version of
				Active Directory has been removed. The 'nsupdate -o'
				option and 'oldgsstsig' command have been
				deprecated, and are now treated as synonyms for
				'nsupdate -g' and 'gsstsig' respectively. [GL #4012]

	6183.	[bug]		Fix a serve-stale bug where a delegation from cache
				could be returned to the client. [GL #3950]

	6182.	[cleanup]	Remove configure checks for epoll, kqueue and
				/dev/poll. [GL #4098]

	6181.	[placeholder]

	6180.	[bug]		The session key object could be incorrectly added
				to multiple different views' keyrings. [GL #4079]

	6179.	[bug]		Fix an interfacemgr use-after-free error in
				zoneconf.c:isself(). [GL #3765]

	6178.	[func]		Add support for the multi-signer model 2 (RFC 8901) when
				using inline-signing. [GL #2710]

	6177.	[placeholder]

	6176.	[test]		Add support for using pytest & pytest-xdist to
				execute the system test suite. [GL #3978]

	6175.	[test]		Fix the `upforwd` system test to be more reliable,

	6174.	[placeholder]

	6173.	[bug]		Properly process extra "nameserver" lines in
				resolv.conf otherwise the next line is not properly
				processed. [GL #4066]

	6172.	[cleanup]	Refactor the loop manager and qp-trie code to remove
				isc_qsbr and use liburcu instead. [GL #3936]

	6171.	[cleanup]	Remove the stack implementation added in change 6108:
				we are using the liburcu concurrent data structures
				instead. [GL !7920]

	6170.	[func]		The 'rndc -t' option allows a timeout to be set in
				seconds, so that commands that take a long time to
				complete (e.g., reloading a very large configuration)
				can be given time to do so. The default is 60
				seconds. [GL #4046]

	6169.	[bug]		named could crash when deleting inline-signing zones
				with "rndc delzone". [GL #4054]

	6168.	[func]		Refactor the glue cache to store list of the GLUE
				directly in the rdatasetheader instead of keeping
				it in the hashtable indexed by the node pointer.
				[GL #4045]

	6167.	[func]		Add 'cdnskey' configuration option. [GL #4050]

	6166.	[func]		Retry without DNS COOKIE on FORMERR if it appears that
				the FORMERR was due to the presence of a DNS COOKIE
				option. [GL #4049]

	6165.	[bug]		Fix a logic error in dighost.c which could call the
				dighost_shutdown() callback twice and cause problems
				if the callback function was not idempotent. [GL #4039]

.. code-block:: none

		--- 9.19.13 released ---

	6164.	[bug]		Set the rndc idle read timeout back to 60 seconds,
				from the netmgr default of 30 seconds, in order to
				match the behavior of 9.16 and earlier. [GL #4046]

	6163.	[func]		Add option to dnstap-read to use timestamps in
				milliseconds (thanks to Oliver Ford). [GL #2360]

	6162.	[placeholder]

	6161.	[bug]		Fix log file rotation when using absolute path as
				file. [GL #3991]

	6160.	[bug]		'delv +ns' could print duplicate output. [GL #4020]

	6159.	[bug]		Fix use-after-free bug in TCP accept connection
				failure. [GL #4018]

	6158.	[func]		Add ISC_LIST_FOREACH() and ISC_LIST_FOREACH_SAFE()
				to walk the ISC_LIST() in a unified manner and use
				the safe macro to fix the potential UAF when shutting
				down the isc_httpd. [GL #4031]

	6157.	[bug]		When removing delegations in an OPTOUT range
				empty-non-terminal NSEC3 records generated by
				those delegations were not removed. [GL #4027]

	6156.	[bug]		Reimplement the maximum and idle timeouts for incoming
				zone tranfers. [GL #4004]

	6155.	[bug]		Treat ISC_R_INVALIDPROTO as a networking error
				in the dispatch code to avoid retrying with the
				same server. [GL #4005]

	6154.	[func]		Add spinlock implementation.  The spinlock is much
				smaller (8 bytes) than pthread_mutex (40 bytes), so
				it can be easily embedded into objects for more
				fine-grained locking (per-object vs per-bucket).

				On the other hand, the spinlock is unsuitable for
				situations where the lock might be held for a long
				time as it keeps the waiting threads in a spinning
				busy loop. [GL #3977]

	6153.	[bug]		Fix the streaming protocols (TCP, TLS) shutdown
				sequence. [GL #4011]

	6152.	[bug]		In dispatch, honour the configured source-port
				selection when UDP connection fails with address
				in use error.

				Also treat ISC_R_NOPERM same as ISC_R_ADDRINUSE.
				[GL #3986]

	6151.	[bug]		When the same ``notify-source`` address and port number
				was configured for multiple destinations and zones, an
				unresponsive server could tie up the socket until it
				timed out; in the meantime, NOTIFY messages for other
				servers silently failed.``named`` will now retry these
				failing messages over TCP.  NOTIFY failures are now
				logged at level INFO. [GL #4001] [GL #4002]

	6150.	[bug]		If the zones have active upstream forwards, the
				shutting down the server might cause assertion
				failures as the forward were all canceled from
				the main loop instead from the loops associated
				with the zone. [GL #4015]

	6149.	[test]		As a workaround, include an OpenSSL header file before
				including cmocka.h in the unit tests, because OpenSSL
				3.1.0 uses __attribute__(malloc), conflicting with a
				redefined malloc in cmocka.h. [GL #4000]

	6148.	[bug]		Fix a use-after-free bug in dns_xfrin_create().
				[GL !7832]

	6147.	[performance]	Fix the TCP server parent quota use. [GL #3985]

.. code-block:: none

		--- 9.19.12 released ---

	6146.	[performance]	Replace the zone table red-black tree and associated
				locking with a lock-free qp-trie. [GL !7582]

	6145.	[bug]		Fix a possible use-after-free bug in the
				dns__catz_done_cb() function. [GL #3997]

	6144.	[bug]		A reference counting problem (double detach) might
				occur when shutting down zone transfer early after
				switching the dns_xfrin to use dns_dispatch API.
				[GL #3984]

	6143.	[bug]		A reference counting problem on the error path in
				the xfrin_connect_done() might cause an assertion
				failure on shutdown.  [GL #3989]

	6142.	[bug]		Reduce the number of dns_dnssec_verify calls made
				determining if revoked keys needs to be removed from
				the trust anchors. [GL #3981]

	6141.	[bug]		Fix several issues in nsupdate timeout handling and
				update the -t option's documentation. [GL #3674]

	6140.	[func]		Implement automatic parental-agents ('checkds yes').
				[GL #3901]

	6139.	[func]		Add isc_histo_t general-purpose log-linear histograms,
				and use them for message size statistics. [GL !7696]

	6138.	[doc]		Fix the DF-flag documentation on the outgoing
				UDP packets. [GL #3710]

	6137.	[cleanup]	Remove the trampoline jump when spawning threads.
				[GL !7293]

	6136.	[cleanup]	Remove the isc_fsaccess API in favor of creating
				temporary file first and atomically replace the key
				with non-truncated content. [GL #3982]

	6135.	[cleanup]	Change isc_stdtime_get(&t) to t = isc_stdtime_now().
				[GL !7757]

	6134.	[bug]		Fix a crash when dig or host receive a signal.
				[GL #3970]

	6133.	[cleanup]	Refactor the isc_job_run() to not make any allocations
				by embedding isc_job_t into callback argument, and
				running it directly.  As a side-effect, isc_async_run
				and isc_job_run now executes jobs in the natural order.

				Use the new improved API to execute connect, read and
				send callbacks from netmgr in more straightforward
				manner, speeding up the networking. [GL #3961]

	6132.	[doc]		Remove a dead link in the DNSSEC guide. [GL #3967]

	6131.	[test]		Add a minimal test-only library to allow testing
				of the DNSRPS API without FastRPZ installed.
				Thanks to Farsight Securty. [GL !7693]

	6130.	[func]		The new "delv +ns" option activates name server mode,
				in which delv sets up an internal recursive
				resolver and uses that, rather than an external
				server, to look up the requested data. All messages
				sent and received during the resolution and
				validation process are logged. This can be used in
				place of "dig +trace"; it more accurately
				replicates the behavior of named when resolving
				a query. [GL #3842]

	6129.	[cleanup]	Value stored to 'source' during its initialization is
				never read. [GL #3965]

	6128.	[bug]		Fix an omission in an earlier commit to avoid a race
				between the 'dns__catz_update_cb()' and
				'dns_catz_dbupdate_callback()' functions. [GL #3968]

	6127.	[cleanup]	Refactor network manager netievent callbacks to
				use isc_job_run()/isc_async_run(). [GL #3964]

	6126.	[func]		Remove zone type "delegation-only" and the
				"delegation-only" and "root-delegation-only"
				options. [GL #3953]

	6125.	[bug]		Hold a catz reference while the update process is
				running, so that the catalog zone is not destroyed
				during shutdown until the update process is finished or
				properly canceled by the activated 'shuttingdown' flag.
				[GL #3955]

	6124.	[bug]		When changing from a NSEC3 capable DNSSEC algorithm to
				an NSEC3 incapable DNSSEC algorithm using KASP the zone
				could sometimes be incompletely signed. [GL #3937]

	6123.	[placeholder]

	6122.	[func]		BIND now requires liburcu for lock-free data structures
				and concurrent safe memory reclamation. It replaces the
				home-grown lock-free linked list and QSBR machinery
				added in changes 6108 and 6109.  [GL #3935]

	6121.	[cleanup]	Remove support for TKEY Mode 2 (Diffie-Hellman Exchanged
				Keying). [GL #3905]

.. code-block:: none

		--- 9.19.11 released ---

	6120.	[bug]		Use two pairs of dns_db_t and dns_dbversion_t in a
				catalog zone structure to avoid a race between the
				dns__catz_update_cb() and dns_catz_dbupdate_callback()
				functions. [GL #3907]

	6119.	[bug]		Make sure to revert the reconfigured zones to the
				previous version of the view, when the new view
				reconfiguration fails during the configuration of
				one of the configured zones. [GL #3911]

	6118.	[func]		Add 'cds-digest-types' configuration option. Also allow
				dnssec-signzone to create multple CDS records.
				[GL #3837]

	6117.	[func]		Add a qp-trie data structure. This is a foundation for
				our plan to replace, in stages, BIND's red-black tree.
				The qp-trie has lock-free multithreaded reads, using
				QSBR for safe memory reclamation. [GL !7130]

	6116.	[placeholder]

	6115.	[bug]		Unregister db update notify callback before detaching
				from the previous db inside the catz update notify
				callback. [GL #3777]

	6114.	[func]		Run the catalog zone update process on the offload
				threads. [GL #3881]

	6113.	[func]		Add shutdown signaling for catalog zones. [GL !7571]

	6112.	[func]		Add reference count tracing for dns_catz_zone_t and
				dns_catz_zones_t. [GL !7570]

	6111.	[cleanup]	Move irs_resconf into libdns, and remove the
				now empty libirs. [GL !7463]

	6110.	[cleanup]	Refactor the dns_xfrin module to use dns_dispatch
				to set up TCP connections and send and receive
				messages. [GL #3886]

	6109.	[func]		Infrastructure for QSBR, asynchronous safe memory
				reclamation for lock-free data structures. [GL !7471]

	6108.	[func]		Support for simple lock-free singly-linked stacks.
				[GL !7470]

	6107.	[cleanup]	Remove the dns_sdb API and rewrite the named
				builtin databases to implement dns_db directly.
				[GL #3882]

	6106.	[cleanup]	Move bind9_getaddresses() to isc_getaddresses()
				and remove the now empty libbind9. [GL !7462]

	6105.	[bug]		Detach 'rpzs' and 'catzs' from the previous view in
				configure_rpz() and configure_catz(), respectively,
				just after attaching it to the new view. [GL #3880]

	6104.	[cleanup]	Move libbind9's configuration checking code into
				libisccfg alongside the other configuration code.
				[GL !7461]

	6103.	[func]		All uses of the isc_task and isc_event APIs have
				been refactored to use isc_loop instead, and the
				original APIs have been removed. [GL #3797]

	6102.	[cleanup]	Several nugatory headers have been removed from libisc.
				[GL !7464]

	6101.	[port]		Clarify the portability dodge needed for `strerror_r()`
				[GL !7465]

	6100.	[cleanup]	Deprecate <isc/deprecated.h>, because obsolete
				functions are now deleted instead of marked with
				an attribute. [GL !7466]

	6099.	[performance]	Change the internal read-write lock to modified C-RW-WP
				algorithm that is more reader-writer fair and has better
				performance for our workloads. [GL #1609]

	6098.	[test]		Don't test HMAC-MD5 when not supported by libcrypto.
				[GL #3871]

	6097.	[port]		Improve support for yield / pause instructions in spin
				loops on AArch64 platforms. [GL !7469]

	6096.	[bug]		Fix RPZ reference counting error on shutdown in
				dns__rpz_timer_cb(). [GL #3866]

	6095.	[test]		Test various 'islands of trust' configurations when
				using managed keys. [GL #3662]

	6094.	[bug]		Building against (or running with) libuv versions
				1.35.0 and 1.36.0 is now a fatal error.  The rules for
				mixing and matching compile-time and run-time libuv
				versions have been tightened for libuv versions between
				1.35.0 and 1.40.0. [GL #3840]

	6093.	[performance]	Reduce the size of each rdataset header object
				by 16 bytes. [GL !7505]

	6092.	[bug]		dnssec-cds failed to cleanup properly. [GL #3831]

	6091.	[cleanup]	Drop RHEL 7 and clones support. [GL #3729]

	6090.	[bug]		Fix a bug in resolver's resume_dslookup() function by
				making sure that dns_resolver_createfetch() is called
				with valid parameters, as required by the function.
				[GL #3839]

	6089.	[bug]		Source ports configured for query-source,
				transfer-source, etc, were being ignored. (This
				feature is deprecated, but it is not yet removed,
				so the bug still needed fixing.) [GL #3790]

	6088.	[cleanup]	/etc/bind.keys is no longer needed and has been
				removed from the distribution. named and delv can
				still load keys from a file for testing purposes,
				but they no longer do so by default. [GL #3850]

	6087.	[cleanup]	Remove support for the `DNS_NAME_DOWNCASE` option to
				the various dns_*_fromwire() functions. It has long
				been unused and is unsupported since change 6022.
				[GL !7467]

	6086.	[cleanup]	Remove some remnants of bitstring labels. [GL !7196]

	6085.	[func]		Add isc_time_monotonic() to simplify time measurements.
				[GL !7468]

	6084.	[bug]		When BIND was built without jemalloc, the allocator flag
				ISC_MEM_ZERO could return non-zero memory. [GL #3845]

.. code-block:: none

		--- 9.19.10 released ---

	6083.	[bug]		Fix DNSRPS-enabled builds as they were inadvertently
				broken by changes 5949 and 6042. [GL #3827]

	6082.	[test]		fuzz/dns_message_checksig leaked memory when shutting
				down. [GL #3828]

	6081.	[bug]		Handle primary server address lookup failures in
				nsupdate more gracefully. [GL #3830]

	6080.	[bug]		'named -V' leaked memory. [GL #3829]

	6079.	[bug]		Force set the DS state after a 'rdnc dnssec -checkds'
				command. [GL #3822]

	6078.	[func]		Cleanup the memory statistic counters to a bare
				minumum - InUse with Malloced as alias. [GL #3718]

	6077.	[func]		Implement query forwarding to DoT-enabled upstream
				servers. [GL #3726]

	6076.	[bug]		Handle OS errors when creating UDP and TCP sockets
				more gracefully. [GL #3800]

	6075.	[bug]		Add missing node lock when setting node->wild in
				add_wildcard_magic. [GL #3799]

	6074.	[func]		Refactor the isc_nm_xfr_allowed() function to return
				isc_result_t instead of boolean. [GL #3808]

	6073.	[bug]		Set RD=1 on DS requests to parental-agents. [GL #3783]

	6072.	[bug]		Avoid the OpenSSL lock contention when initializing
				Message Digest Contexts by using explicit algorithm
				fetching, initializing static contexts for every
				supported algorithms, and initializing the new context
				by copying the static copy. [GL #3795]

	6071.	[func]		The use of "port" when configuring query-source,
				transfer-source, notify-source and parental-source
				addresses has been deprecated, along with the
				use-v[46]-udp-ports and avoid-v[46]-udp-ports
				options. A warning will be logged when these
				options are used. In a future release, they
				will be removed. [GL #3781]

	6070.	[func]		DSCP parsing has now been fully removed, and
				configuration of DSCP values in named.conf is a
				configuration error. [GL #3789]

	6069.	[bug]		Detach from the view in zone_shutdown() to
				release the memory held by the dead view
				early. [GL #3801]

	6068.	[bug]		Downloading a zone via TLS from a server which does
				not negotiate "dot" ALPN token could crash BIND
				on shutdown. That has been fixed. [GL #3767]

.. code-block:: none

		--- 9.19.9 released ---

	6067.	[security]	Fix serve-stale crash when recursive clients soft quota
				is reached. (CVE-2022-3924) [GL #3619]

	6066.	[security]	Handle RRSIG lookups when serve-stale is active.
				(CVE-2022-3736) [GL #3622]

	6065.	[placeholder]

	6064.	[security]	An UPDATE message flood could cause named to exhaust all
				available memory. This flaw was addressed by adding a
				new "update-quota" statement that controls the number of
				simultaneous UPDATE messages that can be processed or
				forwarded. The default is 100. A stats counter has been
				added to record events when the update quota is
				exceeded, and the XML and JSON statistics version
				numbers have been updated. (CVE-2022-3094) [GL #3523]

	6063.	[cleanup]	The RSA and ECDSA parts of the DNSSEC has been
				refactored for a better OpenSSL 3.x integration and
				preliminary PKCS#11 support via for OpenSSL Providers
				has been added. [GL #3785]

	6062.	[func]		The DSCP implementation, which has been
				nonfunctional for some time, is now marked as
				obsolete and the implementation has been removed.
				Configuring DSCP values in named.conf has no
				effect, and a warning will be logged that
				the feature should no longer be used. [GL #3773]

	6061.	[bug]		Fix unexpected "Prohibited" extended DNS error
				on allow-recursion. [GL #3743]

	6060.	[bug]		Fix a use-after-free bug in dns_zonemgr_releasezone()
				by detaching from the zone manager outside of the write
				lock. [GL #3768]

	6059.	[bug]		In some serve stale scenarios, like when following an
				expired CNAME record, named could return SERVFAIL if the
				previous request wasn't successful. Consider non-stale
				data when in serve-stale mode. [GL #3678]

	6058.	[bug]		Prevent named from crashing when "rndc delzone"
				attempts to delete a zone added by a catalog zone.
				[GL #3745]

	6057.	[bug]		Fix shutdown and error path bugs in the rpz unit.
				[GL #3735]

	6056.	[bug]		Fix a race in adb.c:clean_namehooks(), so that an ADB
				entry does not expire without holding the entries lock.
				[GL #3754]

	6055.	[cleanup]	Remove setting alternate transfer sources, make options
				alt-transfer-source, alt-transfer-transfer-source-v6,
				and use-alt-transfer-source ancient. [GL #3714]

	6054.	[func]		Refactor remote servers (primaries, parental-agents)
				in zone.c. Store common code in new source files
				remote.c and remote.h. Introduce a new way to set the
				source address and port. [GL !7110]

	6053.	[bug]		Fix an ADB quota management bug in resolver. [GL #3752]

	6052.	[func]		Replace DNS over TCP and DNS over TLS transports
				code with a new, unified transport implementation.
				[GL #3374]

	6051.	[bug]		Improve thread safety in the dns_dispatch unit.
				[GL #3178] [GL #3636]

	6050.	[bug]		Changes to the RPZ response-policy min-update-interval
				and add-soa options now take effect as expected when
				named is reconfigured. [GL #3740]

	6049.	[bug]		Exclude ABD hashtables from the ADB memory
				overmem checks and don't clean ADB names
				and ADB entries used in the last 10 seconds
				(ADB_CACHE_MINIMUM). [GL #3739]

	6048.	[bug]		Fix a log message error in dns_catz_update_from_db(),
				where serials with values of 2^31 or larger were logged
				incorrectly as negative numbers. [GL #3742]

	6047.	[bug]		Try the next server instead of trying the same
				server again on an outgoing query timeout.
				[GL #3637]

	6046.	[bug]		TLS session resumption might lead to handshake
				failures when client certificates are used for
				authentication (Mutual TLS).  This has been fixed.
				[GL #3725]

	6045.	[cleanup]	The list of supported DNSSEC algorithms changed log
				level from "warning" to "notice" to match named's other
				startup messages. [GL !7217]

	6044.	[bug]		There was an "RSASHA236" typo in a log message.
				[GL !7206]

.. code-block:: none

		--- 9.19.8 released ---

	6043.	[bug]		The key file IO locks objects would never get
				deleted from the hashtable due to off-by-one error.
				[GL #3727]

	6042.	[bug]		ANY responses could sometimes have the wrong TTL.
				[GL #3613]

	6041.	[func]		Set the RLIMIT_NOFILE to rlim_max returned from
				getrlimit() instead of trying to guess the maximum
				allowed value. [GL #3676]

	6040.	[bug]		Speed up the named shutdown time by explicitly
				canceling all recursing ns_client objects for
				each ns_clientmgr. [GL #3183]

	6039.	[bug]		Removing a catalog zone from catalog-zones without
				also removing the referenced zone could leave a
				dangling pointer. [GL #3683]

	6038.	[placeholder]

	6037.	[func]		Reject zones which have DS records not at delegation
				points. [GL #3697]

	6036.	[bug]		nslookup and host were not honoring the selected port
				in TCP mode. [GL #3721]

	6035.	[bug]		Refactor the dns_resolver unit to store the fetch
				contexts and zone counter directly in the hash
				tables without buckets and implement effective
				cleaning of both objects. [GL #3709]

	6034.	[func]		Deprecate alt-transfer-source, alt-transfer-source-v6
				and use-alt-transfer-source. [GL #3694]

	6033.	[func]		Log messages related to serve-stale now include the RR
				type involved. [GL !7145]

	6032.	[bug]		After change 5995, zone transfers were using a small
				compression context that only had space for the first
				few dozen names in each message. They now use a large
				compression context with enough space for every name.
				[GL #3706]

	6031.	[bug]		Move the "final reference detached" log message
				from dns_zone unit to the DEBUG(1) log level.
				[GL #3707]

	6030.	[bug]		Refactor the ADB to use a global LRU queue, store
				the ADB names and ADB entries directly in the hash
				tables instead of buckets, and properly clean the
				ADB names and entries when not in use. [GL #3239]
				[GL #3238] [GL #2615] [GL #2078] [GL #2437]
				[GL #3312] [GL #2441]

	6029.	[cleanup]	Remove the unused external cache cleaning mechanism
				as RBTDB has its own internal cache cleaning
				mechanism and we don't support any other database
				implementations. [GL #3639]

	6028.	[performance]	Build-time code generation of DNS RRtype switches
				is now much faster. [GL !7121]

	6027.	[bug]		Fix assertion failure in isc_http API used by
				statschannel if the read callback would be called
				on HTTP request that has been already closed.
				[GL #3693]

	6026.	[cleanup]	Deduplicate time unit conversion factors.
				[GL !7033]

	6025.	[bug]		Copy TLS identifier when setting up primaries for
				catalog member zones. [GL #3638]

	6024.	[func]		Deprecate 'auto-dnssec'. [GL #3667]

	6023.	[func]		Remove dynamic update DNSSEC management feature.
				[GL #3686]

	6022.	[performance]	The decompression implementation in dns_name_fromwire()
				is now smaller and faster. [GL #3655]

	6021.	[bug]		Use the current domain name when checking answers from
				a dual-stack-server. [GL #3607]

	6020.	[bug]		Ensure 'named-checkconf -z' respects the check-wildcard
				option when loading a zone.  [GL #1905]

	6019.	[func]		Deprecate `coresize`, `datasize`, `files`, and
				`stacksize` named.conf options. [GL #3676]

	6018.	[cleanup]	Remove the --with-tuning configure option.
				[GL #3664]

	6017.	[bug]		The view's zone table was not locked when it should
				have been leading to race conditions when external
				extensions that manipulate the zone table where in
				use. [GL #3468]

	6016.	[func]		Change NSEC3PARAM TTL to match the SOA MINIMUM.
				[GL #3570]

	6015.	[bug]		Some browsers (Firefox) send more than 10 HTTP
				headers.  Bump the number of allowed HTTP headers
				to 100. [GL #3670]

	6014.	[func]		Add isc_hashmap API implementation that implements
				Robin Hood hashing.  The API requires the keys to
				be stored with the stored value.  [GL !6790]

.. code-block:: none

		--- 9.19.7 released ---

	6013.	[bug]		Fix a crash that could happen when you change
				a dnssec-policy zone with NSEC3 to start using
				inline-signing. [GL #3591]

	6012.	[placeholder]

	6011.	[func]		Refactor the privilege setting part of named_os unit
				to make libcap on Linux mandatory and use setreuid
				and setregid if available. [GL #3583]

	6010.	[func]		Make the initial interface scan happen before
				dropping the privileges.  This requires exiting
				exclusive mode before scanning the interfaces
				and re-entering it again when we are done.  This
				is because starting the listening on interfaces
				requires the loopmgr to be running and not paused.
				[GL #3583]

	6009.	[bug]		Don't trust a placeholder KEYDATA from the managed-keys
				zone by adding it into secroots. [GL #2895]

	6008.	[bug]		Fixed a race condition that could cause a crash
				in dns_zone_synckeyzone(). [GL #3617]

	6007.	[cleanup]	Don't enforce the jemalloc use on NetBSD. [GL #3634]

	6006.	[cleanup]	The zone dumping was using isc_task API to launch
				the zonedump on the offloaded threadpool.  Remove
				the task and launch the offloaded work directly.
				[GL #3628]

	6005.	[func]		The zone loading has been moved to the offload
				threadpool instead of doing incremental repeated
				tasks, so zone loading scheduling is now driven
				by the operating system scheduler rather than fixed
				(100) quantum. [GL #3625]

	6004.	[func]		Add check-svcb to control the checking of additional
				constraints on SVBC records.  This change impacts on
				named, named-checkconf, named-checkzone,
				named-compilezone and nsupdate. [GL #3576]

	6003.	[bug]		Fix an inheritance bug when setting the port on
				remote servers in configuration. [GL #3627]

	6002.	[bug]		Fix a resolver prefetch bug when the record's TTL value
				is equal to the configured prefetch eligibility value,
				but the record was erroneously not treated as eligible
				for prefetching. [GL #3603]

	6001.	[bug]		Always call dns_adb_endudpfetch() after calling
				dns_adb_beginudpfetch() for UDP queries in resolver.c,
				in order to adjust back the quota. [GL #3598]

	6000.	[bug]		Fix a startup issue on Solaris systems with many
				(reportedly > 510) CPUs. Thanks to Stacey Marshall from
				Oracle for deep investigation of the problem. [GL #3563]

	5999.	[bug]		rpz-ip rules could be ineffective in some scenarios
				with CD=1 queries. [GL #3247]

	5998.	[placeholder]

	5997.	[cleanup]	Less ceremonial UNEXPECTED_ERROR() and FATAL_ERROR()
				reporting macros. [GL !6914]

	5996.	[bug]		Fix a couple of bugs in cfg_print_duration(), which
				could result in generating incomplete duration values
				when printing the configuration using named-checkconf.
				[GL !6880]

	5995.	[performance]	A new algorithm for DNS name compression based on a
				hash set of message offsets. Name compression is now
				more complete as well as being generally faster, and
				the implementation is less complicated and requires
				much less memory. [GL !6517]

	5994.	[func]		Refactor the isc_httpd implementation used in the
				statistics channel. [GL !6879]

	5993.	[cleanup]	Store dns_name_t attributes as boolean members of
				the structure. Remove DNS_NAMEATTR_* macros.
				Fix latent attribute handling bug in RBT. [GL !6902]

.. code-block:: none

		--- 9.19.6 released ---

	5992.	[func]		Introduce the new isc_mem_*x() APIs that takes extra
				flags as the last argument.  Currently ISC_MEM_ZERO
				and ISC_MEM_ALIGN(n) flags have been implemented that
				clears the memory to avoid the isc_mem_get()/memset()
				pattern and make aligned allocation which replaces the
				previous isc_mem_*_aligned() calls. [GL !6398]

	5991.	[protocol]	Add support for parsing and validating "dohpath" to
				SVCB. [GL #3544]

	5990.	[test]		fuzz/dns_message_checksig now creates the key directory
				it uses when testing in /tmp at run time. [GL #3569]

	5989.	[func]		Implement support for DDNS update forwarding using DoT
				to TLS-enabled primary servers. [GL #3512]

	5988.	[bug]		Some out of memory conditions in opensslrsa_link.c
				could lead to memory leaks. [GL #3551]

	5987.	[func]		Provide custom isc_mem based allocators for libuv,
				OpenSSL and libxml2 libraries that support replacing
				the internal allocators. [GL #3559]

	5986.	[func]		Make the memory context debugging options local to
				the memory context and make it immutable for the memory
				context lifetime. [GL #3559]

	5985.	[func]		Bump the minimal libuv version to 1.34.0. [GL #3567]

	5984.	[func]		'named -V' now reports the list of supported
				DNSSEC/DS/HMAC algorithms and the supported TKEY modes.
				[GL #3541]

	5983.	[bug]		Changing just the TSIG key names for primaries in
				catalog zones' member zones was not effective.
				[GL #3557]

	5982.	[func]		Extend dig to allow requests to be signed using SIG(0)
				as well as providing a mechanism to specify the signing
				time. [GL !5923]

	5981.	[test]		Add dns_message_checksig fuzzer to check messages
				signed using TSIG or SIG(0). [GL !5923]

	5980.	[func]		The internal isc_entropy API provider has been
				changed from OpenSSL RAND_bytes() to uv_random()
				to use system provided entropy. [GL !6803]

	5979.	[func]		Implement DoT support for nsupdate. [GL #1781]

	5978.	[port]		The ability to use pkcs11 via engine_pkcs11 has been
				restored, by only using deprecated APIs in
				OpenSSL 3.0.0. BIND needs to be compiled with
				'-DOPENSSL_API_COMPAT=10100' specified in the CFLAGS
				at compile time. [GL !6711]

	5977.	[bug]		named could incorrectly return non-truncated, glueless
				referrals for responses whose size was close to the UDP
				packet size limit. [GL #1967]

	5976.	[cleanup]	isc_timer_t objects are now created, started and
				destroyed in a particular loop, and timer callbacks
				run in that loop. isc_timer_stop() can still be called
				from any loop; when run from a different loop than
				the one associated with the timer, the request will
				be recorded in atomic variable and the timer will
				be stopped on the next callback call. [GL #3202]

	5975.	[func]		Implement TLS transport support for dns_request and
				dns_dispatch. [GL #3529]

	5974.	[bug]		Fix an assertion failure in dispatch caused by
				extra read callback call. [GL #3545]

	5973.	[bug]		Fixed a possible invalid detach in UPDATE
				processing. [GL #3522]

	5972.	[bug]		Gracefully handle when the statschannel HTTP connection
				gets cancelled during sending data back to the client.
				[GL #3542]

	5971.	[func]		Add libsystemd sd_notify() support. [GL #1176]

	5970.	[func]		Log the reason why a query was refused. [GL !6669]

	5969.	[bug]		DNSSEC signing statistics failed to identify the
				algorithm involved.  The key names have been changed
				to be the algorithm number followed by "+" followed
				by the key id (e.g. "8+54274"). [GL #3525]

	5968.	[cleanup]	Remove 'resolve' binary from tests. [GL !6733]

	5967.	[cleanup]	Flagged the obsolete "random-device" option as
				ancient; it is now an error to configure it. [GL #3399]

	5966.	[func]		You can now specify if a server must return a DNS
				COOKIE before accepting the response over UDP.
				[GL #2295]

				server <prefix> { require-cookie <yes_or_no>; };

	5965.	[cleanup]	Move the duplicated ASCII case conversion tables to
				isc_ascii where they can be shared, and replace the
				various hot-path tolower() loops with calls to new
				isc_ascii implementations. [GL !6516]

	5964.	[func]		When an international domain name is not valid, DiG will
				now pass it through unchanged, instead of stopping with
				an error message. [GL #3527]

	5963.	[bug]		Ensure struct named_server is properly initialized.
				[GL #6531]

.. code-block:: none

		--- 9.19.5 released ---

	5962.	[security]	Fix memory leak in EdDSA verify processing.
				(CVE-2022-38178) [GL #3487]

	5961.	[placeholder]

	5960.	[security]	Fix serve-stale crash that could happen when
				stale-answer-client-timeout was set to 0 and there was
				a stale CNAME in the cache for an incoming query.
				(CVE-2022-3080) [GL #3517]

	5959.	[security]	Fix memory leaks in the DH code when using OpenSSL 3.0.0
				and later versions. The openssldh_compare(),
				openssldh_paramcompare(), and openssldh_todns()
				functions were affected. (CVE-2022-2906) [GL #3491]

	5958.	[security]	When an HTTP connection was reused to get
				statistics from the stats channel, and zlib
				compression was in use, each successive
				response sent larger and larger blocks of memory,
				potentially reading past the end of the allocated
				buffer. (CVE-2022-2881) [GL #3493]

	5957.	[security]	Prevent excessive resource use while processing large
				delegations. (CVE-2022-2795) [GL #3394]

	5956.	[func]		Make RRL code treat all QNAMEs that are subject to
				wildcard processing within a given zone as the same
				name. [GL #3459]

	5955.	[port]		The libxml2 library has deprecated the usage of
				xmlInitThreads() and xmlCleanupThreads() functions. Use
				xmlInitParser() and xmlCleanupParser() instead.
				[GL #3518]

	5954.	[func]		Fallback to IDNA2003 processing in dig when IDNA2008
				conversion fails. [GL #3485]

	5953.	[bug]		Fix a crash on shutdown in delete_trace_entry(). Add
				mctx attach/detach pair to make sure that the memory
				context used by a memory pool is not destroyed before
				the memory pool itself. [GL #3515]

	5952.	[bug]		Use quotes around address strings in YAML output.
				[GL #3511]

	5951.	[bug]		In some cases, the dnstap query_message field was
				erroneously set when logging response messages.
				[GL #3501]

	5950.	[func]		Implement a feature to set an Extended DNS Error (EDE)
				code on responses modified by RPZ. [GL #3410]

	5949.	[func]		Add new isc_loopmgr API that runs the application
				event loops and completely replaces the isc_app
				API. Refactor the isc_taskmgr, isc_timermgr and
				isc_netmgr to use the isc_loopmgr event loops.
				[GL #3508]

	5948.	[bug]		Fix nsec3.c:dns_nsec3_activex() function, add a missing
				dns_db_detachnode() call. [GL #3500]

	5947.	[func]		Change dnssec-policy to allow graceful transition from
				an NSEC only zone to NSEC3. [GL #3486]

	5946.	[bug]		Fix statistics channel's handling of multiple HTTP
				requests in a single connection which have non-empty
				request bodies. [GL #3463]

	5945.	[bug]		If parsing /etc/bind.key failed, delv could assert
				when trying to parse the built in trust anchors as
				the parser hadn't been reset. [GL !6468]

	5944.	[bug]		Fix +http-plain-get and +http-plain-post options
				support in dig. Thanks to Marco Davids at SIDN for
				reporting the problem. [GL !6672]

	5943.	[placeholder]

	5942.	[bug]		Fix tkey.c:buildquery() function's error handling by
				adding the missing cleanup code. [GL #3492]

	5941.	[func]		Zones with dnssec-policy now require dynamic DNS or
				inline-siging to be configured explicitly. [GL #3381]

	5940.	[placeholder]

	5939.	[placeholder]

	5938.	[bug]		An integer type overflow could cause an assertion
				failure when freeing memory. [GL #3483]

	5937.	[cleanup]	The dns_rdatalist_tordataset() and
				dns_rdatalist_fromrdataset() functions can no
				longer fail. Clean up their prototypes and error
				handling, and that of other calling functions that
				subsequently cannot fail, including
				dns_message_setquerytsig(). [GL #3467]

	5936.	[bug]		Don't enable serve-stale for lookups that error because
				it is a duplicate query or a query that would be
				dropped. [GL #2982]

	5935.	[bug]		Fix DiG lookup reference counting bug, which could
				be observed in NSSEARCH mode. [GL #3478]

.. code-block:: none

		--- 9.19.4 released ---

	5934.	[func]		Improve fetches-per-zone fetch limit logging to log
				the final allowed and spilled values of the fetch
				counters before the counter object gets destroyed.
				[GL #3461]

	5933.	[port]		Automatically disable RSASHA1 and NSEC3RSASHA1 in
				named on Fedorda 33, Oracle Linux 9 and RHEL9 when
				they are disabled by the security policy. [GL #3469]

	5932.	[bug]		Fix rndc dumpdb -expired and always include expired
				RRsets, not just for RBTDB_VIRTUAL time window.
				[GL #3462]

	5931.	[bug]		Fix DiG query error handling robustness in NSSEARCH
				mode by making sure that udp_ready(), tcp_connected(),
				and send_done() callbacks start the next query in chain
				even if there is some kind of error with the previous
				query. [GL #3419]

	5930.	[bug]		Fix DiG query retry and fail-over bug in UDP mode.
				Also simplify the overall retry and fail-over logic to
				make it behave predictably, and always respect the
				documented +retry/+tries count set by a command-line
				option (or use the default values of 2 or 3
				respectively). [GL #3407]

	5929.	[func]		The use of the "max-zone-ttl" option in "zone" and
				"options" blocks is now deprecated; this should
				now be configured as part of "dnssec-policy"
				instead. The old option still works in zones
				with no "dnssec-policy" configured, but a warning
				will be logged when loading configuration. Its
				functionality will be removed in a future release.
				Using "max-zone-ttl" and "dnssec-policy" in the
				same zone is now a fatal error. [GL #2918]

	5928.	[placeholder]

	5927.	[bug]		A race was possible in dns_dispatch_connect()
				that could trigger an assertion failure if two
				threads called it near-simultaneously. [GL #3456]

	5926.	[func]		Handle transient TCP connect() EADDRINUSE failures
				on FreeBSD (and possibly other BSDs) by trying three
				times before giving up. [GL #3451]

	5925.	[bug]		With a forwarder configured for all queries, resolution
				failures encountered during DS chasing could trigger
				assertion failures due to a logic bug in
				resume_dslookup() that caused it to call
				dns_resolver_createfetch() with an invalid name.
				[GL #3439]

	5924.	[func]		When it's necessary to use AXFR to respond to an
				IXFR request, a message explaining the reason
				is now logged at level info. [GL #2683]

	5923.	[bug]		Fix inheritance for dnssec-policy when checking for
				inline-signing. [GL #3438]

	5922.	[bug]		Forwarding of UPDATE message could fail with the
				introduction of netmgr. This has been fixed. [GL #3389]

	5921.	[test]		Convert system tests to use a default DNSKEY algorithm
				where the test is not DNSKEY algorithm specific.
				[GL #3440]

	5920.	[bug]		Don't pass back the current name offset when the
				compression is disabled in the non-improving case.
				[GL #3423]

.. code-block:: none

		--- 9.19.3 released ---

	5919.	[func]		The "rndc fetchlimit" command lists name servers
				and domain names that are being rate-limited by
				"fetches-per-server" or "fetches-per-zone" limits.
				[GL #665]

	5918.	[test]		Convert system tests to use a default HMAC algorithm
				where the test is not HMAC specific. [GL #3433]

	5917.	[bug]		Update ifconfig.sh script as is miscomputed interface
				identifiers when destroying interfaces. [GL #3061]

	5916.	[bug]		When resolving a name, don't give up immediately if an
				authoritative server returns FORMERR; try the other
				servers first. [GL #3152]

	5915.	[bug]		Detect missing closing brace (}) and computational
				overflows in $GENERATE directives. [GL #3429]

	5914.	[bug]		When synth-from-dnssec generated a response using
				records from a higher zone, it could unexpectedly prove
				non-existance of records in a subordinate grafted-on
				namespace. [GL #3402]

	5913.	[placeholder]

	5912.	[cleanup]	The "glue-cache" option has been removed. The glue cache
				feature still works and is now permanently enabled.
				[GL #2147]

	5911.	[bug]		Update HTTP listener settings on reconfiguration.
				[GL #3415]

	5910.	[cleanup]	Move built-in dnssec-policies into the defaultconf.
				These are now printed with 'named -C'. [GL !6467]

	5909.	[bug]		The server-side destination port was missing from dnstap
				captures of client traffic. [GL #3309]

	5908.	[bug]		Fix race conditions in route_connected(). [GL #3401]

	5907.	[bug]		Fix a crash in dig NS search mode when one of the NS
				server queries fail. [GL #3207]

	5906.	[cleanup]	Various features (e.g. prefetch, RPZ) no longer share
				common pointers when initiating recursion. This
				rationalizes recursion quota handling and makes the
				value of the RecursClients statistics counter more
				accurate. [GL #3168]

	5905.	[bug]		When the TCP connection would be closed/reset between
				the connect/accept and the read, the uv_read_start()
				return value would be unexpected and cause an assertion
				failure. [GL #3400]

	5904.	[func]		Changed dnssec-signzone -H default to 0 additional
				NSEC3 iterations. [GL #3395]

	5903.	[bug]		When named checks that the OPCODE in a response matches
				that of the request, if there is a mismatch named logs
				an error.  Some of those error messages incorrectly
				used RCODE instead of OPCODE to lookup the nemonic.
				This has been corrected. [GL !6420]

	5902.	[func]		NXDOMAIN cache records are no longer retained in
				the cache after expiry, even when serve-stale is
				in use. [GL #3386]

	5901.	[bug]		When processing a catalog zone member zone make sure
				that there is no configured pre-existing forward-only
				forward zone with that name. [GL #2506]

	5900.	[placeholder]

.. code-block:: none

		--- 9.19.2 released ---

	5899.	[func]		Don't try to process DNSSEC-related and ZONEMD records
				in catz. [GL #3380]

	5898.	[cleanup]	Simplify BIND's internal DNS name compression API. As
				RFC 6891 explains, it isn't practical to deploy new
				label types or compression methods, so it isn't
				necessary to have an API designed to support them.
				Remove compression terminology that refers to Internet
				Drafts that expired in the 1990s. [GL !6270]

	5897.	[bug]		Views that weren't configured to use RFC 5011 key
				management would still set up an empty managed-keys
				zone. This has been fixed. [GL #3349]

	5896.	[func]		Add some more dnssec-policy checks to detect weird
				policies. [GL #1611]

	5895.	[test]		Add new set of unit test macros and move the unit
				tests under single namespace in /tests/. [GL !6243]

	5894.	[func]		Avoid periodic interface re-scans on Linux by
				default, where a reliable event-based mechanism for
				detecting interface state changes is available.
				[GL #3064]

	5893.	[func]		Add TLS session resumption support to the client-side
				TLS code. [GL !6274]

	5892.	[cleanup]	Refactored the the hash tables in resolver.c to
				use the isc_ht API. [GL !6271]

	5891.	[func]		Key timing options for `dnssec-settime` and related
				utilities now accept "UNSET" times as printed by
				`dnssec-settime -p`. [GL #3361]

	5890.	[bug]		When the fetches-per-server quota was adjusted
				because of an authoritative server timing out more
				or less frequently, it was incorrectly set to 1
				rather than the intended value.  This has been
				fixed. [GL #3327]

	5889.	[cleanup]	Refactored and simplified the shutdown processes in
				dns_view, dns_resolver, dns_requestmgr, and dns_adb
				by reducing interdependencies between the objects.
				[GL !6278]

	5888.	[bug]		Only write key files if the dnssec-policy keymgr has
				changed the metadata. [GL #3302]

	5887.	[cleanup]	Remove the on-shutdown mechanics from isc_task API.
				Replace it by isc_task_send() when we are shutting
				down. [GL !6275]

.. code-block:: none

		--- 9.19.1 released ---

	5886.	[security]	Fix a crash in DNS-over-HTTPS (DoH) code caused by
				premature TLS stream socket object deletion.
				(CVE-2022-1183) [GL #3216]

	5885.	[bug]		RPZ NSIP and NSDNAME rule processing didn't handle stub
				and static-stub zones at or above the query name.  This
				has now been addressed. [GL #3232]

	5884.	[cleanup]	Reduce struct padding in ADB address entries, and use a
				binary hash function to find addresses. [GL !6219]

	5883.	[cleanup]	Move netmgr/uv-compat.{c,h} to <isc/uv.h>, so
				the compatibility libuv shims could be used outside
				the network manager. [GL !6199]

	5882.	[contrib]	Avoid name space collision in dlz modules by prefixing
				functions with 'dlz_'. [GL !5778]

	5881.	[placeholder]

	5880.	[func]		Add new named command-line option -C to print built-in
				defaults. [GL #1326]

	5879.	[contrib]	dlz: Add FALLTHROUGH and UNREACHABLE macros. [GL #3306]

	5878.	[func]		Check the algorithm name or OID embedded at the start
				of the signature field for PRIVATEDNS and PRIVATEOID
				SIG and RRSIG records are well formed. [GL #3296]

	5877.	[func]		Introduce the concept of broken catalog zones described
				in the DNS catalog zones draft version 5 document.
				[GL #3224]

	5876.	[func]		Add DNS Extended Errors when stale answers are returned
				from cache. [GL #2267]

	5875.	[bug]		Fixed a deadlock that could occur if an rndc
				connection arrived during the shutdown of network
				interfaces. [GL #3272]

	5874.	[placeholder]

	5873.	[bug]		Refactor the fctx_done() function to set fctx to
				NULL after detaching, so that reference counting
				errors will be easier to avoid. [GL #2969]

	5872.	[bug]		udp_recv() in dispatch could trigger an INSIST when the
				callback's result indicated success but the response
				was canceled in the meantime. [GL #3300]

	5871.	[bug]		Fix dig hanging on TLS context creation errors.
				[GL #3285]

	5870.	[cleanup]	Remove redundant macros in the RBT implementation.
				[GL !6158]

	5869.	[func]		Enable use of IP(V6)_RECVERR on Linux that allows
				the kernel to report destination host/network
				unreachable errors to the userspace application.
				[GL #4251]

	5868.	[cleanup]	Use Daniel Lemire's "nearly divisionless" algorithm
				for unbiased bounded random numbers, and move
				re-seeding out of the hot path. [GL !6161]

	5867.	[bug]		Fix assertion failure triggered by attaching to dns_adb
				in dns_adb_createfind() that has been triggered to shut
				down in different thread between the check for shutting
				down condition and the attach to dns_adb. [GL #3298]

	5866.	[bug]		Work around a jemalloc quirk which could trigger an
				out-of-memory condition in named over time. [GL #3287]

	5865.	[func]		Make statistics channel and control channel listen
				on a single network manager thread. [GL !6032]

	5864.	[func]		The OID embedded at the start of a PRIVATEOID public
				key in a KEY, DNSKEY, CDNSKEY, or RKEY RR is now
				checked for validity when reading from wire or from
				zone files, and the OID is printed when
				'dig +rrcomments' is used. Similarly, the name
				embedded at the start of a PRIVATEDNS public key
				is also checked for validity. [GL #3234]

	5863.	[bug]		If there was a pending negative cache DS entry,
				validations depending upon it could fail. [GL #3279]

	5862.	[bug]		dig returned a 0 exit status on UDP connection failure.
				[GL #3235]

	5861.	[func]		Implement support for catalog zones change of ownership
				(coo) mechanism described in the DNS catalog zones draft
				version 5 document. [GL #3223]

	5860.	[func]		Implement support for catalog zones options new syntax
				based on catalog zones custom properties with "ext"
				suffix described in the DNS catalog zones draft version
				5 document. [GL #3222]

	5859.	[bug]		Fix an assertion failure when using dig with +nssearch
				and +tcp options by starting the next query in the
				send_done() callback (like in the UDP mode) instead
				of doing that recursively in start_tcp(). Also
				ensure that queries interrupted while connecting
				are detached properly. [GL #3144]

	5858.	[bug]		Don't remove CDS/CDNSKEY DELETE records on zone sign
				when using 'auto-dnssec maintain;'. [GL #2931]

	5857.	[bug]		Fixed a possible crash during shutdown due to ADB
				entries being unlinked from the hash table too
				soon. [GL #3256]

.. code-block:: none

		--- 9.19.0 released ---

	5856.	[bug]		The "starting maxtime timer" message related to outgoing
				zone transfers was incorrectly logged at the ERROR level
				instead of DEBUG(1). [GL #3208]

	5855.	[bug]		Ensure that zone maintenance queries have a retry limit.
				[GL #3242]

	5854.	[func]		Implement reference counting for TLS contexts and
				allow reloading of TLS certificates on reconfiguration
				without destroying the underlying TCP listener sockets
				for TLS-based DNS transports. [GL #3122]

	5853.	[bug]		When using both the `+qr` and `+y` options `dig` could
				crash if the connection to the first server was not
				successful. [GL #3244]

	5852.	[func]		Add new "reuseport" option to enable/disable load
				balancing of sockets. [GL #3249]

	5851.	[placeholder]

	5850.	[func]		Run the RPZ update process on the offload threads.
				[GL #3190]

	5849.	[cleanup]	Remove use of exclusive mode in ns_interfacemgr in
				favor of rwlocked access to localhost and localnets
				members of dns_aclenv_t structure. [GL #3229]

	5848.	[bug]		dig could hang in some cases involving multiple servers
				in a lookup, when a request fails and the next one
				refuses to start for some reason, for example if it was
				an IPv4 mapped IPv6 address. [GL #3248]

	5847.	[cleanup]	Remove task privileged mode in favor of processing
				all events in the loadzone task in a single run
				by setting the quantum to UINT_MAX. [GL #3253]

	5846.	[func]		In dns_zonemgr, create per-thread task, zonetask, and
				loadtask and pin the zones to individual threads,
				instead of having "many", spreading the zones among
				them and hoping for the best.  This also removes any
				need to dynamically reallocate the pools with memory
				contexts and tasks. [GL #3226]

	5845.	[bug]		Refactor the timer to keep track of posted events
				as to use isc_task_purgeevent() instead of using
				isc_task_purgerange().  The isc_task_purgeevent()
				has been refactored to purge a single event instead
				of walking through the list of posted events.
				[GL #3252]

	5844.	[bug]		dig +nssearch was hanging until manually interrupted.
				[GL #3145]

	5843.	[bug]		When an UPDATE targets a zone that is not configured,
				the requested zone name is now logged in the "not
				authoritative" error message, so that it is easier to
				track down problematic update clients. [GL #3209]

	5842.	[cleanup]	Remove the task exclusive mode use in ns_clientmgr.
				[GL #3230]

	5841.	[bug]		Refactor the address database:
				- Use self-resizing hash tables, eliminating the
				  need to go into task-exclusive mode when resizing.
				- Simplify reference counting of ADB objects
				  and the process for shutting down. [GL #3213]

	5840.	[cleanup]	Remove multiple application context use in dns_client
				unit. [GL !6041]

	5839.	[func]		Add support for remote TLS certificates
				verification, both to BIND and dig, making it possible
				to implement Strict and Mutual TLS authentication,
				as described in RFC 9103, Section 9.3. [GL #3163]

	5838.	[cleanup]	When modifying a member zone in a catalog zone, and it
				is detected that the zone exists and was not created by
				the current catalog zone, distinguish the two cases when
				the zone was not added by a catalog zone at all, and
				when the zone was added by a different catalog zone,
				and log a warning message accordingly. [GL #3221]

	5837.	[func]		Key timing options for `dnssec-keygen` and
				`dnssec-settime` now accept times as printed by
				`dnssec-settime -p`. [GL !2947]

	5836.	[bug]		Quote the dns64 prefix in error messages that complain
				about problems with it, to avoid confusion with the
				following dns64 ACLs. [GL #3210]

	5835.	[cleanup]	Remove extrahandlesize from the netmgr, the callers
				now have to allocate the object before calling
				isc_nm_setdata() and deallocate the memory in the close
				callback passed to isc_nm_setdata(). [GL #3227]

	5834.	[cleanup]	C99 variable-length arrays are difficult to use safely,
				so avoid them except in test code. [GL #3201]

	5833.	[bug]		When encountering socket error while trying to initiate
				a TCP connection to a server, dig could hang
				indefinitely, when there were more servers to try.
				[GL #3205]

	5832.	[bug]		When timing-out or having other types of socket errors
				during a query, dig wasn't trying to perform the lookup
				using other servers, in case they exist. [GL #3128]

	5831.	[bug]		When resending a UDP request in the result of a timeout,
				the recv_done() function in dighost.c was prepending
				the new query into the loookup's queries list instead
				of inserting, which could cause an assertion failure
				when the resent query's result was SERVFAIL. [GL #3020]

	5830.	[func]		Implement incremental resizing of isc_ht hash tables to
				perform the rehashing gradually. The catalog zone
				implementation has been optimized to work with hundreds
				of thousands of member zones. [GL #3212] [GL #3744]

	5829.	[func]		Refactor and simplify isc_timer API in preparation
				for further refactoring on top of network manager
				loops. [GL #3202]

	5828.	[bug]		Replace single TCP write timer with per-TCP write
				timers. [GL #3200]

	5827.	[cleanup]	The command-line utilities printed their version numbers
				inconsistently; they all now print to stdout. (They are
				still inconsistent abotut whether you use `-v` or `-V`
				to request the version). [GL #3189]

	5826.	[cleanup]	Stop dig from complaining about lack of IDN support when
				the user asks for no IDN translation. [GL #3188]

	5825.	[func]		Set the minimum MTU on UDPv6 and TCPv6 sockets and
				limit TCP maximum segment size (TCP_MAXSEG) to (1220)
				for both TCPv4 and TCPv6 sockets. [GL #2201]

	5824.	[bug]		Invalid dnssec-policy definitions were being accepted
				where the defined keys did not cover both KSK and ZSK
				roles for a given algorithm.  This is now checked for
				and the dnssec-policy is rejected if both roles are
				not present for all algorithms in use. [GL #3142]

	5823.	[func]		Replace hazard pointers based lock-free list with
				locked-list based queue that's simpler and has no or
				little performance impact. [GL #3180]

	5822.	[bug]		When calling dns_dispatch_send(), attach/detach
				dns_request_t object as the read callback could
				be called before send callback dereferencing
				dns_request_t object too early. [GL #3105]

	5821.	[bug]		Fix query context management issues in the TCP part
				of dig. [GL #3184]

	5820.	[security]	An assertion could occur in resume_dslookup() if the
				fetch had been shut down earlier. (CVE-2022-0667)
				[GL #3129]

	5819.	[security]	Lookups involving a DNAME could trigger an INSIST when
				"synth-from-dnssec" was enabled. (CVE-2022-0635)
				[GL #3158]

	5818.	[security]	A synchronous call to closehandle_cb() caused
				isc__nm_process_sock_buffer() to be called recursively,
				which in turn left TCP connections hanging in the
				CLOSE_WAIT state blocking indefinitely when
				out-of-order processing was disabled. (CVE-2022-0396)
				[GL #3112]

	5817.	[security]	The rules for acceptance of records into the cache
				have been tightened to prevent the possibility of
				poisoning if forwarders send records outside
				the configured bailiwick. (CVE-2021-25220) [GL #2950]

	5816.	[bug]		Make BIND compile with LibreSSL 3.5.0, as it was using
				not very accurate pre-processor checks for using shims.
				[GL #3172]

	5815.	[bug]		If an oversized key name of a specific length was used
				in the text form of an HTTP or SVBC record, an INSIST
				could be triggered when parsing it. [GL #3175]

	5814.	[bug]		The RecursClients statistics counter could underflow
				in certain resolution scenarios. [GL #3147]

	5813.	[func]		The "keep-response-order" ACL has been declared
				obsolete, and is now non-operational. [GL #3140]

	5812.	[func]		Drop the artificial limit on the number of queries
				processed in a single TCP read callback. [GL #3141]

	5811.	[bug]		Reimplement the maximum and idle timeouts for outgoing
				zone tranfers. [GL #1897]

	5810.	[func]		New option '-J' for dnssec-signzone and dnssec-verify
				allows loading journal files. [GL #2486]

	5809.	[bug]		Reset client TCP connection when data received cannot
				be parsed as a valid DNS request. [GL #3149]

	5808.	[bug]		Certain TCP failures were not caught and handled
				correctly by the dispatch manager, causing
				connections to time out rather than returning
				SERVFAIL. [GL #3133]

	5807.	[bug]		Add a TCP "write" timer, and time out writing
				connections after the "tcp-idle-timeout" period
				has elapsed. [GL #3132]

	5806.	[bug]		An error in checking the "blackhole" ACL could cause
				DNS requests sent by named to fail if the
				destination address or prefix was specifically
				excluded from the ACL. [GL #3157]

	5805.	[func]		The result of each resolver priming attempt is now
				included in the "resolver priming query complete" log
				message. [GL #3139]

	5804.	[func]		Add a debug log message when starting and ending
				the task exclusive mode. [GL #3137]

	5803.	[func]		Use compile-time paths in the documentation.
				[GL #2717]

	5802.	[test]		Add system test to test engine_pkcs11. [GL !5727]

	5801.	[bug]		Log "quota reached" message when hard quota
				is reached when accepting a connection. [GL #3125]

	5800.	[func]		Add ECS support to the DLZ interface. [GL #3082]

	5799.	[bug]		Use L1 cache-line size detected at runtime. [GL #3108]

	5798.	[test]		Add system test to test dnssec-keyfromlabel. [GL #3092]

	5797.	[bug]		A failed view configuration during a named
				reconfiguration procedure could cause inconsistencies
				in BIND internal structures, causing a crash or other
				unexpected errors. [GL #3060]

	5796.	[bug]		Ignore the invalid (<= 0) values returned
				by the sysconf() check for the L1 cache line
				size.  [GL #3108]

	5795.	[bug]		rndc could crash when interrupted by a signal
				before receiving a response. [GL #3080]

	5794.	[func]		Set the IPV6_V6ONLY on all IPv6 sockets to
				restrict the IPv6 sockets to sending and
				receiving IPv6 packets only. [GL #3093]

	5793.	[bug]		Correctly detect and enable UDP recvmmsg support
				in all versions of libuv that support it. [GL #3095]

	5792.	[bug]		Don't schedule zone events on ISC_R_SHUTTINGDOWN
				event failures. [GL #3084]

	5791.	[func]		Remove workaround for servers returning FORMERR
				when receiving NOTIFY query with SOA record in
				ANSWER section. [GL #3086]

	5790.	[bug]		The control channel was incorrectly looking for
				ISC_R_CANCELED as a signal that the named is
				shutting down.  In the dispatch refactoring,
				the result code returned from network manager
				is now ISC_R_SHUTTINGDOWN.  Change the control
				channel code to use ISC_R_SHUTTINGDOWN result
				code to detect named being shut down. [GL #3079]

.. code-block:: none

		--- 9.17.22 released ---

	5789.	[bug]		Allow replacing expired zone signatures with
				signatures created by the KSK. [GL #3049]

	5788.	[bug]		An assertion could occur if a catalog zone event was
				scheduled while the task manager was being shut
				down. [GL #3074]

	5787.	[doc]		Update 'auto-dnssec' documentation, it may only be
				activated at zone level. [GL #3023]

	5786.	[bug]		Defer detaching from zone->raw in zone_shutdown() if
				the zone is in the process of being dumped to disk, to
				ensure that the unsigned serial number information is
				always written in the raw-format header of the signed
				version on an inline-signed zone. [GL #3071]

	5785.	[bug]		named could leak memory when two dnssec-policy clauses
				had the same name. named failed to log this error.
				[GL #3085]

	5784.	[func]		Implement TLS-contexts reuse. Reusing the
				previously created TLS context objects can reduce
				initialisation time for some configurations and enables
				TLS session resumption for incoming zone transfers over
				TLS (XoT). [GL #3067]

	5783.	[func]		named is now able to log TLS pre-master secrets for
				debugging purposes. This requires setting the
				SSLKEYLOGFILE environment variable appropriately.
				[GL #2723]

	5782.	[func]		Use ECDSA P-256 instead of a 4096-bit RSA when
				generating ephemeral key and certificate for the
				'tls ephemeral' configuration. [GL #2264]

	5781.	[bug]		Make BIND work with OpenSSL 3.0.1 as it is now
				enforcing minimum buffer lengths in EVP_MAC_final and
				hence EVP_DigestSignFinal.  rndc and TSIG at a minimum
				were broken by this change. [GL #3057]

	5780.	[bug]		The Linux kernel may send netlink messages
				indicating that network interfaces have changed
				when they have not. This caused frequent unnecessary
				re-scans of the interfaces.  Netlink messages now
				only trigger re-scanning if a new address is seen
				or an existing address is removed. [GL #3055]

	5779.	[test]		Drop cppcheck suppressions and workarounds. [GL #2886]

	5778.	[bug]		Destroyed TLS contexts could have been used after a
				reconfiguration, making BIND unable to serve queries
				over TLS and HTTPS. [GL #3053]

	5777.	[bug]		TCP connections could hang after receiving
				non-matching responses. [GL #3042]

	5776.	[bug]		Add a missing isc_condition_destroy() for nmsocket
				condition variable and add missing isc_mutex_destroy()
				for nmworker lock. [GL #3051]

.. code-block:: none

		--- 9.17.21 released ---

	5775.	[bug]		Added a timer in the resolver to kill fetches that
				have deadlocked as a result of dependency loops
				with the ADB or the validator. This condition is
				now logged with the message "shut down hung fetch
				while resolving '<name>/<type>'". [GL #3040]

	5774.	[func]		Restore NSEC Aggressive Cache ("synth-from-dnssec")
				as active by default. It is limited to NSEC only
				and by default ignores NSEC records with next name
				in form \000.domain. [GL #1265]

	5773.	[func]		Change the message when accepting TCP connection has
				failed to say "Accepting TCP connection failed" and
				change the log level for ISC_R_NOTCONNECTED, ISC_R_QUOTA
				and ISC_R_SOFTQUOTA results codes from ERROR to INFO.
				[GL #2700]

	5772.	[bug]		The resolver could hang on shutdown due to dispatch
				resources not being cleaned up when a TCP connection
				was reset. [GL #3026]

	5771.	[bug]		Use idn2 UseSTD3ASCIIRules=false to disable additional
				unicode validity checks because enabling the additional
				checks would break valid domain names that contains
				non-alphanumerical characters such as underscore
				character (_) or wildcard (*).  This reverts change
				[GL !5738] from the previous release. [GL #1610]

	5770.	[func]		BIND could abort on startup on systems using old
				OpenSSL versions when 'protocols' option is used inside
				a 'tls' statement. [GL !5602]

	5769.	[func]		Added support for client-side 'tls' parameters when
				doing incoming zone transfers via XoT. [GL !5602]

	5768.	[bug]		dnssec-dsfromkey failed to omit revoked keys. [GL #853]

	5767.	[func]		Extend allow-transfer option with 'port' and
				'transport' options to restrict zone transfers to
				a specific port and DNS transport protocol.
				[GL #2776]

	5766.	[func]		Unused 'tls' clause options 'ca-file' and 'hostname'
				were disabled. [GL !5600]

	5765.	[bug]		Fix a bug in DoH implementation making 'dig'
				abort when ALPN negotiation fails. [GL #3022]

	5764.	[bug]		dns_sdlz_putrr failed to process some valid resource
				records. [GL #3021]

	5763.	[bug]		Fix a bug in DoT code leading to an abort when
				a zone transfer ends with an unexpected DNS message.
				[GL #3004]

	5762.	[bug]		Fix a "named" crash related to removing and restoring a
				`catalog-zone` entry in the configuration file and
				running `rndc reconfig`. [GL #1608]

	5761.	[bug]		OpenSSL 3.0.0 support could fail to correctly read
				ECDSA private keys leading to incorrect signatures
				being generated. [GL #3014]

	5760.	[bug]		Prevent a possible use-after-free error in resolver.
				[GL #3018]

	5759.	[func]		Set Extended DNS Error Code 18 - Prohibited if query
				access is denied to the specific client. [GL #1836]

	5758.	[bug]		mdig now honors the operating system's preferred
				ephemeral port range. [GL #2374]

	5757.	[test]		Replace sed in nsupdate system test with awk to
				construct the nsupdate command.  The sed expression
				was not reliably changing the ttl. [GL #3003]

	5756.	[func]		Assign HTTP freshness lifetime to responses sent
				via DNS-over-HTTPS, according to the recommendations
				given in RFC 8484. [GL #2854]

.. code-block:: none

		--- 9.17.20 released ---

	5755.	[bug]		The statistics channel wasn't correctly handling
				multiple HTTP requests, or pipelined or truncated
				requests. [GL #2973]

	5754.	[bug]		"tls" statements may omit "key-file" and "cert-file",
				but if either one is specified, then both must be.
				[GL #2986]

	5753.	[placeholder]

	5752.	[bug]		Fix an assertion failure caused by missing member zones
				during a reload of a catalog zone. [GL #2308]

	5751.	[port]		Add support for OpenSSL 3.0.0.  OpenSSL 3.0.0
				deprecated 'engine' support.  If OpenSSL 3.0.0 has
				been built without support for deprecated functionality
				pkcs11 via engine_pkcs11 is no longer available.
				[GL #2843]

	5750.	[bug]		Fix a bug when comparing two RSA keys. There was a typo
				which caused the "p" prime factors to not being
				compared. [GL #2972]

	5749.	[bug]		Handle duplicate references to the same catalog
				zone gracefully. [GL #2916]

	5748.	[func]		Update "nsec3param" defaults to iterations 0, salt
				length 0. [GL #2956]

	5747.	[func]		Update rndc serve-stale status output to be less
				confusing. [GL #2742]

	5746.	[bug]		A lame server delegation could lead to a loop in which
				a resolver fetch depends on an ADB find which depends
				on the same resolver fetch. Previously, this would
				cause the fetch to hang until timing out, but after
				change #5730 it would hang forever. The condition is
				now detected and avoided. [GL #2927]

	5745.	[bug]		Fetch context objects now use attach/detach
				semantics to make it easier to find and debug
				reference-counting errors, and several such errors
				have been fixed. [GL #2953]

	5744.	[func]		The network manager is now used for netlink sockets
				to monitor network interface changes. This was the
				last remaining use of the old isc_socket and
				isc_socketmgr APIs, so they have now been removed.
				The "named -S" argument and the "reserved-sockets"
				option in named.conf have no function now, and are
				deprecated. "socketmgr" statistics are no longer
				reported in the statistics channel. [GL #2926]

	5743.	[func]		Add finer-grained "update-policy" rules,
				"krb5-subdomain-self-rhs" and "ms-subdomain-self-rhs",
				which restrict SRV and PTR record changes, allowing
				only records whose content matches the machine name
				embedded in the Kerberos principal making the change.
				[GL #481]

	5742.	[func]		ISC_LIKELY() and ISC_UNLIKELY() macros have been
				removed. [GL #2952]

	5741.	[bug]		Log files with "timestamp" suffixes could be left in
				place after rolling, even if the number of preserved
				log files exceeded the configured "versions" limit.
				[GL #828]

	5740.	[func]		Implement incremental resizing of RBT hash table to
				perform the rehashing gradually. [GL #2941]

	5739.	[func]		Change default of 'dnssec-dnskey-kskonly' to 'yes'.
				[GL #1316]

	5738.	[bug]		Enable idn2 UseSTD3ASCIIRules=true to implement
				additional unicode validity checks. [GL #1610]

	5737.	[bug]		Address Coverity warning in lib/dns/dnssec.c.
				[GL #2935]

.. code-block:: none

		--- 9.17.19 released ---

	5736.	[security]	The "lame-ttl" option is now forcibly set to 0. This
				effectively disables the lame server cache, as it could
				previously be abused by an attacker to significantly
				degrade resolver performance. (CVE-2021-25219)
				[GL #2899]

	5735.	[cleanup]	The result codes which BIND 9 uses internally are now
				all defined as a single list of enum values rather than
				as multiple sets of integers scattered around shared
				libraries. This prevents the need for locking in some
				functions operating on result codes, and makes result
				codes more debugger-friendly. [GL #719]

	5734.	[bug]		Fix intermittent assertion failures in dig which were
				triggered during zone transfers. [GL #2884]

	5733.	[func]		Require the "dot" Application-Layer Protocol Negotiation
				(ALPN) token to be selected in the TLS handshake for
				zone transfers over TLS (XoT), as required by RFC 9103
				section 7.1. [GL #2794]

	5732.	[cleanup]	Remove the dns_lib_init(), dns_lib_shutdown(),
				ns_lib_init(), and ns_lib_shutdown() functions, as they
				no longer served any useful purpose. [GL #88]

	5731.	[bug]		Disallow defining "http" configuration clauses called
				"default" as they were silently ignored. [GL #2925]

	5730.	[func]		The resolver and the request and dispatch managers have
				been substantially refactored, and are now based on the
				network manager instead of the old isc_socket API. All
				outgoing DNS queries and requests now use the new API;
				isc_socket is only used to monitor for network interface
				changes. [GL #2401]

	5729.	[func]		Allow finer control over TLS protocol configuration by
				implementing new options for "tls" configuration clauses
				("dhparam-file", "ciphers", "prefer-server-ciphers",
				"session-tickets"). These options make achieving perfect
				forward secrecy (PFS) possible for DNS-over-TLS (DoT)
				and DNS-over-HTTPS (DoH). [GL #2796]

	5728.	[func]		Allow specifying supported TLS protocol versions for
				each "tls" configuration clause. [GL #2795]

	5727.	[placeholder]

	5726.	[bug]		Fix a use-after-free bug which was triggered while
				checking for duplicate "http" configuration clauses.
				[GL #2924]

	5725.	[bug]		Fix an assertion failure triggered by passing an invalid
				HTTP path to dig. [GL #2923]

	5724.	[bug]		Address a potential deadlock when checking zone content
				consistency. [GL #2908]

	5723.	[bug]		Change 5709 broke backward compatibility for the
				"check-names master ..." and "check-names slave ..."
				options. This has been fixed. [GL #2911]

	5722.	[bug]		Preserve the contents of the receive buffer for TCPDNS
				and TLSDNS when growing its size. [GL #2917]

	5721.	[func]		A new realloc()-like function, isc_mem_reget(), was
				added to the libisc API for resizing memory chunks
				allocated using isc_mem_get(). Memory (re)allocation
				functions are now guaranteed to return non-NULL pointers
				for zero-sized allocation requests. [GL !5440]

	5720.	[contrib]	Remove old-style DLZ drivers that had to be enabled at
				build time. [GL #2814]

	5719.	[func]		Remove support for the "map" zone file format.
				[GL #2882]

	5718.	[bug]		The "sig-signing-type" zone configuration option was
				processed incorrectly, causing valid configurations to
				be rejected. This has been fixed. [GL #2906]

	5717.	[func]		The "cache-file" option, which was documented as "for
				testing purposes only" and not to be used, has been
				removed. [GL #2903]

	5716.	[placeholder]

	5715.	[func]		Add a check for ports specified in "*-source(-v6)"
				options clashing with a global listening port. Such a
				configuration was already unsupported, but it failed
				silently; it is now treated as an error. [GL #2888]

	5714.	[bug]		Remove the "adjust interface" mechanism which was
				responsible for setting up listeners on interfaces when
				the "*-source(-v6)" address and port were the same as
				the "listen-on(-v6)" address and port. Such a
				configuration is no longer supported; under certain
				timing conditions, that mechanism could prevent named
				from listening on some TCP ports. This has been fixed.
				[GL #2852]

	5713.	[func]		Add "primaries" as a synonym for "masters" and
				"default-primaries" as a synonym for "default-masters"
				in catalog zone configuration options. [GL #2818]

	5712.	[func]		Remove native PKCS#11 support in favor of engine_pkcs11
				from the OpenSC project. [GL #2691]

.. code-block:: none

		--- 9.17.18 released ---

	5711.	[bug]		"map" files exceeding 2GB in size failed to load due to
				a size comparison that incorrectly treated the file size
				as a signed integer. [GL #2878]

	5710.	[placeholder]

	5709.	[func]		When reporting zone types in the statistics channel, the
				terms "primary" and "secondary" are now used instead of
				"master" and "slave", respectively. Enum values
				throughout the code have been updated to use this
				terminology as well. [GL #1944]

	5708.	[placeholder]

	5707.	[bug]		A bug was fixed which prevented dig from querying
				DNS-over-HTTPS (DoH) servers via IPv6. [GL #2860]

	5706.	[cleanup]	Support for external applications to register with
				libisc and use it has been removed. Export versions of
				BIND 9 libraries have not been supported for some time,
				but the isc_lib_register() function was still available;
				it has now been removed. [GL !2420]

	5705.	[bug]		Change #5686 altered the internal memory structure of
				zone databases, but neglected to update the MAPAPI value
				for zone files in "map" format. This caused named to
				attempt to load incompatible map files, triggering an
				assertion failure on startup. The MAPAPI value has now
				been updated, so named rejects outdated files when
				encountering them. [GL #2872]

	5704.	[bug]		Change #5317 caused the EDNS TCP Keepalive option to be
				ignored inadvertently in client requests. It has now
				been fixed and this option is handled properly again.
				[GL #1927]

	5703.	[bug]		Fix a crash in dig caused by closing an HTTP/2 socket
				associated with an unused HTTP/2 session. [GL #2858]

	5702.	[bug]		Improve compatibility with DNS-over-HTTPS (DoH) clients
				by allowing HTTP/2 request headers in any order.
				[GL #2875]

	5701.	[bug]		named-checkconf failed to detect syntactically invalid
				values of the "key" and "tls" parameters used to define
				members of remote server lists. [GL #2461]

	5700.	[bug]		When a member zone was removed from a catalog zone,
				journal files for the former were not deleted.
				[GL #2842]

	5699.	[func]		Data structures holding DNSSEC signing statistics are
				now grown and shrunk as necessary upon key rollover
				events. [GL #1721]

	5698.	[bug]		When a DNSSEC-signed zone which only has a single
				signing key available is migrated to use KASP, that key
				is now treated as a Combined Signing Key (CSK).
				[GL #2857]

	5697.	[func]		dnssec-cds now only generates SHA-2 DS records by
				default and avoids copying deprecated SHA-1 records from
				a child zone to its delegation in the parent. If the
				child zone does not publish SHA-2 CDS records,
				dnssec-cds will generate them from the CDNSKEY records.
				The "-a algorithm" option now affects the process of
				generating DS digest records from both CDS and CDNSKEY
				records. Thanks to Tony Finch. [GL #2871]

	5696.	[protocol]	Support for HTTPS and SVCB record types has been added.
				[GL #1132]

	5695.	[func]		Add a new dig command-line option, "+showbadcookie",
				which causes a BADCOOKIE response message to be
				displayed when it is received from the server.
				[GL #2319]

	5694.	[bug]		Stale data in the cache could cause named to send
				non-minimized queries despite QNAME minimization being
				enabled. [GL #2665]

	5693.	[func]		Restore support for reading "timeout" and "attempts"
				options from /etc/resolv.conf, and use their values in
				dig, host, and nslookup. (This was previously supported
				by liblwres, and was still mentioned in the man pages,
				but had stopped working after liblwres was deprecated in
				favor of libirs.) [GL #2785]

	5692.	[bug]		Fix a rare crash in DNS-over-HTTPS (DoH) code caused by
				detaching from an HTTP/2 session handle too early when
				sending data. [GL #2851]

	5691.	[bug]		When a dynamic zone was made available in another view
				using the "in-view" statement, running "rndc freeze"
				always reported an "already frozen" error even though
				the zone was successfully frozen. [GL #2844]

	5690.	[func]		dnssec-signzone now honors Predecessor and Successor
				metadata found in private key files: if a signature for
				an RRset generated by the inactive predecessor exists
				and does not need to be replaced, no additional
				signature is now created for that RRset using the
				successor key. This enables dnssec-signzone to gradually
				replace RRSIGs during a ZSK rollover. [GL #1551]

.. code-block:: none

		--- 9.17.17 released ---

	5689.	[security]	An assertion failure occurred when named attempted to
				send a UDP packet that exceeded the MTU size, if
				Response Rate Limiting (RRL) was enabled.
				(CVE-2021-25218) [GL #2856]

	5688.	[bug]		Zones using KASP and inline-signed zones failed to apply
				changes from the unsigned zone to the signed zone under
				certain circumstances. This has been fixed. [GL #2735]

	5687.	[bug]		"rndc reload <zonename>" could trigger a redundant
				reload for an inline-signed zone whose zone file was not
				modified since the last "rndc reload". This has been
				fixed. [GL #2855]

	5686.	[func]		The number of internal data structures allocated for
				each zone was reduced. [GL #2829]

	5685.	[bug]		named failed to check the opcode of responses when
				performing zone refreshes, stub zone updates, and UPDATE
				forwarding. This has been fixed. [GL #2762]

	5684.	[func]		The DNS-over-HTTP (DoH) configuration syntax was
				extended:
				- The maximum number of active DoH connections can now
				  be set using the "http-listener-clients" option. The
				  default is 300.
				- The maximum number of concurrent HTTP/2 streams per
				  connection can now be set using the
				  "http-streams-per-connection" option. The default is
				  100.
				- Both of these values can also be set on a per-listener
				  basis using the "listener-clients" and
				  "streams-per-connection" parameters in an "http"
				  statement.
				[GL #2809]

	5683.	[bug]		The configuration-checking code now verifies HTTP paths.
				[GL !5231]

	5682.	[bug]		Some changes to "zone-statistics" settings were not
				properly processed by "rndc reconfig". This has been
				fixed. [GL #2820]

	5681.	[func]		Relax the checks in the dns_zone_cdscheck() function to
				allow CDS and CDNSKEY records in the zone that do not
				match an existing DNSKEY record, as long as the
				algorithm matches. This allows a clean rollover from one
				provider to another in a multi-signer DNSSEC
				configuration. [GL #2710]

	5680.	[bug]		HTTP GET requests without query strings caused a crash
				in DoH code. This has been fixed. [GL !5268]

	5679.	[func]		Thread affinity is no longer set. [GL #2822]

	5678.	[bug]		The "check DS" code failed to release all resources upon
				named shutdown when a refresh was in progress. This has
				been fixed. [GL #2811]

	5677.	[func]		Previously, named accepted FORMERR responses both with
				and without an OPT record, as an indication that a given
				server did not support EDNS. To implement full
				compliance with RFC 6891, only FORMERR responses without
				an OPT record are now accepted. This intentionally
				breaks communication with servers that do not support
				EDNS and that incorrectly echo back the query message
				with the RCODE field set to FORMERR and the QR bit set
				to 1. [GL #2249]

	5676.	[func]		Memory allocation has been substantially refactored; it
				is now based on the memory allocation API provided by
				the jemalloc library, which is a new optional build
				dependency for BIND 9. [GL #2433]

	5675.	[bug]		Compatibility with DoH clients has been improved by
				ignoring the value of the "Accept" HTTP header.
				[GL !5246]

	5674.	[bug]		A shutdown hang was triggered by DoH clients prematurely
				aborting HTTP/2 streams. This has been fixed. [GL !5245]

	5673.	[func]		Add a new build-time option, --disable-doh, to allow
				building BIND 9 without the libnghttp2 library.
				[GL #2478]

	5672.	[bug]		Authentication of rndc messages could fail if a
				"controls" statement was configured with multiple key
				algorithms for the same listener. This has been fixed.
				[GL #2756]

.. code-block:: none

		--- 9.17.16 released ---

	5671.	[bug]		A race condition could occur where two threads were
				competing for the same set of key file locks, leading to
				a deadlock. This has been fixed. [GL #2786]

	5670.	[bug]		create_keydata() created an invalid placeholder keydata
				record upon a refresh failure, which prevented the
				database of managed keys from subsequently being read
				back. This has been fixed. [GL #2686]

	5669.	[func]		KASP support was extended with the "check DS" feature.
				Zones with "dnssec-policy" and "parental-agents"
				configured now check for DS presence and can perform
				automatic KSK rollovers. [GL #1126]

	5668.	[bug]		Rescheduling a setnsec3param() task when a zone failed
				to load on startup caused a hang on shutdown. This has
				been fixed. [GL #2791]

	5667.	[bug]		The configuration-checking code failed to account for
				the inheritance rules of the "dnssec-policy" option.
				This has been fixed. [GL #2780]

	5666.	[doc]		The safe "edns-udp-size" value was tweaked to match the
				probing value from BIND 9.16 for better compatibility.
				[GL #2183]

	5665.	[bug]		If nsupdate sends an SOA request and receives a REFUSED
				response, it now fails over to the next available
				server. [GL #2758]

	5664.	[func]		For UDP messages larger than the path MTU, named now
				sends an empty response with the TC (TrunCated) bit set.
				In addition, setting the DF (Don't Fragment) flag on
				outgoing UDP sockets was re-enabled. [GL #2790]

	5663.	[bug]		Non-zero OPCODEs are now properly handled when receiving
				queries over DNS-over-TLS (DoT) and DNS-over-HTTPS (DoH)
				channels. [GL #2787]

	5662.	[bug]		Views with recursion disabled are now configured with a
				default cache size of 2 MB unless "max-cache-size" is
				explicitly set. This prevents cache RBT hash tables from
				being needlessly preallocated for such views. [GL #2777]

	5661.	[bug]		Change 5644 inadvertently introduced a deadlock: when
				locking the key file mutex for each zone structure in a
				different view, the "in-view" logic was not considered.
				This has been fixed. [GL #2783]

	5660.	[bug]		The configuration-checking code failed to account for
				the inheritance rules of the "key-directory" option.
				[GL #2778]

				This change was included in BIND 9.17.15.

	5659.	[bug]		When preparing DNS responses, named could replace the
				letters 'W' (uppercase) and 'w' (lowercase) with '\000'.
				This has been fixed. [GL #2779]

				This change was included in BIND 9.17.15.

	5658.	[bug]		Increasing "max-cache-size" for a running named instance
				(using "rndc reconfig") did not cause the hash tables
				used by cache databases to be grown accordingly. This
				has been fixed. [GL #2770]

	5657.	[cleanup]	Support was removed for both built-in atomics in old
				versions of Clang (< 3.6.0) and GCC (< 4.7.0), and
				atomics emulated with a mutex. [GL #2606]

	5656.	[bug]		Named now ensures that large responses work correctly
				over DNS-over-HTTPS (DoH), and that zone transfer
				requests over DoH are explicitly rejected. [GL !5148]

	5655.	[bug]		Signed, insecure delegation responses prepared by named
				either lacked the necessary NSEC records or contained
				duplicate NSEC records when both wildcard expansion and
				CNAME chaining were required to prepare the response.
				This has been fixed. [GL #2759]

	5654.	[port]		Windows support has been removed. [GL #2690]

	5653.	[bug]		A bug that caused the NSEC3 salt to be changed on every
				restart for zones using KASP has been fixed. [GL #2725]

.. code-block:: none

		--- 9.17.14 released ---

	5652.	[bug]		A copy-and-paste error in change 5584 caused the
				IP_DONTFRAG socket option to be enabled instead of
				disabled. This has been fixed. [GL #2746]

	5651.	[func]		Refactor zone dumping to be processed asynchronously via
				the uv_work_t thread pool API. [GL #2732]

	5650.	[bug]		Prevent a crash that could occur if serve-stale was
				enabled and a prefetch was triggered during a query
				restart. [GL #2733]

	5649.	[bug]		If a query was answered with stale data on a server with
				DNS64 enabled, an assertion could occur if a non-stale
				answer arrived afterward. [GL #2731]

	5648.	[bug]		The calculation of the estimated IXFR transaction size
				in dns_journal_iter_init() was invalid. [GL #2685]

	5647.	[func]		The interface manager has been refactored to use fewer
				client manager objects, which in turn use fewer memory
				contexts and tasks. This should result in less
				fragmented memory and better startup performance.
				[GL #2433]

	5646.	[bug]		The default TCP timeout for rndc has been increased to
				60 seconds. This was its original value, but it had been
				inadvertently lowered to 10 when rndc was updated to use
				the network manager. [GL #2643]

	5645.	[cleanup]	Remove the rarely-used dns_name_copy() function and
				rename dns_name_copynf() to dns_name_copy(). [GL !5081]

	5644.	[bug]		Fix a race condition in reading and writing key files
				for zones using KASP and configured in multiple views.
				[GL #1875]

	5643.	[placeholder]

	5642.	[bug]		Zones which are configured in multiple views with
				different values set for "dnssec-policy" and with
				identical values set for "key-directory" are now
				detected and treated as a configuration error.
				[GL #2463]

	5641.	[bug]		Address a potential memory leak in
				dst_key_fromnamedfile(). [GL #2689]

	5640.	[func]		Add new configuration options for setting the size of
				receive and send buffers in the operating system:
				"tcp-receive-buffer", "tcp-send-buffer",
				"udp-receive-buffer", and "udp-send-buffer". [GL #2313]

	5639.	[bug]		Check that the first and last SOA record of an AXFR are
				consistent. [GL #2528]

.. code-block:: none

		--- 9.17.13 released ---

	5638.	[bug]		Improvements related to network manager/task manager
				integration:
				- isc_managers_create() and isc_managers_destroy()
				  functions were added to handle setup and teardown of
				  netmgr, taskmgr, timermgr, and socketmgr, since these
				  require a precise order of operations now.
				- Event queue processing is now quantized to prevent
				  infinite looping.
				- The netmgr can now be paused from within a netmgr
				  thread.
				- Deadlocks due to a conflict between netmgr's
				  pause/resume and listen/stoplistening operations were
				  fixed.
				[GL #2654]

	5637.	[placeholder]

	5636.	[bug]		named and named-checkconf did not report an error when
				multiple zones with the "dnssec-policy" option set were
				using the same zone file. This has been fixed.
				[GL #2603]

	5635.	[bug]		Journal compaction could fail when a journal with
				invalid transaction headers was not detected at startup.
				This has been fixed. [GL #2670]

	5634.	[bug]		If "dnssec-policy" was active and a private key file was
				temporarily offline during a rekey event, named could
				incorrectly introduce replacement keys and break a
				signed zone. This has been fixed. [GL #2596]

	5633.	[doc]		The "inline-signing" option was incorrectly described as
				being inherited from the "options"/"view" levels and was
				incorrectly accepted at those levels without effect.
				This has been fixed. [GL #2536]

	5632.	[func]		Add a new built-in KASP, "insecure", which is used to
				transition a zone from a signed to an unsigned state.
				The existing built-in KASP "none" should no longer be
				used to unsign a zone. [GL #2645]

	5631.	[protocol]	Update the implementation of the ZONEMD RR type to match
				RFC 8976. [GL #2658]

	5630.	[func]		Treat DNSSEC responses containing NSEC3 records with
				iteration counts greater than 150 as insecure.
				[GL #2445]

	5629.	[func]		Reduce the maximum supported number of NSEC3 iterations
				that can be configured for a zone to 150. [GL #2642]

	5628.	[bug]		Host and nslookup could crash upon receiving a SERVFAIL
				response. This has been fixed. [GL #2564]

	5627.	[bug]		RRSIG(SOA) RRsets placed anywhere other than at the zone
				apex were triggering infinite resigning loops. This has
				been fixed. [GL #2650]

	5626.	[bug]		When generating zone signing keys, KASP now also checks
				for key ID conflicts among newly created keys, rather
				than just between new and existing ones. [GL #2628]

	5625.	[bug]		A deadlock could occur when multiple "rndc addzone",
				"rndc delzone", and/or "rndc modzone" commands were
				invoked simultaneously for different zones. This has
				been fixed. [GL #2626]

	5624.	[func]		Task manager events are now processed inside network
				manager loops. The task manager no longer needs its own
				set of worker threads, which improves resolver
				performance. [GL #2638]

	5623.	[bug]		When named was shut down during an ongoing zone
				transfer, xfrin_fail() could incorrectly be called
				twice. This has been fixed. [GL #2630]

	5622.	[cleanup]	The lib/samples/ directory has been removed, as export
				versions of libraries are no longer maintained.
				[GL !4835]

	5621.	[placeholder]

	5620.	[bug]		If zone journal files written by BIND 9.16.11 or earlier
				were present when BIND was upgraded, the zone file for
				that zone could have been inadvertently rewritten with
				the current zone contents. This caused the original zone
				file structure (e.g. comments, $INCLUDE directives) to
				be lost, although the zone data itself was preserved.
				This has been fixed. [GL #2623]

	5619.	[protocol]	Implement draft-vandijk-dnsop-nsec-ttl, updating the
				protocol such that NSEC(3) TTL values are set to the
				minimum of the SOA MINIMUM value or the SOA TTL.
				[GL #2347]

	5618.	[bug]		Change 5149 introduced some inconsistencies in the way
				record TTLs were presented in cache dumps. These
				inconsistencies have been eliminated. [GL #389]
				[GL #2289]

.. code-block:: none

		--- 9.17.12 released ---

	5617.	[placeholder]

	5616.	[security]	named crashed when a DNAME record placed in the ANSWER
				section during DNAME chasing turned out to be the final
				answer to a client query. (CVE-2021-25215) [GL #2540]

	5615.	[security]	Insufficient IXFR checks could result in named serving a
				zone without an SOA record at the apex, leading to a
				RUNTIME_CHECK assertion failure when the zone was
				subsequently refreshed. This has been fixed by adding an
				owner name check for all SOA records which are included
				in a zone transfer. (CVE-2021-25214) [GL #2467]

	5614.	[bug]		Ensure all resources are properly cleaned up when a call
				to gss_accept_sec_context() fails. [GL #2620]

	5613.	[bug]		It was possible to write an invalid transaction header
				in the journal file for a managed-keys database after
				upgrading. This has been fixed. Invalid headers in
				existing journal files are detected and named is able
				to recover from them. [GL #2600]

	5612.	[bug]		Continued refactoring of the network manager:
				- allow recovery from read and connect timeout events,
				- ensure that calls to isc_nm_*connect() always
				  return the connection status via a callback
				  function.
				[GL #2401]

	5611.	[func]		Set "stale-answer-client-timeout" to "off" by default.
				[GL #2608]

	5610.	[bug]		Prevent a crash which could happen when a lookup
				triggered by "stale-answer-client-timeout" was attempted
				right after recursion for a client query finished.
				[GL #2594]

	5609.	[func]		The ISC implementation of SPNEGO was removed from BIND 9
				source code. It was no longer necessary as all major
				contemporary Kerberos/GSSAPI libraries include support
				for SPNEGO. [GL #2607]

	5608.	[bug]		When sending queries over TCP, dig now properly handles
				"+tries=1 +retry=0" by not retrying the connection when
				the remote server closes the connection prematurely.
				[GL #2490]

	5607.	[bug]		As "rndc dnssec -checkds" and "rndc dnssec -rollover"
				commands may affect the next scheduled key event,
				reconfiguration of zone keys is now triggered after
				receiving either of these commands to prevent
				unnecessary key rollover delays. [GL #2488]

	5606.	[bug]		CDS/CDNSKEY DELETE records are now removed when a zone
				transitions from a secure to an insecure state.
				named-checkzone also no longer reports an error when
				such records are found in an unsigned zone. [GL #2517]

	5605.	[bug]		"dig -u" now uses the CLOCK_REALTIME clock source for
				more accurate time reporting. [GL #2592]

	5604.	[experimental]	A "filter-a.so" plugin, which is similar to the
				"filter-aaaa.so" plugin but which omits A records
				instead of AAAA records, has been added. Thanks to
				GitLab user @treysis. [GL #2585]

	5603.	[placeholder]

	5602.	[bug]		Fix TCPDNS and TLSDNS timers in Network Manager. This
				makes the "tcp-initial-timeout" and "tcp-idle-timeout"
				options work correctly again. [GL #2583]

	5601.	[bug]		Zones using KASP could not be thawed after they were
				frozen using "rndc freeze". This has been fixed.
				[GL #2523]

	5600.	[bug]		Send a full certificate chain instead of just the leaf
				certificate to DNS-over-TLS (DoT) and DNS-over-HTTPS
				(DoH) clients. This makes BIND 9 DoT/DoH servers
				compatible with a broader set of clients. [GL #2514]

	5599.	[bug]		Fix a named crash which occurred after skipping a
				primary server while transferring a zone over TLS.
				[GL #2562]

	5598.	[port]		Silence -Wchar-subscripts compiler warnings triggered on
				some platforms due to calling character classification
				functions declared in the <ctype.h> header with
				arguments of type char. [GL #2567]

.. code-block:: none

		--- 9.17.11 released ---

	5597.	[bug]		When serve-stale was enabled and starting the recursive
				resolution process for a query failed, a named instance
				could crash if it was configured as both a recursive and
				authoritative server. This problem was introduced by
				change 5573 and has now been fixed. [GL #2565]

	5596.	[func]		Client-side support for DNS-over-HTTPS (DoH) has been
				added to dig. "dig +https" can now query a server via
				HTTP/2. [GL #1641]

	5595.	[cleanup]	Public header files for BIND 9 libraries no longer
				directly include third-party library headers. This
				prevents the need to include paths to third-party header
				files in CFLAGS whenever BIND 9 public header files are
				used, which could cause build-time issues on hosts with
				older versions of BIND 9 installed. [GL #2357]

	5594.	[bug]		Building with --enable-dnsrps --enable-dnsrps-dl failed.
				[GL #2298]

	5593.	[bug]		Journal files written by older versions of named can now
				be read when loading zones, so that journal
				incompatibility does not cause problems on upgrade.
				Outdated journals are updated to the new format after
				loading. [GL #2505]

	5592.	[bug]		Prevent hazard pointer table overflows on machines with
				many cores, by allowing the thread IDs (serving as
				indices into hazard pointer tables) of finished threads
				to be reused by those created later. [GL #2396]

	5591.	[bug]		Fix a crash that occurred when
				"stale-answer-client-timeout" was triggered without any
				(stale) data available in the cache to answer the query.
				[GL #2503]

	5590.	[bug]		NSEC3 records were not immediately created for dynamic
				zones using NSEC3 with "dnssec-policy", resulting in
				such zones going bogus. Add code to process the
				NSEC3PARAM queue at zone load time so that NSEC3 records
				for such zones are created immediately. [GL #2498]

	5589.	[placeholder]

	5588.	[func]		Add a new "purge-keys" option for "dnssec-policy". This
				option determines the period of time for which key files
				are retained after they become obsolete. [GL #2408]

	5587.	[bug]		A standalone libtool script no longer needs to be
				present in PATH to build BIND 9 from a source tarball
				prepared using "make dist". [GL #2504]

	5586.	[bug]		An invalid direction field in a LOC record resulted in
				an INSIST failure when a zone file containing such a
				record was loaded. [GL #2499]

	5585.	[func]		Memory contexts and memory pool implementations were
				refactored to reduce lock contention for shared memory
				contexts by replacing mutexes with atomic operations.
				The internal memory allocator was simplified so that it
				is only a thin wrapper around the system allocator. This
				change made the "-M external" named option redundant and
				it was therefore removed. [GL #2433]

	5584.	[bug]		No longer set the IP_DONTFRAG option on UDP sockets, to
				prevent dropping outgoing packets exceeding
				"max-udp-size". [GL #2466]

	5583.	[func]		Changes to DNS-over-HTTPS (DoH) configuration syntax:
				- When "http" is specified in "listen-on" or
				  "listen-on-v6" statements, "tls" must also now be
				  specified. If an unencrypted connection is desired
				  (for example, when running behind a reverse proxy),
				  use "tls none".
				- "http default" can now be specified in "listen-on" and
				  "listen-on-v6" statements to use the default HTTP
				  endpoint of "/dns-query". It is no longer necessary to
				  include an "http" statement in named.conf unless
				  overriding this value.
				[GL #2472]

	5582.	[bug]		BIND 9 failed to build when static OpenSSL libraries
				were used and the pkg-config files for libssl and/or
				libcrypto were unavailable. This has been fixed by
				ensuring that the correct linking order for libssl and
				libcrypto is always used. [GL #2402]

	5581.	[bug]		Fix a memory leak that occurred when inline-signed zones
				were added to the configuration, followed by a
				reconfiguration of named. [GL #2041]

	5580.	[test]		The system test framework no longer differentiates
				between SKIPPED and UNTESTED system test results. Any
				system test which is not run is now marked as SKIPPED.
				[GL !4517]

	5579.	[bug]		If an invalid key name (e.g. "a..b") was specified in a
				primaries list in named.conf, the wrong size was passed
				to isc_mem_put(), resulting in the returned memory being
				put on the wrong free list. This prevented named from
				starting up. [GL #2460]

.. code-block:: none

		--- 9.17.10 released ---

	5578.	[protocol]	Make "check-names" accept A records below "_spf",
				"_spf_rate", and "_spf_verify" labels in order to cater
				for the "exists" SPF mechanism specified in RFC 7208
				section 5.7 and appendix D.1. [GL #2377]

	5577.	[bug]		Fix the "three is a crowd" key rollover bug in KASP by
				correctly implementing Equation (2) of the "Flexible and
				Robust Key Rollover" paper. [GL #2375]

	5576.	[experimental]	Initial server-side implementation of DNS-over-HTTPS
				(DoH). Support for both TLS-encrypted and unencrypted
				HTTP/2 connections has been added to the network manager
				and integrated into named. (Note: there is currently no
				client-side support for DNS-over-HTTPS; this will be
				added to dig in a future release.) [GL #1144]

	5575.	[bug]		When migrating to KASP, BIND 9 considered keys with the
				"Inactive" and/or "Delete" timing metadata to be
				possible active keys. This has been fixed. [GL #2406]

	5574.	[func]		Incoming zone transfers can now use TLS. Addresses in a
				"primaries" list take an optional "tls" argument,
				specifying either a previously configured "tls" block or
				"ephemeral"; SOA queries and zone transfer requests are
				then sent via TLS. [GL #2392]

	5573.	[func]		When serve-stale is enabled and stale data is available,
				named now returns stale answers upon encountering any
				unexpected error in the query resolution process.
				However, the "stale-refresh-time" window is still only
				started upon a timeout. [GL #2434]

	5572.	[bug]		Address potential double free in generatexml().
				[GL #2420]

	5571.	[bug]		named failed to start when its configuration included a
				zone with a non-builtin "allow-update" ACL attached.
				[GL #2413]

	5570.	[bug]		Improve performance of the DNSSEC verification code by
				reducing the number of repeated calls to
				dns_dnssec_keyfromrdata(). [GL #2073]

	5569.	[bug]		Emit useful error message when "rndc retransfer" is
				applied to a zone of inappropriate type. [GL #2342]

	5568.	[bug]		Fixed a crash in "dnssec-keyfromlabel" when using ECDSA
				keys. [GL #2178]

	5567.	[bug]		Dig now reports unknown dash options while pre-parsing
				the options. This prevents "-multi" instead of "+multi"
				from reporting memory usage before ending option parsing
				with "Invalid option: -lti". [GL #2403]

	5566.	[func]		Add "stale-answer-client-timeout" option, which is the
				amount of time a recursive resolver waits before
				attempting to answer the query using stale data from
				cache. [GL #2247]

	5565.	[func]		The SONAMEs for BIND 9 libraries now include the current
				BIND 9 version number, in an effort to tightly couple
				internal libraries with a specific release. [GL #2387]

	5564.	[cleanup]	Network manager's TLSDNS module was refactored to use
				libuv and libssl directly instead of a stack of TCP/TLS
				sockets. [GL #2335]

	5563.	[cleanup]	Changed several obsolete configuration options to
				ancient, making them fatal errors. Also cleaned up the
				number of clause flags in the configuration parser.
				[GL #1086]

	5562.	[placeholder]

	5561.	[bug]		KASP incorrectly set signature validity to the value of
				the DNSKEY signature validity. This is now fixed.
				[GL #2383]

	5560.	[func]		The default value of "max-stale-ttl" has been changed
				from 12 hours to 1 day and the default value of
				"stale-answer-ttl" has been changed from 1 second to 30
				seconds, following RFC 8767 recommendations. [GL #2248]

.. code-block:: none

		--- 9.17.9 released ---

	5559.	[bug]		The --with-maxminddb=PATH form of the build-time option
				enabling support for libmaxminddb was not working
				correctly. This has been fixed. [GL #2366]

	5558.	[bug]		Asynchronous hook modules could trigger an assertion
				failure when the fetch handle was detached too late.
				Thanks to Jinmei Tatuya at Infoblox. [GL #2379]

	5557.	[bug]		Prevent RBTDB instances from being destroyed by multiple
				threads at the same time. [GL #2317]

	5556.	[bug]		Further tweak newline printing in dnssec-signzone and
				dnssec-verify. [GL #2359]

	5555.	[placeholder]

	5554.	[bug]		dnssec-signzone and dnssec-verify were missing newlines
				between log messages. [GL #2359]

	5553.	[bug]		When reconfiguring named, removing "auto-dnssec" did not
				turn off DNSSEC maintenance. [GL #2341]

	5552.	[func]		When switching to "dnssec-policy none;", named now
				permits a safe transition to insecure mode and publishes
				the CDS and CDNSKEY DELETE records, as described in RFC
				8078. [GL #1750]

	5551.	[bug]		named no longer attempts to assign threads to CPUs
				outside the CPU affinity set. Thanks to Ole Bjørn
				Hessen. [GL #2245]

	5550.	[func]		dnssec-signzone and named now log a warning when falling
				back to the "increment" SOA serial method. [GL #2058]

	5549.	[protocol]	ipv4only.arpa is now served when DNS64 is configured.
				[GL #385]

	5548.	[placeholder]

	5547.	[placeholder]

.. code-block:: none

		--- 9.17.8 released ---

	5546.	[placeholder]

	5545.	[func]		OS support for load-balanced sockets is no longer
				required to receive incoming queries in multiple netmgr
				threads. [GL #2137]

	5544.	[func]		Restore the default value of "nocookie-udp-size" to 4096
				bytes. [GL #2250]

	5543.	[bug]		Fix UDP performance issues caused by making netmgr
				callbacks asynchronous-only. [GL #2320]

	5542.	[bug]		Refactor netmgr. [GL #1920] [GL #2034] [GL #2061]
				[GL #2194] [GL #2221] [GL #2266] [GL #2283] [GL #2318]
				[GL #2321]

	5541.	[func]		Adjust the "max-recursion-queries" default from 75 to
				100. [GL #2305]

	5540.	[port]		Fix building with native PKCS#11 support for AEP Keyper.
				[GL #2315]

	5539.	[bug]		Tighten handling of missing DNS COOKIE responses over
				UDP by falling back to TCP. [GL #2275]

	5538.	[func]		Add NSEC3 support to KASP. A new option for
				"dnssec-policy", "nsec3param", can be used to set the
				desired NSEC3 parameters. NSEC3 salt collisions are
				automatically prevented during resalting. Salt
				generation is now logged with zone context. [GL #1620]

	5537.	[func]		The query plugin mechanism has been extended
				to support asynchronous operations. For example, a
				plugin can now trigger recursion and resume
				processing when it is complete. Thanks to Jinmei
				Tatuya at Infoblox. [GL #2141]

	5536.	[func]		Dig can now report the DNS64 prefixes in use
				(+dns64prefix). [GL #1154]

	5535.	[bug]		dig/nslookup/host could crash on shutdown after an
				interrupt. [GL #2287] [GL #2288]

	5534.	[bug]		The CNAME synthesized from a DNAME was incorrectly
				followed when the QTYPE was CNAME or ANY. [GL #2280]

.. code-block:: none

		--- 9.17.7 released ---

	5533.	[func]		Add the "stale-refresh-time" option, a time window that
				starts after a failed lookup, during which a stale RRset
				is served directly from cache before a new attempt to
				refresh it is made. [GL #2066]

	5532.	[cleanup]	Unused header files were removed:
				bin/rndc/include/rndc/os.h, lib/isc/timer_p.h,
				lib/isccfg/include/isccfg/dnsconf.h and code related
				to those files. [GL #1913]

	5531.	[func]		Add support for DNS over TLS (DoT) to dig and named.
				dig output now includes the transport protocol used.
				[GL #1816] [GL #1840]

	5530.	[bug]		dnstap did not capture responses to forwarded UPDATE
				requests. [GL #2252]

	5529.	[func]		The network manager API is now used by named to send
				zone transfer requests. [GL #2016]

	5528.	[func]		Convert dig, host, and nslookup to use the network
				manager API. As a side effect of this change, "dig
				+unexpected" no longer works, and has been disabled.
				[GL #2140]

	5527.	[bug]		A NULL pointer dereference occurred when creating an NTA
				recheck query failed. [GL #2244]

	5526.	[bug]		Fix a race/NULL dereference in TCPDNS read. [GL #2227]

	5525.	[placeholder]

	5524.	[func]		Added functionality to the network manager to support
				outgoing DNS queries in addition to incoming ones.
				[GL #2235]

	5523.	[bug]		The initial lookup in a zone transitioning to/from a
				signed state could fail if the DNSKEY RRset was not
				found. [GL #2236]

	5522.	[bug]		Fixed a race/NULL dereference in TCPDNS send. [GL #2227]

	5521.	[func]		All use of libltdl was dropped. libuv's shared library
				handling interface is now used instead. [GL !4278]

	5520.	[bug]		Fixed a number of shutdown races, reference counting
				errors, and spurious log messages that could occur
				in the network manager. [GL #2221]

	5519.	[cleanup]	Unused source code was removed: lib/dns/dbtable.c,
				lib/dns/portlist.c, lib/isc/bufferlist.c, and code
				related to those files. [GL #2060]

	5518.	[bug]		Stub zones now work correctly with primary servers using
				"minimal-responses yes". [GL #1736]

	5517.	[bug]		Do not treat UV_EOF as a TCP4RecvErr or a TCP6RecvErr.
				[GL #2208]

.. code-block:: none

		--- 9.17.6 released ---

	5516.	[func]		The default EDNS buffer size has been changed from 4096
				to 1232 bytes, the EDNS buffer size probing has been
				removed, and named now sets the DF (Don't Fragment) flag
				on outgoing UDP packets. [GL #2183]

	5515.	[func]		Add 'rndc dnssec -rollover' command to trigger a manual
				rollover for a specific key. [GL #1749]

	5514.	[bug]		Fix KASP expected key size for Ed25519 and Ed448.
				[GL #2171]

	5513.	[doc]		The ARM section describing the "rrset-order" statement
				was rewritten to make it unambiguous and up-to-date with
				the source code. [GL #2139]

	5512.	[bug]		"rrset-order" rules using "order none" were causing
				named to crash despite named-checkconf treating them as
				valid. [GL #2139]

	5511.	[bug]		'dig -u +yaml' failed to display timestamps to the
				microsecond. [GL #2190]

	5510.	[bug]		Implement the attach/detach semantics for dns_message_t
				to fix a data race in accessing an already-destroyed
				fctx->rmessage. [GL #2124]

	5509.	[bug]		filter-aaaa: named crashed upon shutdown if it was in
				the process of recursing for A RRsets. [GL #1040]

	5508.	[func]		Added new parameter "-expired" for "rndc dumpdb" that
				also prints expired RRsets (awaiting cleanup) to the
				dump file. [GL #1870]

	5507.	[bug]		Named could compute incorrect SIG(0) responses.
				[GL #2109]

	5506.	[bug]		Properly handle failed sysconf() calls, so we don't
				report invalid memory size. [GL #2166]

	5505.	[bug]		Updating contents of a mixed-case RPZ could cause some
				rules to be ignored. [GL #2169]

	5504.	[func]		The "glue-cache" option has been marked as deprecated.
				The glue cache feature will be permanently enabled in a
				future release. [GL #2146]

	5503.	[bug]		Cleaned up reference counting of network manager
				handles, now using isc_nmhandle_attach() and _detach()
				instead of _ref() and _unref(). [GL #2122]

.. code-block:: none

		--- 9.17.5 released ---

	5502.	[func]		'dig +bufsize=0' no longer disables EDNS. [GL #2054]

	5501.	[func]		Log CDS/CDNSKEY publication. [GL #1748]

	5500.	[bug]		Fix (non-)publication of CDS and CDNSKEY records.
				[GL #2103]

	5499.	[func]		Add '-P ds' and '-D ds' arguments to dnssec-settime.
				[GL #1748]

	5498.	[test]		The --with-gperftools-profiler configure option was
				removed. [GL !4045]

	5497.	[placeholder]

	5496.	[bug]		Address a TSAN report by ensuring each rate limiter
				object holds a reference to its task. [GL #2081]

	5495.	[bug]		With query minimization enabled, named failed to
				resolve ip6.arpa. names that had extra labels to the
				left of the IPv6 part. [GL #1847]

	5494.	[bug]		Silence the EPROTO syslog message on older systems.
				[GL #1928]

	5493.	[bug]		Fix off-by-one error when calculating new hash table
				size. [GL #2104]

	5492.	[bug]		Tighten LOC parsing to reject a period (".") and/or "m"
				as a value. Fix handling of negative altitudes which are
				not whole meters. [GL #2074]

	5491.	[bug]		rbtversion->glue_table_size could be read without the
				appropriate lock being held. [GL #2080]

	5490.	[func]		Refactor readline support to use pkg-config and add
				support for the editline library. [GL !3942]

	5489.	[bug]		Named erroneously accepted certain invalid resource
				records that were incorrectly processed after
				subsequently being written to disk and loaded back, as
				the wire format differed. Such records include: CERT,
				IPSECKEY, NSEC3, NSEC3PARAM, NXT, SIG, TLSA, WKS, and
				X25. [GL !3953]

	5488.	[bug]		NTA code needed to have a weak reference on its
				associated view to prevent the latter from being deleted
				while NTA tests were being performed. [GL #2067]

	5487.	[cleanup]	Update managed keys log messages to be less confusing.
				[GL #2027]

	5486.	[func]		Add 'rndc dnssec -checkds' command, which signals to
				named that the DS record for a given zone or key has
				been updated in the parent zone. [GL #1613]

.. code-block:: none

		--- 9.17.4 released ---

	5485.	[placeholder]

	5484.	[func]		Expire zero TTL records quickly rather than using them
				for stale answers. [GL #1829]

	5483.	[func]		Keeping "stale" answers in cache has been disabled by
				default and can be re-enabled with a new configuration
				option "stale-cache-enable". [GL #1712]

	5482.	[bug]		If the Duplicate Address Detection (DAD) mechanism had
				not yet finished after adding a new IPv6 address to the
				system, BIND 9 would fail to bind to IPv6 addresses in a
				tentative state. [GL #2038]

	5481.	[security]	"update-policy" rules of type "subdomain" were
				incorrectly treated as "zonesub" rules, which allowed
				keys used in "subdomain" rules to update names outside
				of the specified subdomains. The problem was fixed by
				making sure "subdomain" rules are again processed as
				described in the ARM. (CVE-2020-8624) [GL #2055]

	5480.	[security]	When BIND 9 was compiled with native PKCS#11 support, it
				was possible to trigger an assertion failure in code
				determining the number of bits in the PKCS#11 RSA public
				key with a specially crafted packet. (CVE-2020-8623)
				[GL #2037]

	5479.	[security]	named could crash in certain query resolution scenarios
				where QNAME minimization and forwarding were both
				enabled. (CVE-2020-8621) [GL #1997]

	5478.	[security]	It was possible to trigger an assertion failure by
				sending a specially crafted large TCP DNS message.
				(CVE-2020-8620) [GL #1996]

	5477.	[bug]		The idle timeout for connected TCP sockets, which was
				previously set to a high fixed value, is now derived
				from the client query processing timeout configured for
				a resolver. [GL #2024]

	5476.	[security]	It was possible to trigger an assertion failure when
				verifying the response to a TSIG-signed request.
				(CVE-2020-8622) [GL #2028]

	5475.	[bug]		Wildcard RPZ passthru rules could incorrectly be
				overridden by other rules that were loaded from RPZ
				zones which appeared later in the "response-policy"
				statement. This has been fixed. [GL #1619]

	5474.	[bug]		dns_rdata_hip_next() failed to return ISC_R_NOMORE
				when it should have. [GL !3880]

	5473.	[func]		The RBT hash table implementation has been changed
				to use a faster hash function (HalfSipHash2-4) and
				Fibonacci hashing for better distribution. Setting
				"max-cache-size" now preallocates a fixed-size hash
				table so that rehashing does not cause resolution
				brownouts while the hash table is grown. [GL #1775]

	5472.	[func]		The statistics channel has been updated to use the
				new network manager. [GL #2022]

	5471.	[bug]		The introduction of KASP support inadvertently caused
				the second field of "sig-validity-interval" to always be
				calculated in hours, even in cases when it should have
				been calculated in days. This has been fixed. (Thanks to
				Tony Finch.) [GL !3735]

	5470.	[port]		gsskrb5_register_acceptor_identity() is now only called
				if gssapi_krb5.h is present. [GL #1995]

	5469.	[port]		On illumos, a constant called SEC is already defined in
				<sys/time.h>, which conflicts with an identically named
				constant in libbind9. This conflict has been resolved.
				[GL #1993]

	5468.	[bug]		Addressed potential double unlock in process_fd().
				[GL #2005]

	5467.	[func]		The control channel and the rndc utility have been
				updated to use the new network manager. To support
				this, the network manager was updated to enable
				the initiation of client TCP connections. Its
				internal reference counting has been refactored.

				Note: As a side effect of this change, rndc cannot
				currently be used with UNIX-domain sockets, and its
				default timeout has changed from 60 seconds to 30.
				These will be addressed in a future release.
				[GL #1759]

	5466.	[bug]		Addressed an error in recursive clients stats reporting.
				[GL #1719]

	5465.	[func]		Added fallback to built-in trust-anchors, managed-keys,
				or trusted-keys if the bindkeys-file (bind.keys) cannot
				be parsed. [GL #1235]

	5464.	[bug]		Requesting more than 128 files to be saved when rolling
				dnstap log files caused a buffer overflow. This has been
				fixed. [GL #1989]

	5463.	[placeholder]

	5462.	[bug]		Move LMDB locking from LMDB itself to named. [GL #1976]

	5461.	[bug]		The STALE rdataset header attribute was updated while
				the write lock was not being held, leading to incorrect
				statistics. The header attributes are now converted to
				use atomic operations. [GL #1475]

	5460.	[cleanup]	tsig-keygen was previously an alias for
				ddns-confgen and was documented in the ddns-confgen
				man page. This has been reversed; tsig-keygen is
				now the primary name. [GL #1998]

	5459.	[bug]		Fixed bad isc_mem_put() size when an invalid type was
				specified in an "update-policy" rule. [GL #1990]

.. code-block:: none

		--- 9.17.3 released ---

	5458.	[bug]		Prevent a theoretically possible NULL dereference caused
				by a data race between zone_maintenance() and
				dns_zone_setview_helper(). [GL #1627]

	5457.	[placeholder]

	5456.	[func]		Added "primaries" as a synonym for "masters" in
				named.conf, and "primary-only" as a synonym for
				"master-only" in the parameters to "notify", to bring
				terminology up-to-date with RFC 8499. [GL #1948]

	5455.	[bug]		named could crash when cleaning dead nodes in
				lib/dns/rbtdb.c that were being reused. [GL #1968]

	5454.	[bug]		Address a startup crash that occurred when the server
				was under load and the root zone had not yet been
				loaded. [GL #1862]

	5453.	[bug]		named crashed on shutdown when a new rndc connection was
				received during shutdown. [GL #1747]

	5452.	[bug]		The "blackhole" ACL was accidentally disabled for client
				queries. [GL #1936]

	5451.	[func]		Add 'rndc dnssec -status' command. [GL #1612]

	5450.	[placeholder]

	5449.	[bug]		Fix a socket shutdown race in netmgr udp. [GL #1938]

	5448.	[bug]		Fix a race condition in isc__nm_tcpdns_send().
				[GL #1937]

	5447.	[bug]		IPv6 addresses ending in "::" could break YAML
				parsing. A "0" is now appended to such addresses
				in YAML output from dig, mdig, delv, and dnstap-read.
				[GL #1952]

	5446.	[bug]		The validator could fail to accept a properly signed
				RRset if an unsupported algorithm appeared earlier in
				the DNSKEY RRset than a supported algorithm. It could
				also stop if it detected a malformed public key.
				[GL #1689]

	5445.	[cleanup]	Disable and disallow static linking. [GL #1933]

	5444.	[bug]		'rndc dnstap -roll <value>' did not limit the number of
				saved files to <value>. [GL !3728]

	5443.	[bug]		The "primary" and "secondary" keywords, when used
				as parameters for "check-names", were not
				processed correctly and were being ignored. [GL #1949]

	5442.	[func]		Add support for outgoing TCP connections in netmgr.
				[GL #1958]

	5441.	[placeholder]

	5440.	[placeholder]

	5439.	[bug]		The DS RRset returned by dns_keynode_dsset() was used in
				a non-thread-safe manner. [GL #1926]

.. code-block:: none

		--- 9.17.2 released ---

	5438.	[bug]		Fix a race in TCP accepting code. [GL #1930]

	5437.	[bug]		Fix a data race in lib/dns/resolver.c:log_formerr().
				[GL #1808]

	5436.	[security]	It was possible to trigger an INSIST when determining
				whether a record would fit into a TCP message buffer.
				(CVE-2020-8618) [GL #1850]

	5435.	[tests]		Add RFC 4592 responses examples to the wildcard system
				test. [GL #1718]

	5434.	[security]	It was possible to trigger an INSIST in
				lib/dns/rbtdb.c:new_reference() with a particular zone
				content and query patterns. (CVE-2020-8619) [GL #1111]
				[GL #1718]

	5433.	[placeholder]

	5432.	[bug]		Check the question section when processing AXFR, IXFR,
				and SOA replies when transferring a zone in. [GL #1683]

	5431.	[func]		Reject DS records at the zone apex when loading
				master files. Log but otherwise ignore attempts to
				add DS records at the zone apex via UPDATE. [GL #1798]

	5430.	[doc]		Update docs - with netmgr, a separate listening socket
				is created for each IPv6 interface (just as with IPv4).
				[GL #1782]

	5429.	[cleanup]	Move BIND binaries which are neither daemons nor
				administrative programs to $bindir. [GL #1724]

	5428.	[bug]		Clean up GSSAPI resources in nsupdate only after taskmgr
				has been destroyed. Thanks to Petr Menšík. [GL !3316]

	5427.	[placeholder]

	5426.	[bug]		Don't abort() when setting SO_INCOMING_CPU on the socket
				fails. [GL #1911]

	5425.	[func]		The default value of "max-stale-ttl" has been changed
				from 1 week to 12 hours. [GL #1877]

	5424.	[bug]		With KASP, when creating a successor key, the "goal"
				state of the current active key (predecessor) was not
				changed and thus never removed from the zone. [GL #1846]

	5423.	[bug]		Fix a bug in keymgr_key_has_successor(): it incorrectly
				returned true if any other key in the keyring had a
				successor. [GL #1845]

	5422.	[bug]		When using dnssec-policy, print correct key timing
				metadata. [GL #1843]

	5421.	[bug]		Fix a race that could cause named to crash when looking
				up the nodename of an RBT node if the tree was modified.
				[GL #1857]

	5420.	[bug]		Add missing isc_{mutex,conditional}_destroy() calls
				that caused a memory leak on FreeBSD. [GL #1893]

	5419.	[func]		Add new dig command line option, "+qid=<num>", which
				allows the query ID to be set to an arbitrary value.
				Add a new ./configure option, --enable-singletrace,
				which allows trace logging of a single query when QID is
				set to 0. [GL #1851]

	5418.	[bug]		delv failed to parse deprecated trusted-keys-style
				trust anchors. [GL #1860]

	5417.	[cleanup]	The code determining the advertised UDP buffer size in
				outgoing EDNS queries has been refactored to improve its
				clarity. [GL #1868]

	5416.	[bug]		Fix a lock order inversion in lib/isc/unix/socket.c.
				[GL #1859]

	5415.	[test]		Address race in dnssec system test that led to
				test failures. [GL #1852]

	5414.	[test]		Adjust time allowed for journal truncation to occur
				in nsupdate system test to avoid test failure.
				[GL #1855]

	5413.	[test]		Address race in autosign system test that led to
				test failures. [GL #1852]

	5412.	[bug]		'provide-ixfr no;' failed to return up-to-date responses
				when the serial was greater than or equal to the
				current serial. [GL #1714]

	5411.	[cleanup]	TCP accept code has been refactored to use a single
				accept() and pass the accepted socket to child threads
				for processing. [GL !3320]

	5410.	[func]		Add the ability to specify per-type record count limits,
				which are enforced when adding records via UPDATE, in an
				"update-policy" statement. [GL #1657]

	5409.	[performance]	When looking up NSEC3 data in a zone database, skip the
				check for empty non-terminal nodes; the NSEC3 tree does
				not have any. [GL #1834]

	5408.	[protocol]	Print Extended DNS Errors if present in OPT record.
				[GL #1835]

	5407.	[func]		Zone timers are now exported via statistics channel.
				Thanks to Paul Frieden, Verizon Media. [GL #1232]

	5406.	[func]		Add a new logging category, "rpz-passthru", which allows
				RPZ passthru actions to be logged in a separate channel.
				[GL #54]

	5405.	[bug]		'named-checkconf -p' could include spurious text in
				server-addresses statements due to an uninitialized DSCP
				value. [GL #1812]

	5404.	[bug]		'named-checkconf -z' could incorrectly indicate
				success if errors were found in one view but not in a
				subsequent one. [GL #1807]

	5403.	[func]		Do not set UDP receive/send buffer sizes - use system
				defaults. [GL #1713]

	5402.	[bug]		On FreeBSD, use SO_REUSEPORT_LB instead of SO_REUSEPORT.
				Enable use of SO_REUSEADDR on all platforms which
				support it. [GL !3365]

	5401.	[bug]		The number of input queues allocated during dnstap
				initialization was too low, which could prevent some
				dnstap data from being logged. [GL #1795]

	5400.	[func]		Add engine support to OpenSSL EdDSA implementation.
				[GL #1763]

	5399.	[func]		Add engine support to OpenSSL ECDSA implementation.
				[GL #1534]

	5398.	[bug]		Named could fail to restart if a zone with a double
				quote (") in its name was added with 'rndc addzone'.
				[GL #1695]

	5397.	[func]		Update PKCS#11 EdDSA implementation to PKCS#11 v3.0.
				Thanks to Aaron Thompson. [GL !3326]

	5396.	[func]		When necessary (i.e. in libuv >= 1.37), use the
				UV_UDP_RECVMMSG flag to enable recvmmsg() support in
				libuv. [GL #1797]

	5395.	[security]	Further limit the number of queries that can be
				triggered from a request.  Root and TLD servers
				are no longer exempt from max-recursion-queries.
				Fetches for missing name server address records
				are limited to 4 for any domain. (CVE-2020-8616)
				[GL #1388]

	5394.	[cleanup]	Named formerly attempted to change the effective UID and
				GID in named_os_openfile(), which could trigger a
				spurious log message if they were already set to the
				desired values. This has been fixed. [GL #1042]
				[GL #1090]

	5393.	[cleanup]	Unused and/or redundant APIs were removed from libirs.
				[GL #1758]

	5392.	[bug]		It was possible for named to crash during shutdown
				or reconfiguration if an RPZ zone was still being
				updated. [GL #1779]

	5391.	[func]		The BIND 9 build system has been changed to use a
				typical autoconf+automake+libtool stack. When building
				from the Git repository, run "autoreconf -fi" first.
				[GL #4]

	5390.	[security]	Replaying a TSIG BADTIME response as a request could
				trigger an assertion failure. (CVE-2020-8617)
				[GL #1703]

	5389.	[bug]		Finish PKCS#11 code cleanup, fix a couple of smaller
				bugs and use PKCS#11 v3.0 EdDSA macros and constants.
				Thanks to Aaron Thompson. [GL !3391]

	5388.	[func]		Reject AXFR streams where the message ID is not
				consistent. [GL #1674]

	5387.	[placeholder]

	5386.	[cleanup]	Address Coverity warnings in lib/dns/keymgr.c.
				[GL #1737]

	5385.	[func]		Make ISC rwlock implementation the default again.
				[GL #1753]

	5384.	[bug]		With "dnssec-policy" in effect, "inline-signing" was
				implicitly set to "yes". Now "inline-signing" is only
				set to "yes" if the zone is not dynamic. [GL #1709]

.. code-block:: none

		--- 9.17.1 released ---

	5383.	[func]		Add a quota attach function with a callback and clean up
				the isc_quota API. [GL !3280]

	5382.	[bug]		Use clock_gettime() instead of gettimeofday() for
				isc_stdtime() function. [GL #1679]

	5381.	[bug]		Fix logging API data race by adding rwlock and caching
				logging levels in stdatomic variables to restore
				performance to original levels. [GL #1675] [GL #1717]

	5380.	[contrib]	Fix building MySQL DLZ modules against MySQL 8
				libraries. [GL #1678]

	5379.	[placeholder]

	5378.	[bug]		Receiving invalid DNS data was triggering an assertion
				failure in nslookup. [GL #1652]

	5377.	[placeholder]

	5376.	[bug]		Fix ineffective DNS rebinding protection when BIND is
				configured as a forwarding DNS server. Thanks to Tobias
				Klein. [GL #1574]

	5375.	[test]		Fix timing issues in the "kasp" system test. [GL #1669]

	5374.	[bug]		Statistics counters tracking recursive clients and
				active connections could underflow. [GL #1087]

	5373.	[bug]		Collecting statistics for DNSSEC signing operations
				(change 5254) caused an array of significant size (over
				100 kB) to be allocated for each configured zone. Each
				of these arrays is tracking all possible key IDs; this
				could trigger an out-of-memory condition on servers with
				a high enough number of zones configured. Fixed by
				tracking up to four keys per zone and rotating counters
				when keys are replaced. This fixes the immediate problem
				of high memory usage, but should be improved in a future
				release by growing or shrinking the number of keys to
				track upon key rollover events. [GL #1179]

	5372.	[bug]		Fix migration from existing DNSSEC key files
				("auto-dnssec maintain") to "dnssec-policy". [GL #1706]

	5371.	[bug]		Improve incremental updates of the RPZ summary
				database to reduce delays that could occur when
				a policy zone update included a large number of
				record deletions. [GL #1447]

	5370.	[bug]		Deactivation of a netmgr handle associated with a
				socket could be skipped in some circumstances.
				Fixed by deactivating the netmgr handle before
				scheduling the asynchronous close routine. [GL #1700]

	5369.	[func]		Add the ability to specify whether to wait for
				nameserver domain names to be looked up, with a new RPZ
				modifying directive 'nsdname-wait-recurse'. [GL #1138]

	5368.	[bug]		Named failed to restart if 'rndc addzone' names
				contained special characters (e.g. '/'). [GL #1655]

	5367.	[placeholder]

.. code-block:: none

		--- 9.17.0 released ---

	5366.	[bug]		Fix a race condition with the keymgr when the same
				zone plus dnssec-policy is configured in multiple
				views. [GL #1653]

	5365.	[bug]		Algorithm rollover was stuck on submitting DS
				because keymgr thought it would move to an invalid
				state.  Fixed by checking the current key against
				the desired state, not the existing state. [GL #1626]

	5364.	[bug]		Algorithm rollover waited too long before introducing
				zone signatures.  It waited to make sure all signatures
				were regenerated, but when introducing a new algorithm,
				all signatures are regenerated immediately.  Only
				add the sign delay if there is a predecessor key.
				[GL #1625]

	5363.	[bug]		When changing a dnssec-policy, existing keys with
				properties that no longer match were not being retired.
				[GL #1624]

	5362.	[func]		Limit the size of IXFR responses so that AXFR will
				be used instead if it would be smaller. This is
				controlled by the "max-ixfr-ratio" option, which
				is a percentage representing the ratio of IXFR size
				to the size of the entire zone. This value cannot
				exceed 100%, which is the default. [GL #1515]

	5361.	[bug]		named might not accept new connections after
				hitting tcp-clients quota. [GL #1643]

	5360.	[bug]		delv could fail to load trust anchors in DNSKEY
				format. [GL #1647]

	5359.	[func]		"rndc nta -d" and "rndc secroots" now include
				"validate-except" entries when listing negative
				trust anchors. These are indicated by the keyword
				"permanent" in place of an expiry date. [GL #1532]

	5358.	[bug]		Inline master zones whose master files were touched
				but otherwise unchanged and were subsequently reloaded
				may have stopped re-signing. [GL !3135]

	5357.	[bug]		Newly added RRSIG records with expiry times before
				the previous earliest expiry times might not be
				re-signed in time.  This was a side effect of 5315.
				[GL !3137]

	5356.	[func]		Update dnssec-policy configuration statements:
				- Rename "zone-max-ttl" dnssec-policy option to
				  "max-zone-ttl" for consistency with the existing
				  zone option.
				- Allow for "lifetime unlimited" as a synonym for
				  "lifetime PT0S".
				- Make "key-directory" optional.
				- Warn if specifying a key length does not make
				  sense; fail if key length is out of range for
				  the algorithm.
				- Allow use of mnemonics when specifying key
				  algorithm (e.g. "rsasha256", "ecdsa384", etc.).
				- Make ISO 8601 durations case-insensitive.
				[GL #1598]

	5355.	[func]		What was set with --with-tuning=large option in
				older BIND9 versions is now a default, and
				a --with-tuning=small option was added for small
				(e.g. OpenWRT) systems. [GL !2989]

	5354.	[bug]		dnssec-policy created new KSK keys for zones in the
				initial stage of signing (with the DS not yet in the
				rumoured or omnipresent states).  Fix by checking the
				key goals rather than the active state when determining
				whether new keys are needed. [GL #1593]

	5353.	[doc]		Document port and dscp parameters in forwarders
				configuration option. [GL #914]

	5352.	[bug]		Correctly handle catalog zone entries containing
				characters that aren't legal in filenames. [GL #1592]

	5351.	[bug]		CDS / CDNSKEY consistency checks failed to handle
				removal records. [GL #1554]

	5350.	[bug]		When a view was configured with class CHAOS, the
				server could crash while processing a query for a
				non-existent record. [GL #1540]

	5349.	[bug]		Fix a race in task_pause/unpause. [GL #1571]

	5348.	[bug]		dnssec-settime -Psync was not being honoured.
				Thanks to Tony Finch. [GL !2893]

.. code-block:: none

		--- 9.15.8 released ---

	5347.	[bug]		Fixed a bug that could cause an intermittent crash
				in validator.c when validating a negative cache
				entry. [GL #1561]

	5346.	[bug]		Make hazard pointer array allocations dynamic, fixing
				a bug that caused named to crash on machines with more
				than 40 cores. [GL #1493]

	5345.	[func]		Key-style trust anchors and DS-style trust anchors
				can now both be used for the same name. [GL #1237]

	5344.	[bug]		Handle accept() errors properly in netmgr. [GL !2880]

	5343.	[func]		Add statistics counters to the netmgr. [GL #1311]

	5342.	[bug]		Disable pktinfo for IPv6 and bind to each interface
				explicitly instead, because libuv doesn't support
				pktinfo control messages. [GL #1558]

	5341.	[func]		Simplify passing the bound TCP socket to child
				threads by using isc_uv_export/import functions.
				[GL !2825]

	5340.	[bug]		Don't deadlock when binding to a TCP socket fails.
				[GL #1499]

	5339.	[bug]		With some libmaxminddb versions, named could erroneously
				match an IP address not belonging to any subnet defined
				in a given GeoIP2 database to one of the existing
				entries in that database. [GL #1552]

	5338.	[bug]		Fix line spacing in `rndc secroots`.
				Thanks to Tony Finch. [GL !2478]

	5337.	[func]		'named -V' now reports maxminddb and protobuf-c
				versions. [GL !2686]

.. code-block:: none

		--- 9.15.7 released ---

	5336.	[bug]		The TCP high-water statistic could report an
				incorrect value on startup. [GL #1392]

	5335.	[func]		Make TCP listening code multithreaded. [GL !2659]

	5334.	[doc]		Update documentation with dnssec-policy clarifications.
				Also change some defaults. [GL !2711]

	5333.	[bug]		Fix duration printing on Solaris when value is not
				an ISO 8601 duration. [GL #1460]

	5332.	[func]		Renamed "dnssec-keys" configuration statement
				to the more descriptive "trust-anchors". [GL !2702]

	5331.	[func]		Use compiler-provided mechanisms for thread local
				storage, and make the requirement for such mechanisms
				explicit in configure. [GL #1444]

	5330.	[bug]		'configure --without-python' was ineffective if
				PYTHON was set in the environment. [GL #1434]

	5329.	[bug]		Reconfiguring named caused memory to be leaked when any
				GeoIP2 database was in use. [GL #1445]

	5328.	[bug]		rbtdb.c:rdataset_{get,set}ownercase failed to obtain
				a node lock. [GL #1417]

	5327.	[func]		Added a statistics counter to track queries
				dropped because the recursive-clients quota was
				exceeded. [GL #1399]

	5326.	[bug]		Add Python dependency on 'distutils.core' to configure.
				'distutils.core' is required for installation.
				[GL #1397]

	5325.	[bug]		Addressed several issues with TCP connections in
				the netmgr: restored support for TCP connection
				timeouts, restored TCP backlog support, actively
				close all open sockets during shutdown. [GL #1312]

	5324.	[bug]		Change the category of some log messages from general
				to the more appropriate catergory of xfer-in. [GL #1394]

	5323.	[bug]		Fix a bug in DNSSEC trust anchor verification.
				[GL !2609]

	5322.	[placeholder]

	5321.	[bug]		Obtain write lock before updating version->records
				and version->bytes. [GL #1341]

	5320.	[cleanup]	Silence TSAN on header->count. [GL #1344]

.. code-block:: none

		--- 9.15.6 released ---

	5319.	[func]		Trust anchors can now be configured using DS
				format to represent a key digest, by using the
				new "initial-ds" or "static-ds" keywords in
				the "dnssec-keys" statement.

				Note: DNSKEY-format and DS-format trust anchors
				cannot both be used for the same domain name.
				[GL #622]

	5318.	[cleanup]	The DNSSEC validation code has been refactored
				for clarity and to reduce code duplication.
				[GL #622]

	5317.	[func]		A new asynchronous network communications system
				based on libuv is now used for listening for
				incoming requests and responding to them. (The
				old isc_socket API remains in use for sending
				iterative queries and processing responses; this
				will be changed too in a later release.)

				This change will make it easier to improve
				performance and implement new protocol layers
				(e.g., DNS over TLS) in the future. [GL #29]

	5316.	[func]		A new "dnssec-policy" option has been added to
				named.conf to implement a key and signing policy
				(KASP) for zones. When this option is in use,
				named can generate new keys as needed and
				automatically roll both ZSK and KSK keys. (Note
				that the syntax for this statement differs from
				the dnssec policy used by dnssec-keymgr.)

				See the ARM for configuration details. [GL #1134]

	5315.	[bug]		Apply the initial RRSIG expiration spread fixed
				to all dynamically created records in the zone
				including NSEC3. Also fix the signature clusters
				when the server has been offline for prolonged
				period of times. [GL #1256]

	5314.	[func]		Added a new statistics variable "tcp-highwater"
				that reports the maximum number of simultaneous TCP
				clients BIND has handled while running. [GL #1206]

	5313.	[bug]		The default GeoIP2 database location did not match
				the ARM.  'named -V' now reports the default
				location. [GL #1301]

	5312.	[bug]		Do not flush the cache for `rndc validation status`.
				Thanks to Tony Finch. [GL !2462]

	5311.	[cleanup]	Include all views in output of `rndc validation status`.
				Thanks to Tony Finch. [GL !2461]

	5310.	[bug]		TCP failures were affecting EDNS statistics. [GL #1059]

	5309.	[placeholder]

	5308.	[bug]		Don't log DNS_R_UNCHANGED from sync_secure_journal()
				at ERROR level in receive_secure_serial(). [GL #1288]

	5307.	[bug]		Fix hang when named-compilezone output is sent to pipe.
				Thanks to Tony Finch. [GL !2481]

	5306.	[security]	Set a limit on number of simultaneous pipelined TCP
				queries. (CVE-2019-6477) [GL #1264]

	5305.	[bug]		NSEC Aggressive Cache ("synth-from-dnssec") has been
				disabled by default because it was found to have
				a significant performance impact on the recursive
				service. [GL #1265]

	5304.	[bug]		"dnskey-sig-validity 0;" was not being accepted.
				[GL #876]

	5303.	[placeholder]

	5302.	[bug]		Fix checking that "dnstap-output" is defined when
				"dnstap" is specified in a view. [GL #1281]

	5301.	[bug]		Detect partial prefixes / incomplete IPv4 address in
				acls. [GL #1143]

	5300.	[bug]		dig/mdig/delv: Add a colon after EDNS option names,
				even when the option is empty, to improve
				readability and allow correct parsing of YAML
				output. [GL #1226]

.. code-block:: none

		--- 9.15.5 released ---

	5299.	[security]	A flaw in DNSSEC verification when transferring
				mirror zones could allow data to be incorrectly
				marked valid. (CVE-2019-6475) [GL #1252]

	5298.	[security]	Named could assert if a forwarder returned a
				referral, rather than resolving the query, when QNAME
				minimization was enabled. (CVE-2019-6476) [GL #1051]

	5297.	[bug]		Check whether a previous QNAME minimization fetch
				is still running before starting a new one; return
				SERVFAIL and log an error if so. [GL #1191]

	5296.	[placeholder]

	5295.	[cleanup]	Split dns_name_copy() calls into dns_name_copy() and
				dns_name_copynf() for those calls that can potentially
				fail and those that should not fail respectively.
				[GL !2265]

	5294.	[func]		Fallback to ACE name on output in locale, which does not
				support converting it to unicode.  [GL #846]

	5293.	[bug]		On Windows, named crashed upon any attempt to fetch XML
				statistics from it. [GL #1245]

	5292.	[bug]		Queue 'rndc nsec3param' requests while signing inline
				zone changes. [GL #1205]

.. code-block:: none

		--- 9.15.4 released ---

	5291.	[placeholder]

	5290.	[placeholder]

	5289.	[bug]		Address NULL pointer dereference in rpz.c:rpz_detach.
				[GL #1210]

	5288.	[bug]		dnssec-must-be-secure was not always honored.
				[GL #1209]

	5287.	[placeholder]

	5286.	[contrib]	Address potential NULL pointer dereferences in
				dlz_mysqldyn_mod.c. [GL #1207]

	5285.	[port]		win32: implement "-T maxudpXXX". [GL #837]

	5284.	[func]		Added +unexpected command line option to dig.
				By default, dig won't accept a reply from a source
				other than the one to which it sent the query.
				Invoking dig with +unexpected argument will allow it
				to process replies from unexpected sources.

	5283.	[bug]		When a response-policy zone expires, ensure that
				its policies are removed from the RPZ summary
				database. [GL #1146]

	5282.	[bug]		Fixed a bug in searching for possible wildcard matches
				for query names in the RPZ summary database. [GL #1146]

	5281.	[cleanup]	Don't escape commas when reporting named's command
				line. [GL #1189]

	5280.	[protocol]	Add support for displaying EDNS option LLQ. [GL #1201]

	5279.	[bug]		When loading, reject zones containing CDS or CDNSKEY
				RRsets at the zone apex if they would cause DNSSEC
				validation failures if published in the parent zone
				as the DS RRset.  [GL #1187]

	5278.	[func]		Add YAML output formats for dig, mdig and delv;
				use the "+yaml" option to enable. [GL #1145]

.. code-block:: none

		--- 9.15.3 released ---

	5277.	[bug]		Cache DB statistics could underflow when serve-stale
				was in use, because of a bug in counter maintenance
				when RRsets become stale.

				Functions for dumping statistics have been updated
				to dump active, stale, and ancient statistic
				counters.  Ancient RRset counters are prefixed
				with '~'; stale RRset counters are still prefixed
				with '#'. [GL #602]

	5276.	[func]		DNSSEC Lookaside Validation (DLV) is now obsolete;
				all code enabling its use has been removed from the
				validator, "delv", and the DNSSEC tools. [GL #7]

	5275.	[bug]		Mark DS records included in referral messages
				with trust level "pending" so that they can be
				validated and cached immediately, with no need to
				re-query. [GL #964]

	5274.	[bug]		Address potential use after free race when shutting
				down rpz. [GL #1175]

	5273.	[bug]		Check that bits [64..71] of a dns64 prefix are zero.
				[GL #1159]

	5272.	[cleanup]	Remove isc-config.sh script as the BIND 9 libraries
				are now purely internal. [GL #1123]

	5271.	[func]		The normal (non-debugging) output of dnssec-signzone
				and dnssec-verify tools now goes to stdout, instead of
				the combination of stderr and stdout.

	5270.	[bug]		'dig +expandaaaa +short' did not work. [GL #1152]

	5269.	[port]		cygwin: can return ETIMEDOUT on connect() with a
				non-blocking socket. [GL #1133]

	5268.	[placeholder]

	5267.	[func]		Allow statistics groups display to be toggle-able.
				[GL #1030]

	5266.	[bug]		named-checkconf failed to report dnstap-output
				missing from named.conf when dnstap was specified.
				[GL #1136]

	5265.	[bug]		DNS64 and RPZ nodata (CNAME *.) rules interacted badly
				[GL #1106]

	5264.	[func]		New DNS Cookie algorithm - siphash24 - has been added
				to BIND 9, and the old HMAC-SHA DNS Cookie algorithms
				have been removed. [GL #605]

.. code-block:: none

		--- 9.15.2 released ---

	5263.	[cleanup]	Use atomics and isc_refcount_t wherever possible.
				[GL #1038]

	5262.	[func]		Removed support for the legacy GeoIP API. [GL #1112]

	5261.	[cleanup]	Remove SO_BSDCOMPAT socket option usage.

	5260.	[bug]		dnstap-read was producing malformed output for large
				packets. [GL #1093]

	5259.	[func]		New option '-i' for 'named-checkconf' to ignore
				warnings about deprecated options. [GL #1101]

	5258.	[func]		Added support for the GeoIP2 API from MaxMind. This
				will be compiled in by default if the "libmaxminddb"
				library is found at compile time, but can be
				suppressed using "configure --disable-geoip".

				Certain geoip ACL settings that were available with
				legacy GeoIP are not available when using GeoIP2.
				[GL #182]

	5257.	[bug]		Some statistics data was not being displayed.
				Add shading to the zone tables. [GL #1030]

	5256.	[bug]		Ensure that glue records are included in root
				priming responses if "minimal-responses" is not
				set to "yes". [GL #1092]

	5255.	[bug]		Errors encountered while reloading inline-signing
				zones could be ignored, causing the zone content to
				be left in an incompletely updated state rather than
				reverted. [GL #1109]

	5254.	[func]		Collect metrics to report to the statistics-channel
				DNSSEC signing operations (dnssec-sign) and refresh
				operations (dnssec-refresh) per zone and per keytag.
				[GL #513]

	5253.	[port]		Support platforms that don't define ULLONG_MAX.
				[GL #1098]

	5252.	[func]		Report if the last 'rndc reload/reconfig' failed in
				rndc status. [GL !2040]

	5251.	[bug]		Statistics were broken in x86 Windows builds.
				[GL #1081]

	5250.	[func]		The default size for RSA keys is now 2048 bits,
				for both ZSKs and KSKs. [GL #1097]

	5249.	[bug]		Fix a possible underflow in recursion clients
				statistics when hitting recursive clients
				soft quota. [GL #1067]

.. code-block:: none

		--- 9.15.1 released ---

	5248.	[func]		To clarify the configuration of DNSSEC keys,
				the "managed-keys" and "trusted-keys" options
				have both been deprecated.  The new "dnssec-keys"
				statement can now be used for all trust anchors,
				with the keywords "iniital-key" or "static-key"
				to indicate whether the configured trust anchor
				should be used for initialization of RFC 5011 key
				management, or as a permanent trust anchor.

				The "static-key" keyword will generate a warning if
				used for the root zone.

				Configurations using "trusted-keys" or "managed-keys"
				will continue to work with no changes, but will
				generate warnings in the log. In a future release,
				these options will be marked obsolete. [GL #6]

	5247.	[cleanup]	The 'cleaning-interval' option has been removed.
				[GL !1731]

	5246.	[func]		Log TSIG if appropriate in 'sending notify to' message.
				[GL #1058]

	5245.	[cleanup]	Reduce logging level for IXFR up-to-date poll
				responses. [GL #1009]

	5244.	[security]	Fixed a race condition in dns_dispatch_getnext()
				that could cause an assertion failure if a
				significant number of incoming packets were
				rejected. (CVE-2019-6471) [GL #942]

	5243.	[bug]		Fix a possible race between dispatcher and socket
				code in a high-load cold-cache resolver scenario.
				[GL #943]

	5242.	[bug]		In relaxed qname minimization mode, fall back to
				normal resolution when encountering a lame
				delegation, and use _.domain/A queries rather
				than domain/NS. [GL #1055]

	5241.	[bug]		Fix Ed448 private and public key ASN.1 prefix blobs.
				[GL #225]

	5240.	[bug]		Remove key id calculation for RSAMD5. [GL #996]

	5239.	[func]		Change the json-c detection to pkg-config. [GL #855]

	5238.	[bug]		Fix a possible deadlock in TCP code. [GL #1046]

	5237.	[bug]		Recurse to find the root server list with 'dig +trace'.
				[GL #1028]

	5236.	[func]		Add SipHash 2-4 implementation in lib/isc/siphash.c
				and switch isc_hash_function() to use SipHash 2-4.
				[GL #605]

	5235.	[cleanup]	Refactor lib/isc/app.c to be thread-safe, unused
				parts of the API has been removed and the
				isc_appctx_t data type has been changed to be
				fully opaque. [GL #1023]

	5234.	[port]		arm: just use the compiler's default support for
				yield. [GL #981]

.. code-block:: none

		--- 9.15.0 released ---

	5233.	[bug]		Negative trust anchors did not work with "forward only;"
				to validating resolvers. [GL #997]

	5232.	[placeholder]

	5231.	[protocol]	Add support for displaying CLIENT-TAG and SERVER-TAG.
				[GL #960]

	5230.	[protocol]	The SHA-1 hash algorithm is no longer used when
				generating DS and CDS records. [GL #1015]

	5229.	[protocol]	Enforce known SSHFP fingerprint lengths. [GL #852]

	5228.	[func]		If trusted-keys and managed-keys were configured
				simultaneously for the same name, the key could
				not be be rolled automatically. This is now
				a fatal configuration error. [GL #868]

	5227.	[placeholder]

	5226.	[placeholder]

	5225.	[func]		Allow dig to print out AAAA record fully expanded.
				with +[no]expandaaaa. [GL #765]

	5224.	[bug]		Only test provide-ixfr on TCP streams. [GL #991]

	5223.	[bug]		Fixed a race in the filter-aaaa plugin accessing
				the hash table. [GL #1005]

	5222.	[bug]		'delv -t ANY' could leak memory. [GL #983]

	5221.	[test]		Enable parallel execution of system tests on
				Windows. [GL !4101]

	5220.	[cleanup]	Refactor the isc_stat structure to take advantage
				of stdatomic. [GL !1493]

	5219.	[bug]		Fixed a race in the filter-aaaa plugin that could
				trigger a crash when returning an instance object
				to the memory pool. [GL #982]

	5218.	[bug]		Conditionally include <dlfcn.h>. [GL #995]

	5217.	[bug]		Restore key id calculation for RSAMD5. [GL #996]

	5216.	[bug]		Fetches-per-zone counter wasn't updated correctly
				when doing qname minimization. [GL #992]

	5215.	[bug]		Change #5124 was incomplete; named could still
				return FORMERR instead of SERVFAIL in some cases.
				[GL #990]

	5214.	[bug]		win32: named now removes its lock file upon shutdown.
				[GL #979]

	5213.	[bug]		win32: Eliminated a race which allowed named.exe running
				as a service to be killed prematurely during shutdown.
				[GL #978]

	5212.	[placeholder]

	5211.	[bug]		Allow out-of-zone additional data to be included
				in authoritative responses if recursion is allowed
				and "minimal-responses" is disabled.  This behavior
				was inadvertently removed in change #4605. [GL #817]

	5210.	[bug]		When dnstap is enabled and recursion is not
				available, incoming queries are now logged
				as "auth". Previously, this depended on whether
				recursion was requested by the client, not on
				whether recursion was available. [GL #963]

	5209.	[bug]		When update-check-ksk is true, add_sigs was not
				considering offline keys, leaving record sets signed
				with the incorrect type key. [GL #763]

	5208.	[test]		Run valid rdata wire encodings through totext+fromtext
				and tofmttext+fromtext methods to check these methods.
				[GL #899]

	5207.	[test]		Check delv and dig TTL values. [GL #965]

	5206.	[bug]		Delv could print out bad TTLs. [GL #965]

	5205.	[bug]		Enforce that a DS hash exists. [GL #899]

	5204.	[test]		Check that dns_rdata_fromtext() produces a record that
				will be accepted by dns_rdata_fromwire(). [GL #852]

	5203.	[bug]		Enforce whether key rdata exists or not in KEY,
				DNSKEY, CDNSKEY and RKEY. [GL #899]

	5202.	[bug]		<dns/ecs.h> was missing ISC_LANG_ENDDECLS. [GL #976]

	5201.	[bug]		Fix a possible deadlock in RPZ update code. [GL #973]

	5200.	[security]	tcp-clients settings could be exceeded in some cases,
				which could lead to exhaustion of file descriptors.
				(CVE-2018-5743) [GL #615]

	5199.	[security]	In certain configurations, named could crash
				if nxdomain-redirect was in use and a redirected
				query resulted in an NXDOMAIN from the cache.
				(CVE-2019-6467) [GL #880]

	5198.	[bug]		If a fetch context was being shut down and, at the same
				time, we returned from qname minimization, an INSIST
				could be hit. [GL #966]

	5197.	[bug]		dig could die in best effort mode on multiple SIG(0)
				records. Similarly on multiple OPT and multiple TSIG
				records. [GL #920]

	5196.	[bug]		make install failed with --with-dlopen=no. [GL #955]

	5195.	[bug]		"allow-update" and "allow-update-forwarding" were
				treated as configuration errors if used at the
				options or view level. [GL #913]

	5194.	[bug]		Enforce non empty ZOMEMD hash. [GL #899]

	5193.	[bug]		EID and NIMLOC failed to do multi-line output
				correctly. [GL #899]

	5192.	[placeholder]

	5191.	[placeholder]

	5190.	[bug]		Ignore trust anchors using disabled algorithms.
				[GL #806]

	5189.	[cleanup]	Remove revoked root DNSKEY from bind.keys. [GL #945]

	5188.	[func]		The "dnssec-enable" option is deprecated and no
				longer has any effect; DNSSEC responses are
				always enabled. [GL #866]

	5187.	[test]		Set time zone before running any tests in dnstap_test.
				[GL #940]

	5186.	[cleanup]	More dnssec-keygen manual tidying. [GL !1678]

	5185.	[placeholder]

	5184.	[bug]		Missing unlocks in sdlz.c. [GL #936]

	5183.	[bug]		Reinitialize ECS data before reusing client
				structures. [GL #881]

	5182.	[bug]		Fix a high-load race/crash in handling of
				isc_socket_close() in resolver. [GL #834]

	5181.	[func]		Add a mechanism for a DLZ module to signal that
				the view's allow-transfer ACL should be used to
				determine whether transfers are allowed. [GL #803]

	5180.	[bug]		delv now honors the operating system's preferred
				ephemeral port range. [GL #925]

	5179.	[cleanup]	Replace some vague type declarations with the more
				specific dns_secalg_t and dns_dsdigest_t.
				Thanks to Tony Finch. [GL !1498]

	5178.	[bug]		Handle EDQUOT (disk quota) and ENOSPC (disk full)
				errors when writing files. [GL #902]

	5177.	[func]		Add the ability to specify in named.conf whether a
				response-policy zone's SOA record should be added
				to the additional section (add-soa yes/no). [GL #865]

	5176.	[tests]		Remove a dependency on libxml in statschannel system
				test. [GL #926]

	5175.	[bug]		Fixed a problem with file input in dnssec-keymgr,
				dnssec-coverage and dnssec-checkds when using
				python3. [GL #882]

	5174.	[doc]		Tidy dnssec-keygen manual. [GL !1557]

	5173.	[bug]		Fixed a race in socket code that could occur when
				accept, send, or recv were called from an event
				loop but the socket had been closed by another
				thread. [RT #874]

	5172.	[bug]		nsupdate now honors the operating system's preferred
				ephemeral port range. [GL #905]

	5171.	[func]		named plugins are now installed into a separate
				directory.  Supplying a filename (a string without path
				separators) in a "plugin" configuration stanza now
				causes named to look for that plugin in that directory.
				[GL #878]

	5170.	[test]		Added --with-dlz-filesystem to feature-test. [GL !1587]

	5169.	[bug]		The presence of certain types in an otherwise
				empty node could cause a crash while processing a
				type ANY query. [GL #901]

	5168.	[bug]		Do not crash on shutdown when RPZ fails to load.  Also,
				keep previous version of the database if RPZ fails to
				load. [GL #813]

	5167.	[bug]		nxdomain-redirect could sometimes lookup the wrong
				redirect name. [GL #892]

	5166.	[placeholder]

	5165.	[contrib]	Removed SDB drivers from contrib; they're obsolete.
				[GL #428]

	5164.	[bug]		Correct errno to result translation in dlz filesystem
				modules. [GL #884]

	5163.	[cleanup]	Out-of-tree builds failed --enable-dnstap. [GL #836]

	5162.	[cleanup]	Improve dnssec-keymgr manual. Thanks to Tony Finch.
				[GL !1518]

	5161.	[bug]		Do not require the SEP bit to be set for mirror zone
				trust anchors. [GL #873]

	5160.	[contrib]	Added DNAME support to the DLZ LDAP schema. Also
				fixed a compilation bug affecting several DLZ
				modules. [GL #872]

	5159.	[bug]		dnssec-coverage was incorrectly ignoring
				names specified on the command line without
				trailing dots. [GL !1478]

	5158.	[protocol]	Add support for AMTRELAY and ZONEMD. [GL #867]

	5157.	[bug]		Nslookup now errors out if there are extra command
				line arguments. [GL #207]

	5156.	[doc]		Extended and refined the section of the ARM describing
				mirror zones. [GL #774]

	5155.	[func]		"named -V" now outputs the default paths to
				named.conf, rndc.conf, bind.keys, and other
				files used or created by named and other tools, so
				that the correct paths to these files can quickly be
				determined regardless of the configure settings
				used when BIND was built. [GL #859]

	5154.	[bug]		dig: process_opt could be called twice on the same
				message leading to a assertion failure. [GL #860]

	5153.	[func]		Zone transfer statistics (size, number of records, and
				number of messages) are now logged for outgoing
				transfers as well as incoming ones. [GL #513]

	5152.	[func]		Improved logging of DNSSEC key events:
				- Zone signing and DNSKEY maintenance events are
				  now logged to the "dnssec" category
				- Messages are now logged when DNSSEC keys are
				  published, activated, inactivated, deleted,
				  or revoked.
				[GL #714]

	5151.	[func]		Options that have been been marked as obsolete in
				named.conf for a very long time are now fatal
				configuration errors. [GL #358]

	5150.	[cleanup]	Remove the ability to compile BIND with assertions
				disabled. [GL #735]

	5149.	[func]		"rndc dumpdb" now prints a line above a stale RRset
				indicating how long the data will be retained in the
				cache for emergency use. [GL #101]

	5148.	[bug]		named did not sign the TKEY response. [GL #821]

	5147.	[bug]		dnssec-keymgr: Add a five-minute margin to better
				handle key events close to 'now'. [GL #848]

	5146.	[placeholder]

	5145.	[func]		Use atomics instead of locked variables for isc_quota
				and isc_counter. [GL !1389]

	5144.	[bug]		dig now returns a non-zero exit code when a TCP
				connection is prematurely closed by a peer more than
				once for the same lookup.  [GL #820]

	5143.	[bug]		dnssec-keymgr and dnssec-coverage failed to find
				key files for zone names ending in ".". [GL #560]

	5142.	[cleanup]	Removed "configure --disable-rpz-nsip" and
				"--disable-rpz-nsdname" options. "nsip-enable"
				and "nsdname-enable" both now default to yes,
				regardless of compile-time settings. [GL #824]

	5141.	[security]	Zone transfer controls for writable DLZ zones were
				not effective as the allowzonexfr method was not being
				called for such zones. (CVE-2019-6465) [GL #790]

	5140.	[bug]		Don't immediately mark existing keys as inactive and
				deleted when running dnssec-keymgr for the first
				time. [GL #117]

	5139.	[bug]		If possible, don't use forwarders when priming.
				This ensures we can get root server IP addresses
				from priming query response glue, which may not
				be present if the forwarding server is returning
				minimal responses. [GL #752]

	5138.	[bug]		Under some circumstances named could hit an assertion
				failure when doing qname minimization when using
				forwarders. [GL #797]

	5137.	[func]		named now logs messages whenever a mirror zone becomes
				usable or unusable for resolution purposes. [GL #818]

	5136.	[cleanup]	Check in named-checkconf that allow-update and
				allow-update-forwarding are not set at the
				view/options level; fix documentation. [GL #512]

	5135.	[port]		sparc: Use smt_pause() instead of pause. [GL #816]

	5134.	[bug]		win32: WSAStartup was not called before getservbyname
				was called. [GL #590]

	5133.	[bug]		'rndc managed-keys' didn't handle class and view
				correctly and failed to add new lines between each
				view. [GL !1327]

	5132.	[bug]		Fix race condition in cleanup part of dns_dt_create().
				[GL !1323]

	5131.	[cleanup]	Address Coverity warnings. [GL #801]

	5130.	[cleanup]	Remove support for l10n message catalogs. [GL #709]

	5129.	[contrib]	sdlz_helper.c:build_querylist was not properly
				splitting the query string. [GL #798]

	5128.	[bug]		Refreshkeytime was not being updated for managed
				keys zones. [GL #784]

	5127.	[bug]		rcode.c:maybe_numeric failed to handle NUL in text
				regions. [GL #807]

	5126.	[bug]		Named incorrectly accepted empty base64 and hex encoded
				fields when reading master files. [GL #807]

	5125.	[bug]		Allow for up to 100 records or 64k of data when caching
				a negative response. [GL #804]

	5124.	[bug]		Named could incorrectly return FORMERR rather than
				SERVFAIL. [GL #804]

	5123.	[bug]		dig could hang indefinitely after encountering an error
				before creating a TCP socket. [GL #692]

	5122.	[bug]		In a "forward first;" configuration, a forwarder
				timeout did not prevent that forwarder from being
				queried again after falling back to full recursive
				resolution. [GL #315]

	5121.	[contrib]	dlz_stub_driver.c fails to return ISC_R_NOTFOUND on none
				matching zone names. [GL !1299]

	5120.	[placeholder]

	5119.	[placeholder]

	5118.	[security]	Named could crash if it is managing a key with
				`managed-keys` and the authoritative zone is rolling
				the key to an unsupported algorithm. (CVE-2018-5745)
				[GL #780]

	5117.	[placeholder]

	5116.	[bug]		Named/named-checkconf triggered a assertion when
				a mirror zone's name is bad. [GL #778]

	5115.	[bug]		Allow unsupported algorithms in zone when not used for
				signing with dnssec-signzone. [GL #783]

	5114.	[func]		Include a 'reconfig/reload in progress' status line
				in rndc status, use it in tests.

	5113.	[port]		Fixed a Windows build error.

	5112.	[bug]		Named/named-checkconf could dump core if there was
				a missing masters clause and a bad notify clause.
				[GL #779]

	5111.	[bug]		Occluded DNSKEY records could make it into the
				delegating NSEC/NSEC3 bitmap. [GL #742]

	5110.	[security]	Named leaked memory if there were multiple Key Tag
				EDNS options present. (CVE-2018-5744) [GL #772]

	5109.	[cleanup]	Remove support for RSAMD5 algorithm. [GL #628]

.. code-block:: none

		--- 9.13.5 released ---

	5108.	[bug]		Named could fail to determine bottom of zone when
				removing out of date keys leading to invalid NSEC
				and NSEC3 records being added to the zone. [GL #771]

	5107.	[bug]		'host -U' did not work. [GL #769]

	5106.	[experimental]	A new "plugin" mechanism has been added to allow
				extension of query processing functionality through
				the use of dynamically loadable libraries. A
				"filter-aaaa.so" plugin has been implemented,
				replacing the filter-aaaa feature that was formerly
				implemented as a native part of BIND.

				The "filter-aaaa", "filter-aaaa-on-v4" and
				"filter-aaaa-on-v6" options can no longer be
				configured using native named.conf syntax. However,
				loading the filter-aaaa.so plugin and setting its
				parameters provides identical functionality.

				Note that the plugin API is a work in progress and
				is likely to evolve as further plugins are
				implemented. [GL #15]

	5105.	[bug]		Fix a race between process_fd and socketclose in
				unix socket code. [GL #744]

	5104.	[cleanup]	Log clearer informational message when a catz zone
				is overridden by a zone in named.conf.
				Thanks to Tony Finch. [GL !1157]

	5103.	[bug]		Add missing design by contract tests to dns_catz*.
				[GL #748]

	5102.	[bug]		dnssec-coverage failed to use the default TTL when
				checking KSK deletion times leading to a exception.
				[GL #585]

	5101.	[bug]		Fix default installation path for Python modules and
				remove the dnspython dependency accidentally introduced
				by change 4970. [GL #730]

	5100.	[func]		Pin resolver tasks to specific task queues. [GL !1117]

	5099.	[func]		Failed mutex and conditional creations are always
				fatal. [GL #674]

.. code-block:: none

		--- 9.13.4 released ---

	5098.	[func]		Failed memory allocations are now fatal. [GL #674]

	5097.	[cleanup]	Remove embedded ATF unit testing framework
				from BIND source distribution.  [GL !875]

	5096.	[func]		Use multiple event loops in socket code, and
				make network threads CPU-affinitive.  This
				significantly improves performance on large
				systems. [GL #666]

	5095.	[test]		Converted all unit tests from ATF to CMocka;
				removed the source code for the ATF libraries.
				Build with "configure --with-cmocka" to enable
				unit testing. [GL #620]

	5094.	[func]		Add 'dig -r' to disable reading of .digrc. [GL !970]

	5093.	[bug]		Log lame qname-minimization servers only if they're
				really lame. [GL #671]

	5092.	[bug]		Address memory leak on SIGTERM in nsupdate when using
				GSS-TSIG. [GL #558]

	5091.	[func]		Two new global and per-view options min-cache-ttl
				and min-ncache-ttl [GL #613]

	5090.	[bug]		dig and mdig failed to properly pre-parse dash value
				pairs when value was a separate argument and started
				with a dash. [GL #584]

	5089.	[bug]		Restore localhost fallback in dig and host which is
				used when no nameserver addresses present in
				/etc/resolv.conf are usable due to the requested
				address family restrictions. [GL #433]

	5088.	[bug]		dig/host/nslookup could crash when interrupted close to
				a query timeout. [GL #599]

	5087.	[test]		Check that result tables are complete. [GL #676]

	5086.	[func]		Log of RPZ now includes the QTYPE and QCLASS. [GL #623]

	5085.	[bug]		win32: Restore looking up nameservers, search list,
				etc. [GL #186]

	5084.	[placeholder]

	5083.	[func]		Add autoconf macro AX_POSIX_SHELL, so we
				can use POSIX-compatible shell features
				in the scripts.

	5082.	[bug]		Fixed a race that could cause a crash in
				dig/host/nslookup. [GL #650]

	5081.	[func]		Use per-worker queues in task manager, make task
				runners CPU-affine. [GL #659]

	5080.	[func]		Improvements to "rndc nta" user interface:
				- catch and report invalid command line options
				- when removing an NTA from all views, do not
				  abort with an error if the NTA was not found
				  in one of the views
				- include the view name in "rndc nta -dump"
				  output, for consistency with the add and remove
				  actions
				Thanks to Tony Finch. [GL !816]

	5079.	[func]		Disable IDN processing in dig and nslookup
				when not on a tty. [GL #653]

	5078.	[cleanup]	Require python components to be explicitly disabled if
				python is not available on unix platforms. [GL #601]

	5077.	[cleanup]	Remove ip6.int support (-i) from dig and mdig.
				[GL !969]

	5076.	[bug]		"require-server-cookie" was not effective if
				"rate-limit" was configured. [GL #617]

	5075.	[bug]		Refresh nameservers from cache when sending final
				query in qname minimization. [GL #16]

	5074.	[cleanup]	Remove vector socket functions - isc_socket_recvv(),
				isc_socket_sendtov(), isc_socket_sendtov2(),
				isc_socket_sendv() - in order to simplify socket code.
				[GL #645]

	5073.	[bug]		Destroy a task first when destroying rpzs and catzs.
				[GL #84]

	5072.	[bug]		Add unit tests for isc_buffer_copyregion() and fix its
				behavior for auto-reallocated buffers. [GL #644]

	5071.	[bug]		Comparison of NXT records was broken. [GL #631]

	5070.	[bug]		Record types which support a empty rdata field were
				not handling the empty rdata field case. [GL #638]

	5069.	[bug]		Fix a hang on in RPZ when named is shutdown during RPZ
				zone update. [GL !907]

	5068.	[bug]		Fix a race in RPZ with min-update-interval set to 0.
				[GL #643]

	5067.	[bug]		Don't minimize qname when sending the query
				to a forwarder. [GL #361]

	5066.	[cleanup]	Allow unquoted strings to be used as a zone names
				in response-policy statements. [GL #641]

	5065.	[bug]		Only set IPV6_USE_MIN_MTU on IPv6. [GL #553]

	5064.	[test]		Initialize TZ environment variable before calling
				dns_test_begin in dnstap_test. [GL #624]

	5063.	[test]		In statschannel test try a few times before failing
				when checking if the compressed output is the same as
				uncompressed. [GL !909]

	5062.	[func]		Use non-crypto-secure PRNG to generate nonces for
				cookies. [GL !887]

	5061.	[protocol]	Add support for EID and NIMLOC. [GL #626]

	5060.	[bug]		GID, UID and UINFO could not be loaded using unknown
				record format. [GL #627]

	5059.	[bug]		Display a per-view list of zones in the web interface.
				[GL #427]

	5058.	[func]		Replace old message digest and hmac APIs with more
				generic isc_md and isc_hmac APIs, and convert their
				respective tests to cmocka. [GL #305]

	5057.	[protocol]	Add support for ATMA. [GL #619]

	5056.	[placeholder]

	5055.	[func]		A default list of primary servers for the root zone is
				now built into named, allowing the "masters" statement
				to be omitted when configuring an IANA root zone
				mirror. [GL #564]

	5054.	[func]		Attempts to use mirror zones with recursion disabled
				are now considered a configuration error. [GL #564]

	5053.	[func]		The only valid zone-level NOTIFY settings for mirror
				zones are now "notify no;" and "notify explicit;".
				[GL #564]

	5052.	[func]		Mirror zones are now configured using "type mirror;"
				rather than "mirror yes;". [GL #564]

	5051.	[doc]		Documentation incorrectly stated that the
				"server-addresses" static-stub zone option accepts
				custom port numbers. [GL #582]

	5050.	[bug]		The libirs version of getaddrinfo() was unable to parse
				scoped IPv6 addresses present in /etc/resolv.conf.
				[GL #187]

	5049.	[cleanup]	QNAME minimization has been deeply refactored. [GL #16]

	5048.	[func]		Add configure option to enable and enforce FIPS mode
				in BIND 9. [GL #506]

	5047.	[bug]		Messages logged for certain query processing failures
				now include a more specific error description if it is
				available. [GL #572]

	5046.	[bug]		named could crash during shutdown if an RPZ
				reload was in progress. [RT #46210]

	5045.	[func]		Remove support for DNSSEC algorithms 3 (DSA)
				and 6 (DSA-NSEC3-SHA1). [GL #22]

	5044.	[cleanup]	If "dnssec-enable" is no, then "dnssec-validation"
				now also defaults to no.  [GL #388]

	5043.	[bug]		Fix creating and validating EdDSA signatures. [GL #579]

	5042.	[test]		Make the chained delegations in reclimit behave
				like they would in a regular name server. [GL #578]

	5041.	[test]		The chain test contains a incomplete delegation.
				[GL #568]

	5040.	[func]		Extended dnstap so that it can log UPDATE requests
				and responses as separate message types. Thanks
				to Greg Rabil. [GL #570]

	5039.	[bug]		Named could fail to preserve owner name case of new
				RRset. [GL #420]

	5038.	[bug]		Chaosnet addresses were compared incorrectly.
				[GL #562]

	5037.	[func]		"allow-recursion-on" and "allow-query-cache-on"
				each now default to the other if only one of them
				is set, in order to be more consistent with the way
				"allow-recursion" and "allow-query-cache" work.
				Also we now ensure that both query-cache ACLs are
				checked when determining cache access. [GL #319]

	5036.	[cleanup]	Fixed a spacing/formatting error in some RPZ-related
				error messages in the log. [GL !805]

	5035.	[test]		Fixed errors that prevented the DNSRPS subtests
				from running in the rpz and rpzrecurse system
				tests. [GL #503]

	5034.	[bug]		A race between threads could prevent zone maintenance
				scheduled immediately after zone load from being
				performed. [GL #542]

	5033.	[bug]		When adding NTAs to multiple views using "rndc nta",
				the text returned via rndc was incorrectly terminated
				after the first line, making it look as if only one
				NTA had been added. Also, it was not possible to
				differentiate between views with the same name but
				different classes; this has been corrected with the
				addition of a "-class" option. [GL #105]

	5032.	[func]		Add krb5-selfsub and ms-selfsub update policy rules.
				[GL #511]

	5031.	[cleanup]	Various defines in platform.h has been either dropped
				if always or never triggered on supported platforms
				or replaced with config.h equivalents if the defines
				didn't have any impact on public headers.  Workarounds
				for LinuxThreads have been removed because NPTL is
				available since Linux kernel 2.6.0.  [GL #525]

	5030.	[bug]		Align CMSG buffers to a 64-bit boundary, fixes crash
				on architectures with strict alignment. [GL #521]

.. code-block:: none

		--- 9.13.3 released ---

	5029.	[func]		Workarounds for servers that misbehave when queried
				with EDNS have been removed, because these broken
				servers and the workarounds for their noncompliance
				cause unnecessary delays, increase code complexity,
				and prevent deployment of new DNS features. See
				https://dnsflagday.net for further details. [GL #150]

	5028.	[bug]		Spread the initial RRSIG expiration times over the
				entire working sig-validity-interval when signing a
				zone in named to even out re-signing and transfer
				loads. [GL #418]

	5027.	[func]		Set SO_SNDBUF size on sockets. [GL #74]

	5026.	[bug]		rndc reconfig should not touch already loaded zones.
				[GL #276]

	5025.	[cleanup]	Remove isc_keyboard family of functions. [GL #178]

	5024.	[func]		Replace custom assembly for atomic operations with
				atomic support from the compiler. The code will now use
				C11 stdatomic, or __atomic, or __sync builtins with GCC
				or Clang compilers, and Interlocked functions with MSVC.
				[GL #10]

	5023.	[cleanup]	Remove wrappers that try to fix broken or incomplete
				implementations of IPv6, pthreads and other core
				functionality required and used by BIND. [GL #192]

	5022.	[doc]		Update ms-self, ms-subdomain, krb5-self, and
				krb5-subdomain documentation. [GL !708]

	5021.	[bug]		dig returned a non-zero exit code when it received a
				reply over TCP after a retry. [GL #487]

	5020.	[func]		RNG uses thread-local storage instead of locks, if
				supported by platform. [GL #496]

	5019.	[cleanup]	A message is now logged when ixfr-from-differences is
				set at zone level for an inline-signed zone. [GL #470]

	5018.	[bug]		Fix incorrect sizeof arguments in lib/isc/pk11.c.
				[GL !588]

	5017.	[bug]		lib/isc/pk11.c failed to unlink the session before
				releasing the lock which is unsafe. [GL !589]

	5016.	[bug]		Named could assert with overlapping filter-aaaa and
				dns64 acls. [GL #445]

	5015.	[bug]		Reloading all zones caused zone maintenance to cease
				for inline-signed zones. [GL #435]

	5014.	[bug]		Signatures loaded from the journal for the signed
				version of an inline-signed zone were not scheduled for
				refresh. [GL #482]

	5013.	[bug]		A referral response with a non-empty ANSWER section was
				inadvertently being treated as an error. [GL #390]

	5012.	[bug]		Fix lock order reversal in pk11_initialize. [GL !590]

	5011.	[func]		Remove support for unthreaded named. [GL #478]

	5010.	[func]		New "validate-except" option specifies a list of
				domains beneath which DNSSEC validation should not
				be performed. [GL #237]

	5009.	[bug]		Upon an OpenSSL failure, the first error in the OpenSSL
				error queue was not logged. [GL #476]

	5008.	[bug]		"rndc signing -nsec3param ..." requests were silently
				ignored for zones which were not yet loaded or
				transferred. [GL #468]

	5007.	[cleanup]	Replace custom ISC boolean and integer data types
				with C99 stdint.h and stdbool.h types. [GL #9]

	5006.	[cleanup]	Code preparing a delegation response was extracted from
				query_delegation() and query_zone_delegation() into a
				separate function in order to decrease code
				duplication. [GL #431]

	5005.	[bug]		dnssec-verify, and dnssec-signzone at the verification
				step, failed on some validly signed zones. [GL #442]

	5004.	[bug]		'rndc reconfig' could cause inline zones to stop
				re-signing. [GL #439]

	5003.	[bug]		dns_acl_isinsecure did not handle geoip elements.
				[GL #406]

	5002.	[bug]		mdig: Handle malformed +ednsopt option, support 100
				+ednsopt options per query rather than 100 total and
				address memory leaks if +ednsopt was specified.
				[GL #410]

	5001.	[bug]		Fix refcount errors on error paths. [GL !563]

	5000.	[bug]		named_server_servestale() could leave the server in
				exclusive mode if an error occurred. [GL #441]

	4999.	[cleanup]	Remove custom printf implementation in lib/isc/print.c.
				[GL #261]

	4998.	[test]		Make resolver and cacheclean tests more civilized.

	4997.	[security]	named could crash during recursive processing
				of DNAME records when "deny-answer-aliases" was
				in use. (CVE-2018-5740) [GL #387]

	4996.	[bug]		dig: Handle malformed +ednsopt option. [GL #403]

	4995.	[test]		Add tests for "tcp-self" update policy. [GL !282]

	4994.	[bug]		Trust anchor telemetry queries were not being sent
				upstream for locally served zones. [GL #392]

	4993.	[cleanup]	Remove support for silently ignoring 'no-change' deltas
				from BIND 8 when processing an IXFR stream. 'no-change'
				deltas will now trigger a fallback to AXFR as the
				recovery mechanism. [GL #369]

	4992.	[bug]		The wrong address was being logged for trust anchor
				telemetry queries. [GL #379]

	4991.	[bug]		"rndc reconfig" was incorrectly handling zones whose
				"mirror" setting was changed. [GL #381]

	4990.	[bug]		Prevent a possible NULL reference in pkcs11-keygen.
				[GL #401]

	4989.	[cleanup]	IDN support in dig has been reworked.  IDNA2003
				fallbacks were removed in the process. [GL #384]

	4988.	[bug]		Don't synthesize NXDOMAIN from NSEC for records under
				a DNAME.

.. code-block:: none

		--- 9.13.2 released ---

	4987.	[cleanup]	dns_rdataslab_tordataset() and its related
				dns_rdatasetmethods_t callbacks were removed as they
				were not being used by anything in BIND. [GL #371]

	4986.	[func]		When built on Linux, BIND now requires the libcap
				library to set process privileges, unless capability
				support is explicitly overridden with "configure
				--disable-linux-caps". [GL #321]

	4985.	[func]		Add a new slave zone option, "mirror", to enable
				serving a non-authoritative copy of a zone that
				is subject to DNSSEC validation before being
				used.  For now, this option is only meant to
				facilitate deployment of an RFC 7706-style local
				copy of the root zone. [GL #33]

	4984.	[bug]		Improve handling of very large incremental
				zone transfers to prevent journal corruption. [GL #339]

	4983.	[func]		Add the ability to not return a DNS COOKIE option
				when one is present in the request (answer-cookie no;).
				[GL #173]

	4982.	[cleanup]	Return FORMERR if the question section is empty
				and no COOKIE option is present; this restores
				older behavior except in the newly specified
				COOKIE case. [GL #260]

	4981.	[bug]		Fix race in cmsg buffer usage in socket code.
				[GL #180]

	4980.	[bug]		Named-checkconf failed to detect bad in-view targets.
				[GL #288]

	4979.	[placeholder]

	4978.	[test]		Fix error handling and resolver configuration in the
				"rpz" system test. [GL #312]

	4977.	[func]		When starting up, log the same details that
				would be reported by 'named -V'. [GL #247]

	4976.	[bug]		Log the label with invalid prefix length correctly
				when loading RPZ zones. [GL #254]

	4975.	[bug]		The server cookie computation for sha1 and sha256 did
				not match the method described in RFC 7873. [GL #356]

	4974.	[bug]		Restore default rrset-order to random. [GL #336]

	4973.	[func]		verifyzone() and the functions it uses were moved to
				libdns and refactored to prevent exit() from being
				called upon failure.  A side effect of that is that
				dnssec-signzone and dnssec-verify now check for memory
				leaks upon shutdown. [GL #266]

	4972.	[func]		Declare the 'rdata' argument for dns_rdata_tostruct()
				to be const. [GL #341]

	4971.	[bug]		dnssec-signzone and dnssec-verify did not treat records
				below a DNAME as out-of-zone data. [GL #298]

	4970.	[func]		Add QNAME minimization option to resolver. [GL #16]

	4969.	[cleanup]	Refactor zone logging functions. [GL #269]

.. code-block:: none

		--- 9.13.1 released ---

	4968.	[bug]		If glue records are signed, attempt to validate them.
				[GL #209]

	4967.	[cleanup]	Add "answer-cookie" to the parser, marked obsolete.

	4966.	[placeholder]

	4965.	[func]		Add support for marking options as deprecated.
				[GL #322]

	4964.	[bug]		Reduce the probability of double signature when deleting
				a DNSKEY by checking if the node is otherwise signed
				by the algorithm of the key to be deleted. [GL #240]

	4963.	[test]		ifconfig.sh now uses "ip" instead of "ifconfig",
				if available, to configure the test interfaces on
				linux.  [GL #302]

	4962.	[cleanup]	Move 'named -T' processing to its own function.
				[GL #316]

	4961.	[protocol]	Remove support for ECC-GOST (GOST R 34.11-94).
				[GL #295]

	4960.	[security]	When recursion is enabled, but the "allow-recursion"
				and "allow-query-cache" ACLs are not specified,
				they should be limited to local networks,
				but were inadvertently set to match the default
				"allow-query", thus allowing remote queries.
				(CVE-2018-5738) [GL #309]

	4959.	[func]		NSID logging (enabled by the "request-nsid" option)
				now has its own "nsid" category, instead of using the
				"resolver" category. [GL !332]

	4958.	[bug]		Remove redundant space from NSEC3 record. [GL #281]

	4957.	[func]		The default setting for "dnssec-validation" is now
				"auto", which activates DNSSEC validation using the
				IANA root key. (The default can be changed back to
				"yes", which activates DNSSEC validation only when keys
				are explicitly configured in named.conf, by building
				BIND with "configure --disable-auto-validation".)
				[GL #30]

	4956.	[func]		Change isc_random() to be just PRNG using xoshiro128**,
				and add isc_nonce_buf() that uses CSPRNG. [GL #289]

	4955.	[cleanup]	Silence cppcheck warnings in lib/dns/master.c.
				[GL #286]

	4954.	[func]		Messages about serving of stale answers are now
				directed to the "serve-stale" logging category.
				Also clarified serve-stale documentation. [GL !323]

	4953.	[bug]		Removed the option to build the red black tree
				database without a hash table; the non-hashing
				version was buggy and is not needed. [GL #184]

	4952.	[func]		Authoritative server support in named for the
				EDNS CLIENT-SUBNET option (which was experimental
				and not practical to deploy) has been removed.

				The ECS option is still supported in dig and mdig
				via the +subnet option, and can be parsed and logged
				when received by named, but it is no longer used
				for ACL processing. The "geoip-use-ecs" option
				is now obsolete; a warning will be logged if it is
				used in named.conf. "ecs" tags in an ACL definition
				are also obsolete and will cause the configuration
				to fail to load.  [GL #32]

	4951.	[protocol]	Add "HOME.ARPA" to list of built in empty zones as
				per RFC 8375. [GL #273]

.. code-block:: none

		--- 9.13.0 released ---

	4950.	[bug]		ISC_SOCKEVENTATTR_TRUNC was not be set. [GL #238]

	4949.	[placeholder]

	4948.	[bug]		When request-nsid is turned on, EDNS NSID options
				should be logged at level info. Since change 3741
				they have been logged at debug(3) by mistake.
				[GL !290]

	4947.	[func]		Replace all random functions with isc_random(),
				isc_random_buf() and isc_random_uniform() API.
				[GL #221]

	4946.	[bug]		Additional glue was not being returned by resolver
				for unsigned zones since change 4596. [GL #209]

	4945.	[func]		BIND can no longer be built without DNSSEC support.
				A cryptography provider (i.e., OpenSSL or a hardware
				service module with PKCS#11 support) must be
				available. [GL #244]

	4944.	[cleanup]	Silence cppcheck portability warnings in
				lib/isc/tests/buffer_test.c. [GL #239]

	4943.	[bug]		Change 4687 consumed too much memory when running
				system tests with --with-tuning=large.  Reduced the
				hash table size to 512 entries for 'named -m record'
				restoring the previous memory footprint. [GL #248]

	4942.	[cleanup]	Consolidate multiple instances of splitting of
				batchline in dig into a single function. [GL #196]

	4941.	[cleanup]	Silence clang static analyzer warnings. [GL #196]

	4940.	[cleanup]	Extract the loop in dns__zone_updatesigs() into
				separate functions to improve code readability.
				[GL #135]

	4939.	[test]		Add basic unit tests for update_sigs(). [GL #135]

	4938.	[placeholder]

	4937.	[func]		Remove support for OpenSSL < 1.0.0 [GL #191]

	4936.	[func]		Always use OpenSSL or PKCS#11 random data providers,
				and remove the --{enable,disable}-crypto-rand configure
				options. [GL #165]

	4935.	[func]		Add support for LibreSSL >= 2.7.0 (some OpenSSL 1.1.0
				call were added). [GL #191]

	4934.	[security]	The serve-stale feature could cause an assertion failure
				in rbtdb.c even when stale-answer-enable was false.
				Simultaneous use of stale cache records and NSEC
				aggressive negative caching could trigger a recursion
				loop. (CVE-2018-5737) [GL #185]

	4933.	[bug]		Not creating signing keys for an inline signed zone
				prevented changes applied to the raw zone from being
				reflected in the secure zone until signing keys were
				made available. [GL #159]

	4932.	[bug]		Bumped signed serial of an inline signed zone was
				logged even when an error occurred while updating
				signatures. [GL #159]

	4931.	[func]		Removed the "rbtdb64" database implementation.
				[GL #217]

	4930.	[bug]		Remove a bogus check in nslookup command line
				argument processing. [GL #206]

	4929.	[func]		Add the ability to set RA and TC in queries made by
				dig (+[no]raflag, +[no]tcflag). [GL #213]

	4928.	[func]		The "dnskey-sig-validity" option allows
				"sig-validity-interval" to be overridden for signatures
				covering DNSKEY RRsets. [GL #145]

	4927.	[placeholder]

	4926.	[func]		Add root key sentinel support.  To disable, add
				'root-key-sentinel no;' to named.conf. [GL #37]

	4925.	[func]		Several configuration options that define intervals
				can now take TTL value suffixes (for example, 2h or 1d)
				in addition to integer parameters. These include
				max-cache-ttl, max-ncache-ttl, max-policy-ttl,
				fstrm-set-reopen-interval, interface-interval, and
				min-update-interval. [GL #203]

	4924.	[cleanup]	Clean up the isc_string_* namespace and leave
				only strlcpy and strlcat. [GL #178]

	4923.	[cleanup]	Refactor socket and socket event options into
				enum types. [GL !135]

	4922.	[bug]		dnstap: Log the destination address of client
				packets rather than the interface address.
				[GL #197]

	4921.	[cleanup]	Add dns_fixedname_initname() and refactor the caller
				code to make usage of the new function, as a part of
				refactoring dns_fixedname_*() macros were turned into
				functions. [GL #183]

	4920.	[cleanup]	Clean up libdns removing most of the backwards
				compatibility wrappers.

	4919.	[cleanup]	Clean up the isc_hash_* namespace and leave only
				the FNV-1a hash implementation. [GL #178]

	4918.	[bug]		Fix double free after keygen error in dnssec-keygen
				when OpenSSL >= 1.1.0 is used and RSA_generate_key_ex
				fails. [GL #109]

	4917.	[func]		Support 64 RPZ policy zones by default. [GL #123]

	4916.	[func]		Remove IDNA2003 support and the bundled idnkit-1.0
				library.

	4915.	[func]		Implement IDNA2008 support in dig by adding support
				for libidn2.  New dig option +idnin has been added,
				which allows to process invalid domain names much
				like dig without IDN support.  libidn2 version 2.0
				or higher is needed for +idnout enabled by default.

	4914.	[security]	A bug in zone database reference counting could lead to
				a crash when multiple versions of a slave zone were
				transferred from a master in close succession.
				(CVE-2018-5736) [GL #134]

	4913.	[test]		Re-implemented older unit tests in bin/tests as ATF,
				removed the lib/tests unit testing library. [GL #115]

	4912.	[test]		Improved the reliability of the 'cds' system test.
				[GL #136]

	4911.	[test]		Improved the reliability of the 'mkeys' system test.
				[GL #128]

	4910.	[func]		Update util/check-changes to work on release branches.
				[GL #113]

	4909.	[bug]		named-checkconf did not detect in-view zone collisions.
				[GL #125]

	4908.	[test]		Eliminated unnecessary waiting in the allow_query
				system test. Also changed its name to allow-query.
				[GL #81]

	4907.	[test]		Improved the reliability of the 'notify' system
				test. [GL #59]

	4906.	[func]		Replace getquad() with inet_pton(), completing
				change #4900. [GL #56]

	4905.	[bug]		irs_resconf_load() ignored resolv.conf syntax errors
				when "domain" or "search" options were present in that
				file. [GL #110]

	4904.	[bug]		Temporarily revert change #4859. [GL #124]

	4903.	[bug]		"check-mx fail;" did not prevent MX records containing
				IP addresses from being added to a zone by a dynamic
				update. [GL #112]

	4902.	[test]		Improved the reliability of the 'ixfr' system
				test. [GL #66]

	4901.	[func]		"dig +nssearch" now lists the name servers
				for a domain that time out, as well as the servers
				that respond. [GL #64]

	4900.	[func]		Remove all uses of inet_aton().  As a result of this
				change, IPv4 addresses are now only accepted in
				dotted-quad format. [GL #13]

	4899.	[test]		Convert most of the remaining system tests to be able
				to run in parallel, continuing the work from change
				#4895. To take advantage of this, use "make -jN check",
				where N is the number of processors to use. [GL #91]

	4898.	[func]		Remove libseccomp based system-call filtering. [GL #93]

	4897.	[test]		Update to rpz system test so that it doesn't recurse.
				[GL #68]

	4896.	[test]		cacheclean system test was not robust. [GL #82]

	4895.	[test]		Allow some system tests to run in parallel.
				[RT #46602]

	4894.	[bug]		named could crash while rolling a dnstap output file.
				[RT #46942]

	4893.	[bug]		Address various issues reported by cppcheck. [GL #51]

	4892.	[bug]		named could leak memory when "rndc reload" was invoked
				before all zone loading actions triggered by a previous
				"rndc reload" command were completed. [RT #47076]

	4891.	[placeholder]

	4890.	[func]		Remove unused ondestroy callback from libisc.
				[isc-projects/bind9!3]

	4889.	[func]		Warn about the use of old root keys without the new
				root key being present.  Warn about dlv.isc.org's
				key being present. Warn about both managed and
				trusted root keys being present. [RT #43670]

	4888.	[test]		Initialize sockets correctly in sample-update so
				that the nsupdate system test will run on Windows.
				[RT #47097]

	4887.	[test]		Enable the rpzrecurse test to run on Windows.
				[RT #47093]

	4886.	[doc]		Document dig -u in manpage. [RT #47150]

	4885.	[security]	update-policy rules that otherwise ignore the name
				field now require that it be set to "." to ensure
				that any type list present is properly interpreted.
				[RT #47126]

	4884.	[bug]		named could crash on shutdown due to a race between
				shutdown_server() and ns__client_request(). [RT #47120]

	4883.	[cleanup]	Improved debugging output from dnssec-cds. [RT #47026]

	4882.	[bug]		Address potential memory leak in
				dns_update_signaturesinc. [RT #47084]

	4881.	[bug]		Only include dst_openssl.h when OpenSSL is required.
				[RT #47068]

	4880.	[bug]		Named wasn't returning the target of a cross-zone
				CNAME between two served zones when recursion was
				desired and available (RD=1, RA=1). (When this is
				not the case, the CNAME target is deliberately
				withheld to prevent accidental cache poisoning.)
				[RT #47078]

	4879.	[bug]		dns_rdata_caa:value_len field was too small.
				[RT #47086]

	4878.	[bug]		List 'ply' as a requirement for the 'isc' python
				package. [RT #47065]

	4877.	[bug]		Address integer overflow when exponentially
				backing off retry intervals. [RT #47041]

	4876.	[bug]		Address deadlock with accessing a keytable. [RT #47000]

	4875.	[bug]		Address compile failures on older systems. [RT #47015]

	4874.	[bug]		Wrong time display when reporting new keywarntime.
				[RT #47042]

	4873.	[doc]		Grammars for named.conf included in the ARM are now
				automatically generated by the configuration parser
				itself.  As a side effect of the work needed to
				separate zone type grammars from each other, this
				also makes checking of zone statements in
				named-checkconf more correct and consistent.
				[RT #36957]

	4872.	[bug]		Don't permit loading meta RR types such as TKEY
				from master files. [RT #47009]

	4871.	[bug]		Fix configure glitch in detecting stdatomic.h
				support on systems with multiple compilers.
				[RT #46959]

	4870.	[test]		Update included ATF library to atf-0.21 preserving
				the ATF tool. [RT #46967]

	4869.	[bug]		Address some cases where NULL with zero length could
				be passed to memmove which is undefined behavior and
				can lead to bad optimization. [RT #46888]

	4868.	[func]		dnssec-keygen can no longer generate HMAC keys.
				Use tsig-keygen instead. [RT #46404]

	4867.	[cleanup]	Normalize rndc on/off commands (validation,
				querylog, serve-stale) so they all accept the
				same synonyms for on/off (yes/no, true/false,
				enable/disable). Thanks to Tony Finch. [RT #47022]

	4866.	[port]		DST library initialization verifies MD5 (when MD5
				was not disabled) and SHA-1 hash and HMAC support.
				[RT #46764]

	4865.	[cleanup]	Simplify handling isc_socket_sendto2() return values.
				[RT #46986]

	4864.	[bug]		named acting as a slave for a catalog zone crashed if
				the latter contained a master definition without an IP
				address. [RT #45999]

	4863.	[bug]		Fix various other bugs reported by Valgrind's
				memcheck tool. [RT #46978]

	4862.	[bug]		The rdata flags for RRSIG were not being properly set
				when constructing a rdataslab. [RT #46978]

	4861.	[bug]		The isc_crc64 unit test was not endian independent.
				[RT #46973]

	4860.	[bug]		isc_int8_t should be signed char.  [RT #46973]

	4859.	[bug]		A loop was possible when attempting to validate
				unsigned CNAME responses from secure zones;
				this caused a delay in returning SERVFAIL and
				also increased the chances of encountering
				CVE-2017-3145. [RT #46839]

	4858.	[security]	Addresses could be referenced after being freed
				in resolver.c, causing an assertion failure.
				(CVE-2017-3145) [RT #46839]

	4857.	[bug]		Maintain attach/detach semantics for event->db,
				event->node, event->rdataset and event->sigrdataset
				in query.c. [RT #46891]

	4856.	[bug]		'rndc zonestatus' reported the wrong underlying type
				for a inline slave zone. [RT #46875]

	4855.	[bug]		isc_time_formatshorttimestamp produced incorrect
				output. [RT #46938]

	4854.	[bug]		query_synthcnamewildcard should stop generating the
				response if query_synthwildcard fails. [RT #46939]

	4853.	[bug]		Add REQUIRE's and INSIST's to isc_time_formatISO8601L
				and isc_time_formatISO8601Lms. [RT #46916]

	4852.	[bug]		Handle strftime() failing in isc_time_formatISO8601ms.
				Add REQUIRE's and INSIST's to isc_time_formattimestamp,
				isc_time_formathttptimestamp, isc_time_formatISO8601,
				isc_time_formatISO8601ms. [RT #46892]

	4851.	[port]		Support using kyua as well as atf-run to run the unit
				tests. [RT #46853]

	4850.	[bug]		Named failed to restart with multiple added zones in
				lmdb database. [RT #46889]

	4849.	[bug]		Duplicate zones could appear in the .nzf file if
				addzone failed. [RT #46435]

	4848.	[func]		Zone types "primary" and "secondary" can now be used
				as synonyms for "master" and "slave" in named.conf.
				[RT #46713]

	4847.	[bug]		dnssec-dnskey-kskonly was not being honored for
				CDS and CDNSKEY. [RT #46755]

	4846.	[test]		Adjust timing values in runtime system test. Address
				named.pid removal races in runtime system test.
				[RT #46800]

	4845.	[bug]		Dig (non iOS) should exit on malformed names.
				[RT #46806]

	4844.	[test]		Address memory leaks in libatf-c. [RT #46798]

	4843.	[bug]		dnssec-signzone free hashlist on exit. [RT #46791]

	4842.	[bug]		Conditionally compile opensslecdsa_link.c to avoid
				warnings about unused function. [RT #46790]

.. code-block:: none

		--- 9.12.0rc1 released ---

	4841.	[bug]		Address -fsanitize=undefined warnings. [RT #46786]

	4840.	[test]		Add tests to cover fallback to using ZSK on inactive
				KSK. [RT #46787]

	4839.	[bug]		zone.c:zone_sign was not properly determining
				if there were active KSK and ZSK keys for
				a algorithm when update-check-ksk is true
				(default) leaving records unsigned with one or
				more DNSKEY algorithms. [RT #46774]

	4838.	[bug]		zone.c:add_sigs was not properly determining
				if there were active KSK and ZSK keys for
				a algorithm when update-check-ksk is true
				(default) leaving records unsigned with one or
				more DNSKEY algorithms. [RT #46754]

	4837.	[bug]		dns_update_signatures{inc} (add_sigs) was not
				properly determining if there were active KSK and
				ZSK keys for a algorithm when update-check-ksk is
				true (default) leaving records unsigned when there
				were multiple DNSKEY algorithms for the zone.
				[RT #46743]

	4836.	[bug]		Zones created using "rndc addzone" could
				temporarily fail to inherit an "allow-transfer"
				ACL that had been configured in the options
				statement. [RT #46603]

	4835.	[cleanup]	Clean up and refactor LMDB-related code. [RT #46718]

	4834.	[port]		Fix LMDB support on OpenBSD. [RT #46718]

	4833.	[bug]		isc_event_free should check that the event is not
				linked when called. [RT #46725]

	4832.	[bug]		Events were not being removed from zone->rss_events.
				[RT #46725]

	4831.	[bug]		Convert the RRSIG expirytime to 64 bits for
				comparisons in diff.c:resign. [RT #46710]

	4830.	[bug]		Failure to configure ATF when requested did not cause
				an error in top-level configure script. [RT #46655]

	4829.	[bug]		isc_heap_delete did not zero the index value when
				the heap was created with a callback to do that.
				[RT #46709]

	4828.	[bug]		Do not use thread-local storage for storing LMDB reader
				locktable slots. [RT #46556]

	4827.	[misc]		Add a precommit check script util/checklibs.sh
				[RT #46215]

	4826.	[cleanup]	Prevent potential build failures in bin/confgen/ and
				bin/named/ when using parallel make. [RT #46648]

	4825.	[bug]		Prevent a bogus "error during managed-keys processing
				(no more)" warning from being logged. [RT #46645]

	4824.	[port]		Add iOS hooks to dig. [RT #42011]

	4823.	[test]		Refactor reclimit system test to improve its
				reliability and speed. [RT #46632]

	4822.	[bug]		Use resign_sooner in dns_db_setsigningtime. [RT #46473]

	4821.	[bug]		When resigning ensure that the SOA's expire time is
				always later that the resigning time of other records.
				[RT #46473]

	4820.	[bug]		dns_db_subtractrdataset should transfer the resigning
				information to the new header. [RT #46473]

	4819.	[bug]		Fully backout the transaction when adding a RRset
				to the resigning / removal heaps fails. [RT #46473]

	4818.	[test]		The logfileconfig system test could intermittently
				report false negatives on some platforms. [RT #46615]

	4817.	[cleanup]	Use DNS_NAME_INITABSOLUTE and DNS_NAME_INITNONABSOLUTE.
				[RT #45433]

	4816.	[bug]		Don't use a common array for storing EDNS options
				in DiG as it could fill up. [RT #45611]

	4815.	[bug]		rbt_test.c:insert_and_delete needed to call
				dns_rbt_addnode instead of dns_rbt_addname. [RT #46553]

	4814.	[cleanup]	Use AS_HELP_STRING for consistent help text. [RT #46521]

	4813.	[bug]		Address potential read after free errors from
				query_synthnodata, query_synthwildcard and
				query_synthnxdomain. [RT #46547]

	4812.	[bug]		Minor improvements to stability and consistency of code
				handling managed keys. [RT #46468]

	4811.	[bug]		Revert api changes to use <isc/buffer.h> inline
				macros.  Provide a alternative mechanism to turn
				on the use of inline macros when building BIND.
				[RT #46520]

	4810.	[test]		The chain system test failed if the IPv6 interfaces
				were not configured. [RT #46508]

.. code-block:: none

		--- 9.12.0b2 released ---

	4809.	[port]		Check at configure time whether -latomic is needed
				for stdatomic.h. [RT #46324]

	4808.	[bug]		Properly test for zlib.h. [RT #46504]

	4807.	[cleanup]	isc_rng_randombytes() returns a specified number of
				bytes from the PRNG; this is now used instead of
				calling isc_rng_random() multiple times. [RT #46230]

	4806.	[func]		Log messages related to loading of zones are now
				directed to the "zoneload" logging category.
				[RT #41640]

	4805.	[bug]		TCP4Active and TCP6Active weren't being updated
				correctly. [RT #46454]

	4804.	[port]		win32: access() does not work on directories as
				required by POSIX.  Supply a alternative in
				isc_file_isdirwritable. [RT #46394]

	4803.	[placeholder]

	4802.	[test]		Refactor mkeys system test to make it quicker and more
				reliable. [RT #45293]

	4801.	[func]		'dnssec-lookaside auto;' and 'dnssec-lookaside .
				trust-anchor dlv.isc.org;' now elicit warnings rather
				than being fatal configuration errors. [RT #46410]

	4800.	[bug]		When processing delzone, write one zone config per
				line to the NZF. [RT #46323]

	4799.	[cleanup]	Improve clarity of keytable unit tests. [RT #46407]

	4798.	[func]		Keys specified in "managed-keys" statements
				are tagged as "initializing" until they have been
				updated by a key refresh query. If initialization
				fails it will be visible from "rndc secroots".
				[RT #46267]

	4797.	[func]		Removed "isc-hmac-fixup", as the versions of BIND that
				had the bug it worked around are long past end of
				life. [RT #46411]

	4796.	[bug]		Increase the maximum configurable TCP keepalive
				timeout to 65535. [RT #44710]

	4795.	[func]		A new statistics counter has been added to track
				priming queries. [RT #46313]

	4794.	[func]		"dnssec-checkds -s" specifies a file from which
				to read a DS set rather than querying the parent.
				[RT #44667]

	4793.	[bug]		nsupdate -[46] could overflow the array of server
				addresses. [RT #46402]

	4792.	[bug]		Fix map file header correctness check. [RT #38418]

	4791.	[doc]		Fixed outdated documentation about export libraries.
				[RT #46341]

	4790.	[bug]		nsupdate could trigger a require when sending a
				update to the second address of the server.
				[RT #45731]

	4789.	[cleanup]	Check writability of new-zones-directory. [RT #46308]

	4788.	[cleanup]	When using "update-policy local", log a warning
				when an update matching the session key is received
				from a remote host. [RT #46213]

	4787.	[cleanup]	Turn nsec3param_salt_totext() into a public function,
				dns_nsec3param_salttotext(), and add unit tests for it.
				[RT #46289]

	4786.	[func]		The "filter-aaaa-on-v4" and "filter-aaaa-on-v6"
				options are no longer conditionally compiled.
				[RT #46340]

	4785.	[func]		The hmac-md5 algorithm is no longer recommended for
				use with RNDC keys.  The default in rndc-confgen
				is now hmac-sha256. [RT #42272]

	4784.	[func]		The use of dnssec-keygen to generate HMAC keys is
				deprecated in favor of tsig-keygen.  dnssec-keygen
				will print a warning when used for this purpose.
				All HMAC algorithms will be removed from
				dnssec-keygen in a future release. [RT #42272]

	4783.	[test]		dnssec: 'check that NOTIFY is sent at the end of
				NSEC3 chain generation failed' required more time
				on some machines for the IXFR to complete. [RT #46388]

	4782.	[test]		dnssec: 'checking positive and negative validation
				with negative trust anchors' required more time to
				complete on some machines. [RT #46386]

	4781.	[maint]		B.ROOT-SERVERS.NET is now 199.9.14.201. [RT #45889]

	4780.	[bug]		When answering ANY queries, don't include the NS
				RRset in the authority section if it was already
				in the answer section. [RT #44543]

	4779.	[bug]		Expire NTA at the start of the second. Don't update
				the expiry value if the record has already expired
				after a successful check. [RT #46368]

	4778.	[test]		Improve synth-from-dnssec testing. [RT #46352]

	4777.	[cleanup]	Removed a redundant call to configure_view_acl().
				[RT #46369]

	4776.	[bug]		Improve portability of ht_test. [RT #46333]

	4775.	[bug]		Address Coverity warnings in ht_test.c and mem_test.c
				[RT #46281]

	4774.	[bug]		<isc/util.h> was incorrectly included in several
				header files. [RT #46311]

	4773.	[doc]		Fixed generating Doxygen documentation for functions
				annotated using certain macros.  Miscellaneous
				Doxygen-related cleanups. [RT #46276]

.. code-block:: none

		--- 9.12.0b1 released ---

	4772.	[test]		Expanded unit testing framework for libns, using
				hooks to interrupt query flow and inspect state
				at specified locations. [RT #46173]

	4771.	[bug]		When sending RFC 5011 refresh queries, disregard
				cached DNSKEY rrsets. [RT #46251]

	4770.	[bug]		Cache additional data from priming queries as glue.
				Previously they were ignored as unsigned
				non-answer data from a secure zone, and never
				actually got added to the cache, causing hints
				to be used frequently for root-server
				addresses, which triggered re-priming. [RT #45241]

	4769.	[func]		The working directory and managed-keys directory has
				to be writeable (and seekable). [RT #46077]

	4768.	[func]		By default, memory is no longer filled with tag values
				when it is allocated or freed; this improves
				performance but makes debugging of certain memory
				issues more difficult. "named -M fill" turns memory
				filling back on. (Building "configure
				--enable-developer", turns memory fill on by
				default again; it can then be disabled with
				"named -M nofill".) [RT #45123]

	4767.	[func]		Add a new function, isc_buffer_printf(), which can be
				used to append a formatted string to the used region of
				a buffer. [RT #46201]

	4766.	[cleanup]	Address Coverity warnings. [RT #46150]

	4765.	[bug]		Address potential INSIST in dnssec-cds. [RT #46150]

	4764.	[bug]		Address portability issues in cds system test.
				[RT #46214]

	4763.	[contrib]	Improve compatibility when building MySQL DLZ
				module by using mysql_config if available.
				[RT #45558]

	4762.	[func]		"update-policy local" is now restricted to updates
				from local addresses. (Previously, other addresses
				were allowed so long as updates were signed by the
				local session key.) [RT #45492]

	4761.	[protocol]	Add support for DOA. [RT #45612]

	4760.	[func]		Add glue cache statistics counters. [RT #46028]

	4759.	[func]		Add logging channel "trust-anchor-telemetry" to
				record trust-anchor-telemetry in incoming requests.
				Both _ta-XXXX.<anchor>/NULL and EDNS KEY-TAG options
				are logged.  [RT #46124]

	4758.	[doc]		Remove documentation of unimplemented "topology".
				[RT #46161]

	4757.	[func]		New "dnssec-cds" command creates a new parent DS
				RRset based on CDS or CDNSKEY RRsets found in
				a child zone, and generates either a dsset file
				or stream of nsupdate commands to update the
				parent. Thanks to Tony Finch. [RT #46090]

	4756.	[bug]		Interrupting dig could lead to an INSIST failure after
				certain errors were encountered while querying a host
				whose name resolved to more than one address.  Change
				4537 increased the odds of triggering this issue by
				causing dig to hang indefinitely when certain error
				paths were evaluated.  dig now also retries TCP queries
				(once) if the server gracefully closes the connection
				before sending a response. [RT #42832, #45159]

	4755.	[cleanup]	Silence unnecessary log message when NZF file doesn't
				exist. [RT #46186]

	4754.	[bug]		dns_zone_setview needs a two stage commit to properly
				handle errors. [RT #45841]

	4753.	[contrib]	Software obtainable from known upstream locations
				(i.e., zkt, nslint, query-loc) has been removed.
				Links to these and other packages can be found at
				https://www.isc.org/community/tools [RT #46182]

	4752.	[test]		Add unit test for isc_net_pton. [RT #46171]

	4751.	[func]		"dnssec-signzone -S" can now automatically add parent
				synchronization records (CDS and CDNSKEY) according
				to key metadata set using the -Psync and -Dsync
				options to dnssec-keygen and dnssec-settime.
				[RT #46149]

	4750.	[func]		"rndc managed-keys destroy" shuts down RFC 5011 key
				maintenance and deletes the managed-keys database.
				If followed by "rndc reconfig" or a server restart,
				key maintenance is reinitialized from scratch.
				This is primarily intended for testing. [RT #32456]

	4749.	[func]		The ISC DLV service has been shut down, and all
				DLV records have been removed from dlv.isc.org.
				- Removed references to ISC DLV in documentation
				- Removed DLV key from bind.keys
				- No longer use ISC DLV by default in delv
				- "dnssec-lookaside auto" and configuration of
				  "dnssec-lookaide" with dlv.isc.org as the trust
				  anchor are both now fatal errors.
				[RT #46155]

	4748.	[cleanup]	Sprintf to snprintf coversions. [RT #46132]

	4747.	[func]		Synthesis of responses from DNSSEC-verified records.
				Stage 3 - synthesize NODATA responses. [RT #40138]

	4746.	[cleanup]	Add configured prefixes to configure summary
				output. [RT #46153]

	4745.	[test]		Add color-coded pass/fail messages to system
				tests when running on terminals that support them.
				[RT #45977]

	4744.	[bug]		Suppress trust-anchor-telemetry queries if
				validation is disabled. [RT #46131]

	4743.	[func]		Exclude trust-anchor-telemetry queries from
				synth-from-dnssec processing. [RT #46123]

	4742.	[func]		Synthesis of responses from DNSSEC-verified records.
				Stage 2 - synthesis of records from wildcard data.
				If the dns64 or filter-aaaa* is configured then the
				involved lookups are currently excluded. [RT #40138]

	4741.	[bug]		Make isc_refcount_current() atomically read the
				counter value. [RT #46074]

	4740.	[cleanup]	Avoid triggering format-truncated warnings. [RT #46107]

	4739.	[cleanup]	Address clang static analysis warnings. [RT #45952]

	4738.	[port]		win32: strftime mishandles %Z. [RT #46039]

	4737.	[cleanup]	Address Coverity warnings. [RT #46012]

	4736.	[cleanup]	(a) Added comments to NSEC3-related functions in
				lib/dns/zone.c.  (b) Refactored NSEC3 salt formatting
				code.  (c) Minor tweaks to lock and result handling.
				[RT #46053]

	4735.	[bug]		Add @ISC_OPENSSL_LIBS@ to isc-config. [RT #46078]

	4734.	[contrib]	Added sample configuration for DNS-over-TLS in
				contrib/dnspriv.

	4733.	[bug]		Change #4706 introduced a bug causing TCP clients
				not be reused correctly, leading to unconstrained
				memory growth. [RT #46029]

	4732.	[func]		Change default minimal-responses setting to
				no-auth-recursive. [RT #46016]

	4731.	[bug]		Fix use after free when closing an LMDB. [RT #46000]

	4730.	[bug]		Fix out of bounds access in DHCID totext() method.
				[RT #46001]

	4729.	[bug]		Don't use memset() to wipe memory, as it may be
				removed by compiler optimizations when the
				memset() occurs on automatic stack allocation
				just before function return. [RT #45947]

	4728.	[func]		Use C11's stdatomic.h instead of isc_atomic
				where available. [RT #40668]

	4727.	[bug]		Retransferring an inline-signed slave using NSEC3
				around the time its NSEC3 salt was changed could result
				in an infinite signing loop. [RT #45080]

	4726.	[port]		Prevent setsockopt() errors related to TCP_FASTOPEN
				from being logged on FreeBSD if the kernel does not
				support it.  Notify the user when the kernel does
				support TCP_FASTOPEN, but it is disabled by sysctl.
				Add a new configure option, --disable-tcp-fastopen, to
				disable use of TCP_FASTOPEN altogether. [RT #44754]

	4725.	[bug]		Nsupdate: "recvsoa" was incorrectly reported for
				failures in sending the update message.  The correct
				location to be reported is "update_completed".
				[RT #46014]

	4724.	[func]		By default, BIND now uses the random number
				functions provided by the crypto library (i.e.,
				OpenSSL or a PKCS#11 provider) as a source of
				randomness rather than /dev/random.  This is
				suitable for virtual machine environments
				which have limited entropy pools and lack
				hardware random number generators.

				This can be overridden by specifying another
				entropy source via the "random-device" option
				in named.conf, or via the -r command line option;
				however, for functions requiring full cryptographic
				strength, such as DNSSEC key generation, this
				cannot be overridden. In particular, the -r
				command line option no longer has any effect on
				dnssec-keygen.

				This can be disabled by building with
				"configure --disable-crypto-rand".
				[RT #31459] [RT #46047]

	4723.	[bug]		Statistics counter DNSTAPdropped was misidentified
				as DNSSECdropped. [RT #46002]

	4722.	[cleanup]	Clean up uses of strcpy() and strcat() in favor of
				strlcpy() and strlcat() for safety. [RT #45981]

	4721.	[func]		'dnssec-signzone -x' and 'dnssec-dnskey-kskonly'
				options now apply to CDNSKEY and DS records as well
				as DNSKEY. Thanks to Tony Finch. [RT #45689]

	4720.	[func]		Added a statistics counter to track prefetch
				queries. [RT #45847]

	4719.	[bug]		Address PVS static analyzer warnings. [RT #45946]

	4718.	[func]		Avoid searching for a owner name compression pointer
				more than once when writing out a RRset. [RT #45802]

	4717.	[bug]		Treat replies with QCOUNT=0 as truncated if TC=1,
				FORMERR if TC=0, and log the error correctly.
				[RT #45836]

	4716.	[placeholder]

.. code-block:: none

		--- 9.12.0a1 released ---

	4715.	[bug]		TreeMemMax was mis-identified as a second HeapMemMax
				in the Json cache statistics. [RT #45980]

	4714.	[port]		openbsd/libressl: add support for building with
				--enable-openssl-hash. [RT #45982]

	4713.	[func]		Added support for the DNS Response Policy Service
				(DNSRPS) API, which allows named to use an external
				response policy daemon when built with
				"configure --enable-dnsrps". Thanks to Farsight
				Security. [RT #43376]

	4712.	[bug]		"dig +domain" and "dig +search" didn't retain the
				search domain when retrying with TCP. [RT #45547]

	4711.	[test]		Some RR types were missing from genzones.sh.
				[RT #45782]

	4710.	[cleanup]	Changed the --enable-openssl-hash default to yes.
				[RT #45019]

	4709.	[cleanup]	Use dns_name_fullhash() to hash names for RRL.
				[RT #45435]

	4708.	[cleanup]	Legacy Windows builds (i.e. for XP and earlier)
				are no longer supported. [RT #45186]

	4707.	[func]		The lightweight resolver daemon and library (lwresd
				and liblwres) have been removed. [RT #45186]

	4706.	[func]		Code implementing name server query processing has
				been moved from bin/named to a new library "libns".
				Functions remaining in bin/named are now prefixed
				with "named_" rather than "ns_".  This will make it
				easier to write unit tests for name server code, or
				link name server functionality into new tools.
				[RT #45186]

	4705.	[placeholder]

	4704.	[cleanup]	Silence Visual Studio compiler warnings. [RT #45898]

	4703.	[bug]		BINDInstall.exe was missing some buffer length checks.
				[RT #45898]

	4702.	[func]		Update function declarations to use
				dns_masterstyle_flags_t for style flags. [RT #45924]

	4701.	[cleanup]	Refactored lib/dns/tsig.c to reduce code
				duplication and simplify the disabling of MD5.
				[RT #45490]

	4700.	[func]		Serving of stale answers is now supported. This
				allows named to provide stale cached answers when
				the authoritative server is under attack.
				See max-stale-ttl, stale-answer-enable,
				stale-answer-ttl. [RT #44790]

	4699.	[func]		Multiple cookie-secret clauses can now be specified.
				The first one specified is used to generate new
				server cookies.  [RT #45672]

	4698.	[port]		Add --with-python-install-dir configure option to allow
				specifying a nonstandard installation directory for
				Python modules. [RT #45407]

	4697.	[bug]		Restore workaround for Microsoft Windows TSIG hash
				computation bug. [RT #45854]

	4696.	[port]		Enable filter-aaaa support by default on Windows
				builds. [RT #45883]

	4695.	[bug]		cookie-secrets were not being properly checked by
				named-checkconf. [RT #45886]

	4694.	[func]		dnssec-keygen no longer uses RSASHA1 by default;
				the signing algorithm must be specified on
				the command line with the "-a" option.  Signing
				scripts that rely on the existing default behavior
				will break; use "dnssec-keygen -a RSASHA1" to
				repair them. (The goal of this change is to make
				it easier to find scripts using RSASHA1 so they
				can be changed in the event of that algorithm
				being deprecated in the future.) [RT #44755]

	4693.	[func]		Synthesis of responses from DNSSEC-verified records.
				Stage 1 covers NXDOMAIN synthesis from NSEC records.
				This is controlled by synth-from-dnssec and is enabled
				by default. [RT #40138]

	4692.	[bug]		Fix build failures with libressl introduced in 4676.
				[RT #45879]

	4691.	[func]		Add -4/-6 command line options to nsupdate and rndc.
				[RT #45632]

	4690.	[bug]		Command line options -4/-6 were handled inconsistently
				between tools. [RT #45632]

	4689.	[cleanup]	Turn on minimal responses for CDNSKEY and CDS in
				addition to DNSKEY and DS. Thanks to Tony Finch.
				[RT #45690]

	4688.	[protocol]	Check and display EDNS KEY TAG options (RFC 8145) in
				messages. [RT #44804]

	4687.	[func]		Refactor tracklines code. [RT #45126]

	4686.	[bug]		dnssec-settime -p could print a bogus warning about
				key deletion scheduled before its inactivation when a
				key had an inactivation date set but no deletion date
				set. [RT #45807]

	4685.	[bug]		dnssec-settime incorrectly calculated publication and
				activation dates for a successor key. [RT #45806]

	4684.	[bug]		delv could send bogus DNS queries when an explicit
				server address was specified on the command line along
				with -4/-6. [RT #45804]

	4683.	[bug]		Prevent nsupdate from immediately exiting on invalid
				user input in interactive mode. [RT #28194]

	4682.	[bug]		Don't report errors on records below a DNAME.
				[RT #44880]

	4681.	[bug]		Log messages from the validator now include the
				associated view unless the view is "_default/IN"
				or "_dnsclient/IN". [RT #45770]

	4680.	[bug]		Fix failing over to another master server address when
				nsupdate is used with GSS-API. [RT #45380]

	4679.	[cleanup]	Suggest using -o when dnssec-verify finds a SOA record
				not at top of zone and -o is not used. [RT #45519]

	4678.	[bug]		geoip-use-ecs has the wrong type when geoip support
				is disabled at configure time. [RT #45763]

	4677.	[cleanup]	Split up the main function in dig to better support
				the iOS app version. [RT #45508]

	4676.	[cleanup]	Allow BIND to be built using OpenSSL 1.0.X with
				deprecated functions removed. [RT #45706]

	4675.	[cleanup]	Don't use C++ keyword class. [RT #45726]

	4674.	[func]		"dig +sigchase", and related options "+topdown" and
				"+trusted-keys", have been removed. Use "delv" for
				queries with DNSSEC validation. [RT #42793]

	4673.	[port]		Silence GCC 7 warnings. [RT #45592]

	4672.	[placeholder]

	4671.	[bug]		Fix a race condition that could cause the
				resolver to crash with assertion failure when
				chasing DS in specific conditions with a very
				short RTT to the upstream nameserver. [RT #45168]

	4670.	[cleanup]	Ensure that a request MAC is never sent back
				in an XFR response unless the signature was
				verified. [RT #45494]

	4669.	[func]		Iterative query logic in resolver.c has been
				refactored into smaller functions and commented,
				for improved readability, maintainability and
				testability. [RT #45362]

	4668.	[bug]		Use localtime_r and gmtime_r for thread safety.
				[RT #45664]

	4667.	[cleanup]	Refactor RDATA unit tests. [RT #45610]

	4666.	[bug]		dnssec-keymgr: Domain names beginning with digits (0-9)
				could cause a parser error when reading the policy
				file. This now works correctly so long as the domain
				name is quoted. [RT #45641]

	4665.	[protocol]	Added support for ED25519 and ED448 DNSSEC signing
				algorithms (RFC 8080). (Note: these algorithms
				depend on code currently in the development branch
				of OpenSSL which has not yet been released.)
				[RT #44696]

	4664.	[func]		Add a "glue-cache" option to enable or disable the
				glue cache. The default is "yes". [RT #45125]

	4663.	[cleanup]	Clarify error message printed by dnssec-dsfromkey.
				[RT #21731]

	4662.	[performance]	Improve cache memory cleanup of zero TTL records
				by putting them at the tail of LRU header lists.
				[RT #45274]

	4661.	[bug]		A race condition could occur if a zone was reloaded
				while resigning, triggering a crash in
				rbtdb.c:closeversion(). [RT #45276]

	4660.	[bug]		Remove spurious "peer" from Windows socket log
				messages. [RT #45617]

	4659.	[bug]		Remove spurious log message about lmdb-mapsize
				not being supported when parsing builtin
				configuration file. [RT #45618]

	4658.	[bug]		Clean up build directory created by "setup.py install"
				immediately.  [RT #45628]

	4657.	[bug]		rrchecker system test result could be improperly
				determined. [RT #45602]

	4656.	[bug]		Apply "port" and "dscp" values specified in catalog
				zone's "default-masters" option to the generated
				configuration of its member zones. [RT #45545]

	4655.	[bug]		Lack of seccomp could be falsely reported. [RT #45599]

	4654.	[cleanup]	Don't use C++ keywords delete, new and namespace.
				[RT #45538]

	4653.	[bug]		Reorder includes to move @DST_OPENSSL_INC@ and
				@ISC_OPENSSL_INC@ after shipped include directories.
				[RT #45581]

	4652.	[bug]		Nsupdate could attempt to use a zeroed address on
				server timeout. [RT #45417]

	4651.	[test]		Silence coverity warnings in tsig_test.c. [RT #45528]

	4650.	[placeholder]

	4649.	[bug]		The wrong zone was logged when a catalog zone is added.
				[RT #45520]

	4648.	[bug]		"rndc reconfig" on a slave no longer causes all member
				zones of configured catalog zones to be removed from
				configuration. [RT #45310]

	4647.	[bug]		Change 4643 broke verification of TSIG signed TCP
				message sequences where not all the messages contain
				TSIG records.  These may be used in AXFR and IXFR
				responses. [RT #45509]

	4646.	[placeholder]

	4645.	[bug]		Fix PKCS#11 RSA parsing when MD5 is disabled.
				[RT #45300]

	4644.	[placeholder]

	4643.	[security]	An error in TSIG handling could permit unauthorized
				zone transfers or zone updates. (CVE-2017-3142)
				(CVE-2017-3143) [RT #45383]

	4642.	[cleanup]	Add more logging of RFC 5011 events affecting the
				status of managed keys: newly observed keys,
				deletion of revoked keys, etc. [RT #45354]

	4641.	[cleanup]	Parallel builds (make -j) could fail with --with-atf /
				--enable-developer. [RT #45373]

	4640.	[bug]		If query_findversion failed in query_getdb due to
				memory failure the error status was incorrectly
				discarded. [RT #45331]

	4639.	[bug]		Fix a regression in --with-tuning reporting introduced
				by change 4488. [RT #45396]

	4638.	[bug]		Reloading or reconfiguring named could fail on
				some platforms when LMDB was in use. [RT #45203]

	4637.	[func]		"nsec3hash -r" option ("rdata order") takes arguments
				in the same order as they appear in NSEC3 or
				NSEC3PARAM records, so that NSEC3 parameters can
				be cut and pasted from an existing record. Thanks
				to Tony Finch for the contribution. [RT #45183]

	4636.	[bug]		Normalize rpz policy zone names when checking for
				existence. [RT #45358]

	4635.	[bug]		Fix RPZ NSDNAME logging that was logging
				failures as NSIP. [RT #45052]

	4634.	[contrib]	check5011.pl needs to handle optional space before
				semi-colon in +multi-line output. [RT #45352]

	4633.	[maint]		Updated AAAA (2001:500:200::b) for B.ROOT-SERVERS.NET.

	4632.	[security]	The BIND installer on Windows used an unquoted
				service path, which can enable privilege escalation.
				(CVE-2017-3141) [RT #45229]

	4631.	[security]	Some RPZ configurations could go into an infinite
				query loop when encountering responses with TTL=0.
				(CVE-2017-3140) [RT #45181]

	4630.	[bug]		"dyndb" is dependent on dlopen existing / being
				enabled. [RT #45291]

	4629.	[bug]		dns_client_startupdate could not be called with a
				running client. [RT #45277]

	4628.	[bug]		Fixed a potential reference leak in query_getdb().
				[RT #45247]

	4627.	[placeholder]

	4626.	[test]		Added more tests for handling of different record
				ordering in CNAME and DNAME responses. [QA #430]

	4625.	[bug]		Running "rndc addzone" and "rndc delzone" at close
				to the same time could trigger a deadlock if using
				LMDB. [RT #45209]

	4624.	[placeholder]

	4623.	[bug]		Use --with-protobuf-c and --with-libfstrm to find
				protoc-c and fstrm_capture. [RT #45187]

	4622.	[bug]		Remove unnecessary escaping of semicolon in CAA and
				URI records. [RT #45216]

	4621.	[port]		Force alignment of oid arrays to silence loader
				warnings. [RT #45131]

	4620.	[port]		Handle EPFNOSUPPORT being returned when probing
				to see if a socket type is supported. [RT #45214]

	4619.	[bug]		Call isc_mem_put instead of isc_mem_free in
				bin/named/server.c:setup_newzones. [RT #45202]

	4618.	[bug]		Check isc_mem_strdup results in dns_view_setnewzones.
				Add logging for lmdb call failures. [RT #45204]

	4617.	[test]		Update rndc system test to be more delay tolerant.
				[RT #45177]

	4616.	[bug]		When using LMDB, zones deleted using "rndc delzone"
				were not correctly removed from the new-zone
				database. [RT #45185]

	4615.	[bug]		AD could be set on truncated answer with no records
				present in the answer and authority sections.
				[RT #45140]

	4614.	[test]		Fixed an error in the sockaddr unit test. [RT #45146]

	4613.	[func]		By default, the maximum size of a zone journal file
				is now twice the size of the zone's contents (there
				is little benefit to a journal larger than this).
				This can be overridden by setting "max-journal-size"
				to "unlimited" or to an explicit value up to 2G.
				Thanks to Tony Finch. [RT #38324]

	4612.	[bug]		Silence 'may be use uninitalised' warning and simplify
				the code in lwres/getaddinfo:process_answer.
				[RT #45158]

	4611.	[bug]		The default LMDB mapsize was too low and caused
				errors after few thousand zones were added using
				rndc addzone. A new config option "lmdb-mapsize"
				has been introduced to configure the LMDB
				mapsize depending on operational needs.
				[RT #44954]

	4610.	[func]		The "new-zones-directory" option specifies the
				location of NZF or NZD files for storing
				configuration of zones added by "rndc addzone".
				Thanks to Petr Menšík. [RT #44853]

	4609.	[cleanup]	Rearrange makefiles to enable parallel execution
				(i.e. "make -j"). [RT #45078]

	4608.	[func]		DiG now warns about .local queries which are reserved
				for Multicast DNS. [RT #44783]

	4607.	[bug]		The memory context's malloced and maxmalloced counters
				were being updated without the appropriate lock being
				held.  [RT #44869]

	4606.	[port]		Stop using experimental "Experimental keys on scalar"
				feature of perl as it has been removed. [RT #45012]

	4605.	[performance]	Improve performance for delegation heavy answers
				and also general query performance. Removes the
				acache feature that didn't significantly improve
				performance. Adds a glue cache. Removes
				additional-from-cache and additional-from-auth
				features. Enables minimal-responses by
				default. Improves performance of compression
				code, owner case restoration, hash function,
				etc. Uses inline buffer implementation by
				default. Many other performance changes and fixes.
				[RT #44029]

	4604.	[bug]		Don't use ERR_load_crypto_strings() when building
				with OpenSSL 1.1.0. [RT #45117]

	4603.	[doc]		Automatically generate named.conf(5) man page
				from doc/misc/options. Thanks to Tony Finch.
				[RT #43525]

	4602.	[func]		Threads are now set to human-readable
				names to assist debugging, when supported by
				the OS. [RT #43234]

	4601.	[bug]		Reject incorrect RSA key lengths during key
				generation and and sign/verify context
				creation. [RT #45043]

	4600.	[bug]		Adjust RPZ trigger counts only when the entry
				being deleted exists. [RT #43386]

	4599.	[bug]		Fix inconsistencies in inline signing time
				comparison that were introduced with the
				introduction of rdatasetheader->resign_lsb.
				[RT #42112]

	4598.	[func]		Update fuzzing code to (1) reply to a DNSKEY
				query from named with appropriate DNSKEY used in
				fuzzing; (2) patch the QTYPE correctly in
				resolver fuzzing; (3) comment things so the rest
				of us are able to understand how fuzzing is
				implemented in named; (4) Coding style changes,
				cleanup, etc. [RT #44787]

	4597.	[bug]		The validator now ignores SHA-1 DS digest type
				when a DS record with SHA-384 digest type is
				present and is a supported digest type.
				[RT #45017]

	4596.	[bug]		Validate glue before adding it to the additional
				section. This also fixes incorrect TTL capping
				when the RRSIG expired earlier than the TTL.
				[RT #45062]

	4595.	[func]		dnssec-keygen will no longer generate RSA keys
				less than 1024 bits in length. dnssec-keymgr
				was similarly updated. [RT #36895]

	4594.	[func]		"dnstap-read -x" prints a hex dump of the wire
				format of each logged DNS message. [RT #44816]

	4593.	[doc]		Update README using markdown, remove outdated FAQ
				file in favor of the knowledge base.

	4592.	[bug]		A race condition on shutdown could trigger an
				assertion failure in dispatch.c. [RT #43822]

	4591.	[port]		Addressed some python 3 compatibility issues.
				Thanks to Ville Skytta. [RT #44955] [RT #44956]

	4590.	[bug]		Support for PTHREAD_MUTEX_ADAPTIVE_NP was not being
				properly detected. [RT #44871]

	4589.	[cleanup]	"configure -q" is now silent. [RT #44829]

	4588.	[bug]		nsupdate could send queries for TKEY to the wrong
				server when using GSSAPI. Thanks to Tomas Hozza.
				[RT #39893]

	4587.	[bug]		named-checkzone failed to handle occulted data below
				DNAMEs correctly. [RT #44877]

	4586.	[func]		dig, host and nslookup now use TCP for ANY queries.
				[RT #44687]

	4585.	[port]		win32: Set CompileAS value. [RT #42474]

	4584.	[bug]		A number of memory usage statistics were not properly
				reported when they exceeded 4G.  [RT #44750]

	4583.	[func]		"host -A" returns most records for a name but
				omits RRSIG, NSEC and NSEC3. (Thanks to Tony Finch.)
				[RT #43032]

	4582.	[security]	'rndc ""' could trigger a assertion failure in named.
				(CVE-2017-3138) [RT #44924]

	4581.	[port]		Linux: Add getpid and getrandom to the list of system
				calls named uses for seccomp. [RT #44883]

	4580.	[bug]		4578 introduced a regression when handling CNAME to
				referral below the current domain. [RT #44850]

	4579.	[func]		Logging channels and dnstap output files can now
				be configured with a "suffix" option, set to
				either "increment" or "timestamp", indicating
				whether to use incrementing numbers or timestamps
				as the file suffix when rolling over a log file.
				[RT #42838]

	4578.	[security]	Some chaining (CNAME or DNAME) responses to upstream
				queries could trigger assertion failures.
				(CVE-2017-3137) [RT #44734]

	4577.	[func]		Make qtype of resolver fuzzing packet configurable
				via command line. [RT #43540]

	4576.	[func]		The RPZ implementation has been substantially
				refactored for improved performance and reliability.
				[RT #43449]

	4575.	[security]	DNS64 with "break-dnssec yes;" can result in an
				assertion failure. (CVE-2017-3136) [RT #44653]

	4574.	[bug]		Dig leaked memory with multiple +subnet options.
				[RT #44683]

	4573.	[func]		Query logic has been substantially refactored (e.g.
				query_find function has been split into smaller
				functions) for improved readability, maintainability
				and testability. [RT #43929]

	4572.	[func]		The "dnstap-output" option can now take "size" and
				"versions" parameters to indicate the maximum size
				a dnstap log file can grow before rolling to a new
				file, and how many old files to retain. [RT #44502]

	4571.	[bug]		Out-of-tree builds of backtrace_test failed.

	4570.	[cleanup]	named did not correctly fall back to the built-in
				initializing keys if the bind.keys file was present
				but empty. [RT #44531]

	4569.	[func]		Store both local and remote addresses in dnstap
				logging, and modify dnstap-read output format to
				print them. [RT #43595]

	4568.	[contrib]	Added a --with-bind option to the dnsperf configure
				script to specify BIND prefix path.

	4567.	[port]		Call getprotobyname and getservbyname prior to calling
				chroot so that shared libraries get loaded. [RT #44537]

	4566.	[func]		Query logging now includes the ECS option if one
				was included in the query. [RT #44476]

	4565.	[cleanup]	The inline macro versions of isc_buffer_put*()
				did not implement automatic buffer reallocation.
				[RT #44216]

	4564.	[maint]		Update the built in managed keys to include the
				upcoming root KSK. [RT #44579]

	4563.	[bug]		Modified zones would occasionally fail to reload.
				[RT #39424]

	4562.	[func]		Add additional memory statistics currently malloced
				and maxmalloced per memory context. [RT #43593]

	4561.	[port]		Silence a warning in strict C99 compilers. [RT #44414]

	4560.	[bug]		mdig: add -m option to enable memory debugging rather
				than having it on all the time. [RT #44509]

	4559.	[bug]		openssl_link.c didn't compile if ISC_MEM_TRACKLINES
				was turned off.  [RT #44509]

	4558.	[bug]		Synthesised CNAME before matching DNAME was still
				being cached when it should not have been.  [RT #44318]

	4557.	[security]	Combining dns64 and rpz can result in dereferencing
				a NULL pointer (read).  (CVE-2017-3135) [RT#44434]

	4556.	[bug]		Sending an EDNS Padding option using "dig
				+ednsopt" could cause a crash in dig. [RT #44462]

	4555.	[func]		dig +ednsopt: EDNS options can now be specified by
				name in addition to numeric value. [RT #44461]

	4554.	[bug]		Remove double unlock in dns_dispatchmgr_setudp.
				[RT #44336]

	4553.	[bug]		Named could deadlock there were multiple changes to
				NSEC/NSEC3 parameters for a zone being processed at
				the same time. [RT #42770]

	4552.	[bug]		Named could trigger a assertion when sending notify
				messages. [RT #44019]

	4551.	[test]		Add system tests for integrity checks of MX and
				SRV records. [RT #43953]

	4550.	[cleanup]	Increased the number of available master file
				output style flags from 32 to 64. [RT #44043]

	4549.	[func]		Added support for the EDNS TCP Keepalive option
				(RFC 7828). [RT #42126]

	4548.	[func]		Added support for the EDNS Padding option (RFC 7830).
				[RT #42094]

	4547.	[port]		Add support for --enable-native-pkcs11 on the AEP
				Keyper HSM. [RT #42463]

	4546.	[func]		Extend the use of const declarations. [RT #43379]

	4545.	[func]		Expand YAML output from dnstap-read to include
				a detailed breakdown of the DNS message contents.
				[RT #43642]

	4544.	[bug]		Add message/payload size to dnstap-read YAML output.
				[RT #43622]

	4543.	[bug]		dns_client_startupdate now delays sending the update
				request until isc_app_ctxrun has been called.
				[RT #43976]

	4542.	[func]		Allow rndc to manipulate redirect zones with using
				-redirect as the zone name (use "-redirect." to
				manipulate a zone named "-redirect"). [RT #43971]

	4541.	[bug]		rndc addzone should properly reject non master/slave
				zones. [RT #43665]

	4540.	[bug]		Correctly handle ecs entries in dns_acl_isinsecure.
				[RT #43601]

	4539.	[bug]		Referencing a nonexistent zone with RPZ could lead
				to a assertion failure when configuring. [RT #43787]

	4538.	[bug]		Call dns_client_startresolve from client->task.
				[RT #43896]

	4537.	[bug]		Handle timeouts better in dig/host/nslookup. [RT #43576]

	4536.	[bug]		ISC_SOCKEVENTATTR_USEMINMTU was not being cleared
				when reusing the event structure. [RT #43885]

	4535.	[bug]		Address race condition in setting / testing of
				DNS_REQUEST_F_SENDING. [RT #43889]

	4534.	[bug]		Only set RD, RA and CD in QUERY responses. [RT #43879]

	4533.	[bug]		dns_client_update should terminate on prerequisite
				failures (NXDOMAIN, YXDOMAIN, NXRRSET, YXRRSET)
				and also on BADZONE.  [RT #43865]

	4532.	[contrib]	Make gen-data-queryperf.py python 3 compatible.
				[RT #43836]

	4531.	[security]	'is_zone' was not being properly updated by redirect2
				and subsequently preserved leading to an assertion
				failure. (CVE-2016-9778) [RT #43837]

	4530.	[bug]		Change 4489 broke the handling of CNAME -> DNAME
				in responses resulting in SERVFAIL being returned.
				[RT #43779]

	4529.	[cleanup]	Silence noisy log warning when DSCP probe fails
				due to firewall rules. [RT #43847]

	4528.	[bug]		Only set the flag bits for the i/o we are waiting
				for on EPOLLERR or EPOLLHUP. [RT #43617]

	4527.	[doc]		Support DocBook XSL Stylesheets v1.79.1. [RT #43831]

	4526.	[doc]		Corrected errors and improved formatting of
				grammar definitions in the ARM. [RT #43739]

	4525.	[doc]		Fixed outdated documentation on managed-keys.
				[RT #43810]

	4524.	[bug]		The net zero test was broken causing IPv4 servers
				with addresses ending in .0 to be rejected. [RT #43776]

	4523.	[doc]		Expand config doc for <querysource4> and
				<querysource6>. [RT #43768]

	4522.	[bug]		Handle big gaps in log file version numbers better.
				[RT #38688]

	4521.	[cleanup]	Log it as an error if an entropy source is not
				found and there is no fallback available. [RT #43659]

	4520.	[cleanup]	Alphabetize more of the grammar when printing it
				out. Fix unbalanced indenting. [RT #43755]

	4519.	[port]		win32: handle ERROR_MORE_DATA. [RT #43534]

	4518.	[func]		The "print-time" option in the logging configuration
				can now take arguments "local", "iso8601" or
				"iso8601-utc" to indicate the format in which the
				date and time should be logged. For backward
				compatibility, "yes" is a synonym for "local".
				[RT #42585]

	4517.	[security]	Named could mishandle authority sections that were
				missing RRSIGs triggering an assertion failure.
				(CVE-2016-9444) [RT # 43632]

	4516.	[bug]		isc_socketmgr_renderjson was missing from the
				windows build. [RT #43602]

	4515.	[port]		FreeBSD: Find readline headers when they are in
				edit/readline/ instead of readline/. [RT #43658]

	4514.	[port]		NetBSD: strip -WL, from ld command line. [RT #43204]

	4513.	[cleanup]	Minimum Python versions are now 2.7 and 3.2.
				[RT #43566]

	4512.	[bug]		win32: @GEOIP_INC@ missing from delv.vcxproj.in.
				[RT #43556]

	4511.	[bug]		win32: mdig.exe-BNFT was missing Configure. [RT #43554]

	4510.	[security]	Named mishandled some responses where covering RRSIG
				records are returned without the requested data
				resulting in a assertion failure. (CVE-2016-9147)
				[RT #43548]

	4509.	[test]		Make the rrl system test more reliable on slower
				machines by using mdig instead of dig. [RT #43280]

	4508.	[security]	Named incorrectly tried to cache TKEY records which
				could trigger a assertion failure when there was
				a class mismatch. (CVE-2016-9131) [RT #43522]

	4507.	[bug]		Named could incorrectly log 'allows updates by IP
				address, which is insecure' [RT #43432]

	4506.	[func]		'named-checkconf -l' will now list the zones found in
				named.conf. [RT #43154]

	4505.	[port]		Use IP_PMTUDISC_OMIT if available. [RT #35494]

	4504.	[security]	Allow the maximum number of records in a zone to
				be specified.  This provides a control for issues
				raised in CVE-2016-6170. [RT #42143]

	4503.	[cleanup]	"make uninstall" now removes files installed by
				BIND. (This currently excludes Python files
				due to lack of support in setup.py.) [RT #42192]

	4502.	[func]		Report multiple and experimental options when printing
				grammar. [RT #43134]

	4501.	[placeholder]

	4500.	[bug]		Support modifier I64 in isc__print_printf. [RT #43526]

	4499.	[port]		MacOSX: silence deprecated function warning
				by using arc4random_stir() when available
				instead of arc4random_addrandom(). [RT #43503]

	4498.	[test]		Simplify prerequisite checks in system tests.
				[RT #43516]

	4497.	[port]		Add support for OpenSSL 1.1.0. [RT #41284]

	4496.	[func]		dig: add +idnout to control whether labels are
				display in punycode or not.  Requires idn support
				to be enabled at compile time. [RT #43398]

	4495.	[bug]		A isc_mutex_init call was not being checked.
				[RT #43391]

	4494.	[bug]		Look for <editline/readline.h>. [RT #43429]

	4493.	[bug]		bin/tests/system/dyndb/driver/Makefile.in should use
				SO_TARGETS. [RT# 43336]

	4492.	[bug]		irs_resconf_load failed to initialize sortlistnxt
				causing bad writes if resolv.conf contained a
				sortlist directive. [RT #43459]

	4491.	[bug]		Improve message emitted when testing whether sendmsg
				works with TOS/TCLASS fails. [RT #43483]

	4490.	[maint]		Added AAAA (2001:500:12::d0d) for G.ROOT-SERVERS.NET.

	4489.	[security]	It was possible to trigger assertions when processing
				a response containing a DNAME answer. (CVE-2016-8864)
				[RT #43465]

	4488.	[port]		Darwin: use -framework for Kerberos. [RT #43418]

	4487.	[test]		Make system tests work on Windows. [RT #42931]

	4486.	[bug]		Look in $prefix/lib/pythonX.Y/site-packages for
				the python modules we install. [RT #43330]

	4485.	[bug]		Failure to find readline when requested should be
				fatal to configure. [RT #43328]

	4484.	[func]		Check prefixes in acls to make sure the address and
				prefix lengths are consistent.  Warn only in
				BIND 9.11 and earlier. [RT #43367]

	4483.	[bug]		Address use before require check and remove extraneous
				dns_message_gettsigkey call in dns_tsig_sign.
				[RT #43374]

	4482.	[cleanup]	Change #4455 was incomplete. [RT #43252]

	4481.	[func]		dig: make +class, +crypto, +multiline, +rrcomments,
				+onesoa, +qr, +ttlid, +ttlunits and -u per lookup
				rather than global. [RT #42450]

	4480.	[placeholder]

	4479.	[placeholder]

	4478.	[func]		Add +continue option to mdig, allow continue on socket
				errors. [RT #43281]

	4477.	[test]		Fix mkeys test timing issues. [RT #41028]

	4476.	[test]		Fix reclimit test on slower machines. [RT #43283]

	4475.	[doc]		Update named-checkconf documentation. [RT #43153]

	4474.	[bug]		win32: call WSAStartup in fromtext_in_wks so that
				getprotobyname and getservbyname work.  [RT #43197]

	4473.	[bug]		Only call fsync / _commit on regular files. [RT #43196]

	4472.	[bug]		Named could fail to find the correct NSEC3 records when
				a zone was updated between looking for the answer and
				looking for the NSEC3 records proving nonexistence
				of the answer. [RT #43247]

.. code-block:: none

		--- 9.11.0 released ---

.. code-block:: none

		--- 9.11.0rc3 released ---

	4471.	[cleanup]	Render client/query logging format consistent for
				ease of log file parsing. (Note that this affects
				"querylog" format: there is now an additional field
				indicating the client object address.) [RT #43238]

	4470.	[bug]		Reset message with intent parse before
				calling dns_dispatch_getnext. [RT #43229]

	4469.	[placeholder]

.. code-block:: none

		--- 9.11.0rc2 released ---

	4468.	[bug]		Address ECS option handling issues. [RT #43191]

	4467.	[security]	It was possible to trigger an assertion when
				rendering a message. (CVE-2016-2776) [RT #43139]

	4466.	[bug]		Interface scanning didn't work on a Windows system
				without a non local IPv6 addresses. [RT #43130]

	4465.	[bug]		Don't use "%z" as Windows doesn't support it.
				[RT #43131]

	4464.	[bug]		Fix windows python support. [RT #43173]

	4463.	[bug]		The dnstap system test failed on some systems.
				[RT #43129]

	4462.	[bug]		Don't describe a returned EDNS COOKIE as "good"
				when there isn't a valid server cookie. [RT #43167]

	4461.	[bug]		win32: not all external data was properly marked
				as external data for windows dll. [RT #43161]

.. code-block:: none

		--- 9.11.0rc1 released ---

	4460.	[test]		Add system test for dnstap using unix domain sockets.
				[RT #42926]

	4459.	[bug]		TCP client objects created to handle pipeline queries
				were not cleaned up correctly, causing uncontrolled
				memory growth. [RT #43106]

	4458.	[cleanup]	Update assertions to be more correct, and also remove
				use of a reserved word. [RT #43090]

	4457.	[maint]		Added AAAA (2001:500:a8::e) for E.ROOT-SERVERS.NET.

	4456.	[doc]		Add DOCTYPE and lang attribute to <html> tags.
				[RT #42587]

	4455.	[cleanup]	Allow dyndb modules to correctly log the filename
				and line number when processing configuration text
				from named.conf. [RT #43050]

	4454.	[bug]		'rndc dnstap -reopen' had a race issue. [RT #43089]

	4453.	[bug]		Prefetching of DS records failed to update their
				RRSIGs. [RT #42865]

	4452.	[bug]		The default key manager policy file is now
				<sysdir>/dnssec-policy.conf (usually
				/etc/dnssec-policy.conf). [RT #43064]

	4451.	[cleanup]	Log more useful information if a PKCS#11 provider
				library cannot be loaded. [RT #43076]

	4450.	[port]		Provide more nuanced HSM support which better matches
				the specific PKCS11 providers capabilities. [RT #42458]

	4449.	[test]		Fix catalog zones test on slower systems. [RT #42997]

	4448.	[bug]		win32: ::1 was not being found when iterating
				interfaces. [RT #42993]

	4447.	[tuning]	Allow the fstrm_iothr_init() options to be set using
				named.conf to control how dnstap manages the data
				flow. [RT #42974]

	4446.	[bug]		The cache_find() and _findrdataset() functions
				could find rdatasets that had been marked stale.
				[RT #42853]

	4445.	[cleanup]	isc_errno_toresult() can now be used to call the
				formerly private function isc__errno2result().
				[RT #43050]

	4444.	[bug]		Fixed some issues related to dyndb: A bug caused
				braces to be omitted when passing configuration text
				from named.conf to a dyndb driver, and there was a
				use-after-free in the sample dyndb driver. [RT #43050]

	4443.	[func]		Set TCP_MAXSEG in addition to IPV6_USE_MIN_MTU on
				TCP sockets. [RT #42864]

	4442.	[bug]		Fix RPZ CIDR tree insertion bug that corrupted
				tree data structure with overlapping networks
				(longest prefix match was ineffective).
				[RT #43035]

	4441.	[cleanup]	Alphabetize host's help output. [RT #43031]

	4440.	[func]		Enable TCP fast open support when available on the
				server side. [RT #42866]

	4439.	[bug]		Address race conditions getting ownernames of nodes.
				[RT #43005]

	4438.	[func]		Use LIFO rather than FIFO when processing startup
				notify and refresh queries. [RT #42825]

	4437.	[func]		Minimal-responses now has two additional modes
				no-auth and no-auth-recursive which suppress
				adding the NS records to the authority section
				as well as the associated address records for the
				nameservers. [RT #42005]

	4436.	[func]		Return TLSA records as additional data for MX and SRV
				lookups. [RT #42894]

	4435.	[tuning]	Only set IPV6_USE_MIN_MTU for UDP when the message
				will not fit into a single IPv4 encapsulated IPv6
				UDP packet when transmitted over a Ethernet link.
				[RT #42871]

	4434.	[protocol]	Return EDNS EXPIRE option for master zones in addition
				to slave zones. [RT #43008]

	4433.	[cleanup]	Report an error when passing an invalid option or
				view name to "rndc dumpdb". [RT #42958]

	4432.	[test]		Hide rndc output on expected failures in logfileconfig
				system test. [RT #27996]

	4431.	[bug]		named-checkconf now checks the rate-limit clause.
				[RT #42970]

	4430.	[bug]		Lwresd died if a search list was not defined.
				Found by 0x710DDDD At Alibaba Security. [RT #42895]

	4429.	[bug]		Address potential use after free on fclose() error.
				[RT #42976]

	4428.	[bug]		The "test dispatch getnext" unit test could fail
				in a threaded build. [RT #42979]

	4427.	[bug]		The "query" and "response" parameters to the
				"dnstap" option had their functions reversed.

.. code-block:: none

		--- 9.11.0b3 released ---

	4426.	[bug]		Addressed Coverity warnings. [RT #42908]

	4425.	[bug]		arpaname, dnstap-read and named-rrchecker were not
				being installed into ${prefix}/bin.  Tidy up
				installation issues with CHANGE 4421. [RT #42910]

	4424.	[experimental]	Named now sends _ta-XXXX.<trust-anchor>/NULL queries
				to provide feedback to the trust-anchor administrators
				about how key rollovers are progressing as per
				draft-ietf-dnsop-edns-key-tag-02.  This can be
				disabled using 'trust-anchor-telemetry no;'.
				[RT #40583]

	4423.	[maint]		Added missing IPv6 address 2001:500:84::b for
				B.ROOT-SERVERS.NET. [RT #42898]

	4422.	[port]		Silence clang warnings in dig.c and dighost.c.
				[RT #42451]

	4421.	[func]		When built with LMDB (Lightning Memory-mapped
				Database), named will now use a database to store
				the configuration for zones added by "rndc addzone"
				instead of using a flat NZF file. This improves
				performance of "rndc delzone" and "rndc modzone"
				significantly. Existing NZF files will
				automatically by converted to NZD databases.
				To view the contents of an NZD or to roll back to
				NZF format, use "named-nzd2nzf". To disable
				this feature, use "configure --without-lmdb".
				[RT #39837]

	4420.	[func]		nslookup now looks for AAAA as well as A by default.
				[RT #40420]

	4419.	[bug]		Don't cause undefined result if the label of an
				entry in catalog zone is changed. [RT #42708]

	4418.	[bug]		Fix a compiler warning in GSSAPI code. [RT #42879]

	4417.	[bug]		dnssec-keymgr could fail to create successor keys
				if the prepublication interval was set to a value
				smaller than the default. [RT #42820]

	4416.	[bug]		dnssec-keymgr: Domain names in policy files could
				fail to match due to trailing dots. [RT #42807]

	4415.	[bug]		dnssec-keymgr: Expired/deleted keys were not always
				excluded. [RT #42884]

	4414.	[bug]		Corrected a bug in the MIPS implementation of
				isc_atomic_xadd(). [RT #41965]

	4413.	[bug]		GSSAPI negotiation could fail if GSS_S_CONTINUE_NEEDED
				was returned. [RT #42733]

.. code-block:: none

		--- 9.11.0b2 released ---

	4412.	[cleanup]	Make fixes for GCC 6. ISC_OFFSET_MAXIMUM macro was
				removed. [RT #42721]

	4411.	[func]		"rndc dnstap -roll" automatically rolls the
				dnstap output file; the previous version is
				saved with ".0" suffix, and earlier versions
				with ".1" and so on. An optional numeric argument
				indicates how many prior files to save. [RT #42830]

	4410.	[bug]		Address use after free and memory leak with dnstap.
				[RT #42746]

	4409.	[bug]		DNS64 should exclude mapped addresses by default when
				an exclude acl is not defined. [RT #42810]

	4408.	[func]		Continue waiting for expected response when we the
				response we get does not match the request. [RT #41026]

	4407.	[performance]	Use GCC builtin for clz in RPZ lookup code.
				[RT #42818]

	4406.	[security]	getrrsetbyname with a non absolute name could
				trigger an infinite recursion bug in lwresd
				and named with lwres configured if when combined
				with a search list entry the resulting name is
				too long. (CVE-2016-2775) [RT #42694]

	4405.	[bug]		Change 4342 introduced a regression where you could
				not remove a delegation in a NSEC3 signed zone using
				OPTOUT via nsupdate. [RT #42702]

	4404.	[misc]		Allow krb5-config to be used when configuring gssapi.
				[RT #42580]

	4403.	[bug]		Rename variables and arguments that shadow: basename,
				clone and gai_error.

	4402.	[bug]		protoc-c is now a hard requirement for --enable-dnstap.

.. code-block:: none

		--- 9.11.0b1 released ---

	4401.	[misc]		Change LICENSE to MPL 2.0.

	4400.	[bug]		ttl policy was not being inherited in policy.py.
				[RT #42718]

	4399.	[bug]		policy.py 'ECCGOST', 'ECDSAP256SHA256', and
				'ECDSAP384SHA384' don't have settable keysize.
				[RT #42718]

	4398.	[bug]		Correct spelling of ECDSAP256SHA256 in policy.py.
				[RT #42718]

	4397.	[bug]		Update Windows python support. [RT #42538]

	4396.	[func]		dnssec-keymgr now takes a '-r randomfile' option.
				[RT #42455]

	4395.	[bug]		Improve out-of-tree installation of python modules.
				[RT #42586]

	4394.	[func]		Add rndc command "dnstap-reopen" to close and
				reopen dnstap output files. [RT #41803]

	4393.	[bug]		Address potential NULL pointer dereferences in
				dnstap code.

	4392.	[func]		Collect statistics for RSSAC02v3 traffic-volume,
				traffic-sizes and rcode-volume reporting. [RT #41475]

	4391.	[contrib]	Fix leaks in contrib DLZ code. [RT #42707]

	4390.	[doc]		Description of masters with TSIG, allow-query and
				allow-transfer options in catalog zones. [RT #42692]

	4389.	[test]		Rewritten test suite for catalog zones. [RT #42676]

	4388.	[func]		Support for master entries with TSIG keys in catalog
				zones. [RT #42577]

	4387.	[bug]		Change 4336 was not complete leading to SERVFAIL
				being return as NS records expired. [RT #42683]

	4386.	[bug]		Remove shadowed overmem function/variable. [RT #42706]

	4385.	[func]		Add support for allow-query and allow-transfer ACLs
				to catalog zones. [RT #42578]

	4384.	[bug]		Change 4256 accidentally disabled logging of the
				rndc command. [RT #42654]

	4383.	[bug]		Correct spelling error in stats channel description of
				"EDNS client subnet option received". [RT #42633]

	4382.	[bug]		rndc {addzone,modzone,delzone,showzone} should all
				compare the zone name using a canonical format.
				[RT #42630]

	4381.	[bug]		Missing "zone-directory" option in catalog zone
				definition caused BIND to crash. [RT #42579]

.. code-block:: none

		--- 9.11.0a3 released ---

	4380.	[experimental]	Added a "zone-directory" option to "catalog-zones"
				syntax, allowing local masterfiles for slaves
				that are provisioned by catalog zones to be stored
				in a directory other than the server's working
				directory. [RT #42527]

	4379.	[bug]		An INSIST could be triggered if a zone contains
				RRSIG records with expiry fields that loop
				using serial number arithmetic. [RT #40571]

	4378.	[contrib]	#include <isc/string.h> for strlcat in zone2ldap.c.
				[RT #42525]

	4377.	[bug]		Don't reuse zero TTL responses beyond the current
				client set (excludes ANY/SIG/RRSIG queries).
				[RT #42142]

	4376.	[experimental]	Added support for Catalog Zones, a new method for
				provisioning secondary servers in which a list of
				zones to be served is stored in a DNS zone and can
				be propagated to slaves via AXFR/IXFR. [RT #41581]

	4375.	[func]		Add support for automatic reallocation of isc_buffer
				to isc_buffer_put* functions. [RT #42394]

	4374.	[bug]		Use SAVE/RESTORE macros in query.c to reduce the
				probability of reference counting errors as seen
				in 4365. [RT #42405]

	4373.	[bug]		Address undefined behavior in getaddrinfo. [RT #42479]

	4372.	[bug]		Address undefined behavior in libt_api. [RT #42480]

	4371.	[func]		New "minimal-any" option reduces the size of UDP
				responses for qtype ANY by returning a single
				arbitrarily selected RRset instead of all RRsets.
				Thanks to Tony Finch. [RT #41615]

	4370.	[bug]		Address python3 compatibility issues with RNDC module.
				[RT #42499] [RT #42506]

.. code-block:: none

		--- 9.11.0a2 released ---

	4369.	[bug]		Fix 'make' and 'make install' out-of-tree python
				support. [RT #42484]

	4368.	[bug]		Fix a crash when calling "rndc stats" on some
				Windows builds because some Visual Studio compilers
				generated crashing code for the "%z" printf()
				format specifier. [RT #42380]

	4367.	[bug]		Remove unnecessary assignment of loadtime in
				zone_touched. [RT #42440]

	4366.	[bug]		Address race condition when updating rbtnode bit
				fields. [RT #42379]

	4365.	[bug]		Address zone reference counting errors involving
				nxdomain-redirect. [RT #42258]

	4364.	[port]		freebsd: add -Wl,-E to loader flags [RT #41690]

	4363.	[port]		win32: Disable explicit triggering UAC when running
				BINDInstall.

	4362.	[func]		Changed rndc reconfig behavior so that newly added
				zones are loaded asynchronously and the loading does
				not block the server. [RT #41934]

	4361.	[cleanup]	Where supported, file modification times returned
				by isc_file_getmodtime() are now accurate to the
				nanosecond. [RT #41968]

	4360.	[bug]		Silence spurious 'bad key type' message when there is
				a existing TSIG key. [RT #42195]

	4359.	[bug]		Inherited 'also-notify' lists were not being checked
				by named-checkconf. [RT #42174]

	4358.	[test]		Added American Fuzzy Lop harness that allows
				feeding fuzzed packets into BIND.
				[RT #41723]

	4357.	[func]		Add the python RNDC module. [RT #42093]

	4356.	[func]		Add the ability to specify whether to wait for
				nameserver addresses to be looked up or not to
				RPZ with a new modifying directive 'nsip-wait-recurse'.
				[RT #35009]

	4355.	[func]		"pkcs11-list" now displays the extractability
				attribute of private or secret keys stored in
				an HSM, as either "true", "false", or "never"
				Thanks to Daniel Stirnimann. [RT #36557]

	4354.	[bug]		Check that the received HMAC length matches the
				expected length prior to check the contents on the
				control channel.  This prevents a OOB read error.
				This was reported by Lian Yihan, <lianyihan@360.cn>.
				[RT #42215]

	4353.	[cleanup]	Update PKCS#11 header files. [RT #42175]

	4352.	[cleanup]	The ISC DNSSEC Lookaside Validation (DLV) service
				is scheduled to be disabled in 2017.  A warning is
				now logged when named is configured to use it,
				either explicitly or via "dnssec-lookaside auto;"
				[RT #42207]

	4351.	[bug]		'dig +noignore' didn't work. [RT #42273]

	4350.	[contrib]	Declare result in  dlz_filesystem_dynamic.c.

	4349.	[contrib]	kasp2policy: A python script to create a DNSSEC
				policy file from an OpenDNSSEC KASP XML file.

	4348.	[func]		dnssec-keymgr: A new python-based DNSSEC key
				management utility, which reads a policy definition
				file and can create or update DNSSEC keys as needed
				to ensure that a zone's keys match policy, roll over
				correctly on schedule, etc.  Thanks to Sebastian
				Castro for assistance in development. [RT #39211]

	4347.	[port]		Corrected a build error on x86_64 Solaris. [RT #42150]

	4346.	[bug]		Fixed a regression introduced in change #4337 which
				caused signed domains with revoked KSKs to fail
				validation. [RT #42147]

	4345.	[contrib]	perftcpdns mishandled the return values from
				clock_nanosleep. [RT #42131]

	4344.	[port]		Address openssl version differences. [RT #42059]

	4343.	[bug]		dns_dnssec_syncupdate mis-declared in <dns/dnssec.h>.
				[RT #42090]

	4342.	[bug]		'rndc flushtree' could fail to clean the tree if there
				wasn't a node at the specified name. [RT #41846]

.. code-block:: none

		--- 9.11.0a1 released ---

	4341.	[bug]		Correct the handling of ECS options with
				address family 0. [RT #41377]

	4340.	[performance]	Implement adaptive read-write locks, reducing the
				overhead of locks that are only held briefly.
				[RT #37329]

	4339.	[test]		Use "mdig" to test pipelined queries. [RT #41929]

	4338.	[bug]		Reimplement change 4324 as it wasn't properly doing
				all the required book keeping. [RT #41941]

	4337.	[bug]		The previous change exposed a latent flaw in
				key refresh queries for managed-keys when
				a cached DNSKEY had TTL 0. [RT #41986]

	4336.	[bug]		Don't emit records with zero ttl unless the records
				were learnt with a zero ttl. [RT #41687]

	4335.	[bug]		zone->view could be detached too early. [RT #41942]

	4334.	[func]		'named -V' now reports zlib version. [RT #41913]

	4333.	[maint]		L.ROOT-SERVERS.NET is now 199.7.83.42 and
				2001:500:9f::42.

	4332.	[placeholder]

	4331.	[func]		When loading managed signed zones detect if the
				RRSIG's inception time is in the future and regenerate
				the RRSIG immediately. [RT #41808]

	4330.	[protocol]	Identify the PAD option as "PAD" when printing out
				a message.

	4329.	[func]		Warn about a common misconfiguration when forwarding
				RFC 1918 zones. [RT #41441]

	4328.	[performance]	Add dns_name_fromwire() benchmark test. [RT #41694]

	4327.	[func]		Log query and depth counters during fetches when
				querytrace (./configure --enable-querytrace) is
				enabled (helps in diagnosing).  [RT #41787]

	4326.	[protocol]	Add support for AVC. [RT #41819]

	4325.	[func]		Add a line to "rndc status" indicating the
				hostname and operating system details. [RT #41610]

	4324.	[bug]		When deleting records from a zone database, interior
				nodes could be left empty but not deleted, damaging
				search performance afterward. [RT #40997]

	4323.	[bug]		Improve HTTP header processing on statschannel.
				[RT #41674]

	4322.	[security]	Duplicate EDNS COOKIE options in a response could
				trigger an assertion failure. (CVE-2016-2088)
				[RT #41809]

	4321.	[bug]		Zones using mapped files containing out-of-zone data
				could return SERVFAIL instead of the expected NODATA
				or NXDOMAIN results. [RT #41596]

	4320.	[bug]		Insufficient memory allocation when handling
				"none" ACL could cause an assertion failure in
				named when parsing ACL configuration. [RT #41745]

	4319.	[security]	Fix resolver assertion failure due to improper
				DNAME handling when parsing fetch reply messages.
				(CVE-2016-1286) [RT #41753]

	4318.	[security]	Malformed control messages can trigger assertions
				in named and rndc. (CVE-2016-1285) [RT #41666]

	4317.	[bug]		Age all unused servers on fetch timeout. [RT #41597]

	4316.	[func]		Add option to tools to print RRs in unknown
				presentation format [RT #41595].

	4315.	[bug]		Check that configured view class isn't a meta class.
				[RT #41572].

	4314.	[contrib]	Added 'dnsperf-2.1.0.0-1', a set of performance
				testing tools provided by Nominum, Inc.

	4313.	[bug]		Handle ns_client_replace failures in test mode.
				[RT #41190]

	4312.	[bug]		dig's unknown DNS and EDNS flags (MBZ value) logging
				was not consistent. [RT #41600]

	4311.	[bug]		Prevent "rndc delzone" from being used on
				response-policy zones. [RT #41593]

	4310.	[performance]	Use __builtin_expect() where available to annotate
				conditions with known behavior. [RT #41411]

	4309.	[cleanup]	Remove the spurious "none" filename from log messages
				when processing built-in configuration. [RT #41594]

	4308.	[func]		Added operating system details to "named -V"
				output. [RT #41452]

	4307.	[bug]		"dig +subnet" and "mdig +subnet" could send
				incorrectly-formatted Client Subnet options
				if the prefix length was not divisible by 8.
				Also fixed a memory leak in "mdig". [RT #45178]

	4306.	[maint]		Added a PKCS#11 openssl patch supporting
				version 1.0.2f [RT #38312]

	4305.	[bug]		dnssec-signzone was not removing unnecessary rrsigs
				from the zone's apex. [RT #41483]

	4304.	[port]		xfer system test failed as 'tail -n +value' is not
				portable. [RT #41315]

	4303.	[bug]		"dig +subnet" was unable to send a prefix length of
				zero, as it was incorrectly changed to 32 for v4
				prefixes or 128 for v6 prefixes. In addition to
				fixing this, "dig +subnet=0" has been added as a
				short form for 0.0.0.0/0. The same changes have
				also been made in "mdig". [RT #41553]

	4302.	[port]		win32: fixed a build error in VS 2015. [RT #41426]

	4301.	[bug]		dnssec-settime -p [DP]sync was not working. [RT #41534]

	4300.	[bug]		A flag could be set in the wrong field when setting
				up non-recursive queries; this could cause the
				SERVFAIL cache to cache responses it shouldn't.
				New querytrace logging has been added which
				identified this error. [RT #41155]

	4299.	[bug]		Check that exactly totallen bytes are read when
				reading a RRset from raw files in both single read
				and incremental modes. [RT #41402]

	4298.	[bug]		dns_rpz_add errors in loadzone were not being
				propagated up the call stack. [RT #41425]

	4297.	[test]		Ensure delegations in RPZ zones fail robustly.
				[RT #41518]

	4296.	[bug]		TCP packet sizes were calculated incorrectly in the
				stats channel; they could be counted in the wrong
				histogram bucket. [RT #40587]

	4295.	[bug]		An unchecked result in dns_message_pseudosectiontotext()
				could allow incorrect text formatting of EDNS EXPIRE
				options. [RT #41437]

	4294.	[bug]		Fixed a regression in which "rndc stop -p" failed
				to print the PID. [RT #41513]

	4293.	[bug]		Address memory leak on priming query creation failure.
				[RT #41512]

	4292.	[placeholder]

	4291.	[cleanup]	Added a required include to dns/forward.h. [RT #41474]

	4290.	[func]		The timers returned by the statistics channel
				(indicating current time, server boot time, and
				most recent reconfiguration time) are now reported
				with millisecond accuracy. [RT #40082]

	4289.	[bug]		The server could crash due to memory being used
				after it was freed if a zone transfer timed out.
				[RT #41297]

	4288.	[bug]		Fixed a regression in resolver.c:possibly_mark()
				which caused known-bogus servers to be queried
				anyway. [RT #41321]

	4287.	[bug]		Silence an overly noisy log message when message
				parsing fails. [RT #41374]

	4286.	[security]	render_ecs errors were mishandled when printing out
				a OPT record resulting in a assertion failure.
				(CVE-2015-8705) [RT #41397]

	4285.	[security]	Specific APL data could trigger a INSIST.
				(CVE-2015-8704) [RT #41396]

	4284.	[bug]		Some GeoIP options were incorrectly documented
				using abbreviated forms which were not accepted by
				named.  The code has been updated to allow both
				long and abbreviated forms. [RT #41381]

	4283.	[bug]		OPENSSL_config is no longer re-callable. [RT #41348]

	4282.	[func]		'dig +[no]mapped' determine whether the use of mapped
				IPv4 addresses over IPv6 is permitted or not.  The
				default is +mapped.  [RT #41307]

	4281.	[bug]		Teach dns_message_totext about BADCOOKIE. [RT #41257]

	4280.	[performance]	Use optimal message sizes to improve compression
				in AXFRs. This reduces network traffic. [RT #40996]

	4279.	[test]		Don't use fixed ports when unit testing. [RT #41194]

	4278.	[bug]		'delv +short +[no]split[=##]' didn't work as expected.
				[RT #41238]

	4277.	[performance]	Improve performance of the RBT, the central zone
				datastructure: The aux hashtable was improved,
				hash function was updated to perform more
				uniform mapping, uppernode was added to
				dns_rbtnode, and other cleanups and performance
				improvements were made. [RT #41165]

	4276.	[protocol]	Add support for SMIMEA. [RT #40513]

	4275.	[performance]	Lazily initialize dns_compress->table only when
				compression is enabled. [RT #41189]

	4274.	[performance]	Speed up typemap processing from text. [RT #41196]

	4273.	[bug]		Only call dns_test_begin() and dns_test_end() once each
				in nsec3_test as it fails with GOST if called multiple
				times.

	4272.	[bug]		dig: the +norrcomments option didn't work with +multi.
				[RT #41234]

	4271.	[test]		Unit tests could deadlock in isc__taskmgr_pause().
				[RT #41235]

	4270.	[security]	Update allowed OpenSSL versions as named is
				potentially vulnerable to CVE-2015-3193.

	4269.	[bug]		Zones using "map" format master files currently
				don't work as policy zones.  This limitation has
				now been documented; attempting to use such zones
				in "response-policy" statements is now a
